dnl ------------------------------------------
dnl  SF_CHECK_LIB_ACE()
dnl 
dnl  Check for ACE Libraries.
dnl
dnl ------------------------------------------

AC_DEFUN([SF_CHECK_LIB_ACE],
[
   AC_MSG_CHECKING([ACE_ROOT])
   AC_ARG_WITH([acedir], [  --with-acedir=DIR        ACE installation directory [default=$ACE_ROOT]], ACE_ROOT=$withval)
   AC_MSG_RESULT([$ACE_ROOT])
   if test x"$ACE_ROOT" != x ; then
      ACE_CPPFLAGS="-I$ACE_ROOT/include"
      ACE_LDFLAGS="-L$ACE_ROOT/lib"
   else
      ACE_CPPFLAGS=""
      ACE_LDFLAGS="" 
   fi
   ACE_LIBS="-lACE"
   ORIG_CXXFLAGS="$CXXFLAGS"
   ORIG_CPPFLAGS="$CPPFLAGS"
   CXXFLAGS="$CXXFLAGS $ACE_CPPFLAGS"
   CPPFLAGS="$CPPFLAGS $ACE_CPPFLAGS"
   ORIG_LDFLAGS="$LDFLAGS"
   LDFLAGS="$LDFLAGS $ACE_LDFLAGS"
   ORIG_LIBS="$LIBS"
   LIBS="$LIBS $ACE_LIBS"
   AC_MSG_CHECKING([for compatible ACE library and headers])
   AC_LINK_IFELSE(
      [[
         #include <ace/Task.h>
         #include <ace/Thread_Manager.h>
   
         int main( int argc, char* argv[] )
         {
            ACE_Task_Base thread;
   
            thread.activate();
            thread.wait();
   
            return 0;
         }
      ]],
      [AC_MSG_RESULT(yes)],
      [
         if test x"$ACE_ROOT" != x ; then
            ACE_CPPFLAGS="-I$ACE_ROOT"
         fi
         CXXFLAGS="$CXXFLAGS $ACE_CPPFLAGS"
         CPPFLAGS="$CPPFLAGS $ACE_CPPFLAGS"
         AC_LINK_IFELSE(
            [[
               #include <ace/Task.h>
               #include <ace/Thread_Manager.h>
   
               int main( int argc, char* argv[] )
               {
                  ACE_Task_Base thread;
   
                  thread.activate();
                  thread.wait();
   
                  return 0;
               }
            ]],
            [AC_MSG_RESULT(yes)],
            [
               AC_MSG_RESULT(no)
               AC_MSG_ERROR(
                  [compatible ACE library (libACE) and/or headers not found. Use --with-acedir=DIR to indicate where ACE is installed or see http://www.cs.wustl.edu/~schmidt/ACE.html]
               )
            ]
         )
      ]
   )
   CPPFLAGS="$ORIG_CPPFLAGS"
   CXXFLAGS="$ORIG_CXXFLAGS"
   LDFLAGS="$ORIG_LDFLAGS"
   LIBS="$ORIG_LIBS"
   AC_SUBST(ACE_CPPFLAGS)
   AC_SUBST(ACE_LDFLAGS)
   AC_SUBST(ACE_LIBS)
])