dnl ------------------------------------------
dnl  SF_CHECK_LIB_ACEXML()
dnl 
dnl  Check for ACEXML and ACEXML_Parser Libraries.
dnl
dnl ------------------------------------------

AC_DEFUN([SF_CHECK_LIB_ACEXML],
[
   ACEXML_LIBS="-lACEXML -lACEXML_Parser"
   ORIG_CXXFLAGS="$CXXFLAGS"
   ORIG_CPPFLAGS="$CPPFLAGS"
   CXXFLAGS="$CXXFLAGS $ACE_CPPFLAGS"
   CPPFLAGS="$CPPFLAGS $ACE_CPPFLAGS"
   ORIG_LDFLAGS="$LDFLAGS"
   LDFLAGS="$LDFLAGS $ACE_LDFLAGS"
   ORIG_LIBS="$LIBS"
   LIBS="$LIBS $ACE_LIBS $ACEXML_LIBS"
   AC_MSG_CHECKING([for compatible ACEXML and ACEXML_Parser libraries and headers])
   AC_LINK_IFELSE(
      [[
         #include <ACEXML/parser/parser/Parser.h>
	 #include <ACEXML/common/DefaultHandler.h>
   
         int main( int argc, char* argv[] )
         {  
	    ACEXML_Parser parser;
	    ACEXML_DefaultHandler *handler;
	    ACE_NEW_RETURN(handler, ACEXML_DefaultHandler(), -1);

	    parser.setContentHandler(handler);
	    parser.setDTDHandler(handler);
	    parser.setErrorHandler(handler);
	    parser.setEntityResolver(handler);

            return 0;
         }
      ]],
      [AC_MSG_RESULT(yes)],
      [
         AC_MSG_RESULT(no)
         AC_MSG_ERROR(
            [compatible ACEXML and/or ACEXML_Parser libraries (libACEXML and/or libACEXML_Parser) and/or headers not found--see http://www.cs.wustl.edu/~schmidt/ACE.html]
         )
      ]
   )
   CPPFLAGS="$ORIG_CPPFLAGS"
   CXXFLAGS="$ORIG_CXXFLAGS"
   LDFLAGS="$ORIG_LDFLAGS"
   LIBS="$ORIG_LIBS"
   AC_SUBST(ACEXML_LIBS)
])