#include "XML_Parser.h"
#include "Log_Manager.h"

XML_Parser::XML_Parser(ACE_TString x)
{
  ACE_TRACE(ACE_TEXT("XML_Parser::XML_Parser"));
  
  xml = x;
  handler = 0;
  parse();
}

XML_Parser::~XML_Parser()
{
  ACE_TRACE(ACE_TEXT("XML_Parser::~XML_Parser"));

  delete handler;
}

int XML_Parser::parse()
{
  ACE_TRACE(ACE_TEXT("XML_Parser::parse"));

  //ACE_DEBUG((LM_DEBUG,"[XML_Parser::parse() ]\n"));
  ACEXML_Parser parser;
  ACEXML_CharStream *stm = 0;
  ACEXML_StrCharStream *sstm = 0;
  ACE_TCHAR *xmlString = (ACE_TCHAR *) xml.c_str();
  ACEXML_Char *test_string = xmlString;
  int status = 0;
  
  ACE_NEW_RETURN(sstm, ACEXML_StrCharStream, -1);
  
  if (sstm->open (test_string, ACE_TEXT ("document")) < 0)
    {
		ACE_DEBUG((ERROR_PREFIX ACE_TEXT("[ XML_Parser::parse() ] Failed to open document : %s\n"), test_string));
		return -1;
       //ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("Failed to open document : %s\n"), test_string), -1);
    }
  
  stm = sstm;
  ACEXML_InputSource input(stm);  
  ACE_NEW_RETURN(handler, XML_SaxHandler(), -1);
  
  parser.setContentHandler(handler);
  parser.setDTDHandler(handler);
  parser.setErrorHandler(handler);
  parser.setEntityResolver(handler);
  //parser.parse(&input ACEXML_ENV_ARG_PARAMETER);  
  ACEXML_TRY_EX(FIRST) {
    parser.parse(&input ACEXML_ENV_ARG_PARAMETER);
    ACEXML_TRY_CHECK_EX(FIRST);
  }
  ACEXML_CATCH(ACEXML_Exception, ex) {
    ex.print();
    ACE_DEBUG((ERROR_PREFIX ACE_TEXT("Exception occurred. Exiting...\n")));
    status = 1;
  }
  ACEXML_ENDTRY;
  
  
  return status;
}

ACE_TString XML_Parser::getInfos(ACE_TString s)
{
  ACE_TRACE(ACE_TEXT("XML_Parser::getInfos"));

  return ((XML_SaxHandler *) handler)->getInfos(s);
}
