#include "duplicator.h"

int ACE_TMAIN(int argc, ACE_TCHAR *argv[])
{
	int           error_code = 0;
	int           provider = 0;
	unsigned long block_size = 0;
	unsigned long block_count = 0;
	char          peer[64] = {0};
	char          flow_name[64] = {0};
	char	      logSeverity[10] = {0};
	int	      syslogEnabled = 0;
	int	      forwardTheLog = 0;
	char	      logFilePath[256] = {0};

	if (!TheDuplicator::instance())
	{
		ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("Duplicator : Problem on initialization\n")), -1);
	}

	if (argc != 10)
	{
		ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("Duplicator : Incorrect number of parameters\n")), -1);
	}

	ACE_OS::strncpy(flow_name,argv[1],64);

	if ((flow_name[63] != '\0') || (flow_name[0] == 0))
	{
		ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("Duplicator : Incorrect parameter (flow_name)\n")), -1);
	}

	provider = ACE_OS::atoi(argv[2]);
	
	block_size = ACE_OS::atoi(argv[3]);
	if (block_size == 0)
	{
		ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("Duplicator : Incorrect parameter (block_size)\n")), -1);
	}

	block_count = ACE_OS::atoi(argv[4]);
	if (block_count == 0)
	{
		ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("Duplicator : Incorrect parameter (block_count)\n")), -1);
	}

	ACE_OS::strncpy(peer, argv[5], 64);
	if ((peer[63] != '\0') || (peer[0] == '\0'))
	 {
		ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("Duplicator : Incorrect parameter (peer)\n")), -1);
	}

	const char *log_warning = "warning";
	const char *log_debug = "debug";
	const char *log_error = "error";
	ACE_OS::strncpy(logSeverity, argv[6], 10);
	if ( ( ACE_OS::strcmp(logSeverity, log_warning) == -1 ) && ( ACE_OS::strcmp(logSeverity, log_debug) == -1 ) && ( ACE_OS::strcmp(logSeverity, log_error) == -1 ) )
	{
		ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("Duplicator : Log Severity parameter not recognized\n")), -1);
	}

	syslogEnabled = ACE_OS::atoi(argv[7]);
	
	forwardTheLog = ACE_OS::atoi(argv[8]);

	ACE_OS::strncpy(logFilePath, argv[9], 256);

	error_code = TheDuplicator::instance()->init(flow_name, provider, block_size, block_count, peer, logSeverity, syslogEnabled, forwardTheLog, logFilePath);
	if (error_code)
	{
	  ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("Duplicator : error_code :%d"), error_code),error_code);
	}
	
    TheDuplicator::instance()->run_event_loop();
	
	return 0;
}
