#ifndef _ACCEPTOR_EVENT_HANDLER_H
#define _ACCEPTOR_EVENT_HANDLER_H

#include "ace/SString.h"
#include "ace/Event_Handler.h"
#include "ace/INET_Addr.h"
#include "ace/Reactor.h"
#include "ace/SOCK_Acceptor.h"
#include "ace/SOCK_Stream.h"

class Acceptor_Event_Handler : public ACE_Event_Handler {
 
 protected:
  // virtual ~Acceptor_Event_Handler(){}
  ACE_SOCK_Acceptor acceptor_;
   
  public :
  virtual ~Acceptor_Event_Handler(){}
  Acceptor_Event_Handler(ACE_Reactor *r = ACE_Reactor::instance()) : ACE_Event_Handler(r){}
  int open (const ACE_INET_Addr &local_addr);
  virtual int handle_input (ACE_HANDLE = ACE_INVALID_HANDLE) = 0;
  virtual int handle_close (ACE_HANDLE=ACE_INVALID_HANDLE,ACE_Reactor_Mask=0);
  virtual ACE_HANDLE get_handle() const {return acceptor_.get_handle();}
  ACE_SOCK_Acceptor &acceptor() {return acceptor_;}
  
};

class Peer_Acceptor_Event_Handler : public Acceptor_Event_Handler {
  public :
    int handle_input (ACE_HANDLE = ACE_INVALID_HANDLE);
    Peer_Acceptor_Event_Handler(ACE_Reactor *r = ACE_Reactor::instance()) : Acceptor_Event_Handler(r){}
};

class Local_Acceptor_Event_Handler : public Acceptor_Event_Handler {
  public : 
   int handle_input (ACE_HANDLE = ACE_INVALID_HANDLE);
   Local_Acceptor_Event_Handler(ACE_Reactor *r = ACE_Reactor::instance()) : Acceptor_Event_Handler(r){}
};

class Local2_Acceptor_Event_Handler : public Acceptor_Event_Handler {
  public : 
   int handle_input (ACE_HANDLE = ACE_INVALID_HANDLE);
   Local2_Acceptor_Event_Handler(ACE_Reactor *r = ACE_Reactor::instance()) : Acceptor_Event_Handler(r){}
};

class Duplicator_Acceptor_Event_Handler : public Acceptor_Event_Handler {
  public : 
   int handle_input (ACE_HANDLE = ACE_INVALID_HANDLE);
   Duplicator_Acceptor_Event_Handler(ACE_Reactor *r = ACE_Reactor::instance()) : Acceptor_Event_Handler(r){}
   //ACE_SOCK_Stream duplicator_socket;
};

#endif
