#ifndef _MULTICAST_SERVER_EVENTS_H
#define _MULTICAST_SERVER_EVENTS_H

#include "ace/ACE.h"
#include "ace/SString.h"
#include "ace/Event_Handler.h"
#include "ace/INET_Addr.h"
#include "ace/SOCK_Dgram.h"
#include "ace/SOCK_Stream.h"
#include "ace/SOCK_Connector.h"
#include "ace/SOCK_Dgram_Mcast.h"

#include "sf2d_common_ACE.h"

#include "Peer_Event_Handler.h"

#include "list/SocketList.h"
#include "list/ServerList.h"
#include "list/GlobalList.h"
#include "list/LastModifications.h"

#include "sf2d.h"

#define MULTICAST_MESSAGE    "<?xml version='1.0'?>\n<smartspace>\n	<servername>%s</servername>\n <serveros>%s</serveros>\n <applicationname>%s</applicationname>\n</smartspace>"

class MultiCast_Server_Events : public ACE_Event_Handler
{
public:
  MultiCast_Server_Events (u_short port,const char *mcast_addr);
  MultiCast_Server_Events (u_short port,const char *mcast_addr, ACE_TCHAR *application_name);
  ~MultiCast_Server_Events (void);
  virtual int handle_input (ACE_HANDLE fd); 
  virtual int open(void); 
  virtual ACE_HANDLE get_handle (void) const;
  int welcome_to_multicast_group(void);
  ACE_TString add_server_message(ACE_TString name_, ACE_TString os_);
  ACE_TString remove_serverxml(ACE_TString name_);

private:
  ACE_SOCK_Dgram_Mcast mcast_dgram_;   
  ACE_INET_Addr remote_addr_;
  ACE_INET_Addr mcast_addr_;    
  ACE_INET_Addr local_addr_;
  ACE_SOCK_Dgram dgram_;
  char mcast_info[256];
  ACE_TCHAR application_name_[512];
};

#endif
