#include "Client.h"
#include "../Log_Manager.h"

Client::Client(ACE_TString group_, ACE_TString name_)
{
	ACE_TRACE(ACE_TEXT("Client::Client(ACE_TString group_, ACE_TString name_)"));
	init(group_, name_);
}

Client::Client(ACE_TString xml_)
{
	ACE_TRACE(ACE_TEXT("Client::Client(ACE_TString xml_)"));
	init(xml_);
}

Client::~Client()
{
	ACE_TRACE(ACE_TEXT("Client::~Client"));
	fini();
}

int Client::init(ACE_TString group_, ACE_TString name_)
{
	ACE_TRACE(ACE_TEXT("Client::init(ACE_TString group_, ACE_TString name_)"));

	id = Client::getIDFromGroupAndName(group_, name_);
	group = group_;
	name = name_;

	return 0;
}

int Client::init(ACE_TString xml_)
{
	ACE_TRACE(ACE_TEXT("Client::init(ACE_TString xml_)"));
	
	int pos;
	ACE_TString idXml;
	ACE_TString groupXml;
	ACE_TString nameXml;
	ACE_TString descriptionXml;
	ACE_TString serverXml;
	ACE_TString paramsXml;
	ACE_TString pathXml;
	ACE_TString flowInfoXml;
	
	// <Client> tag
	
	pos = xml_.strstr(ACE_TEXT("<Client ID=\""));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Client::fromXml ] ERROR: Parse error, <Client> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Client::fromXml ] ERROR: Parse error, <Client> tag not found\n")), -1);
	}
	else
	{
		xml_ = xml_.substr(pos + 12);
	}

	pos = xml_.strstr(ACE_TEXT("\">"));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Client::fromXml ] ERROR: Parse error, ending of <Client> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Client::fromXml ] ERROR: Parse error, ending of <Client> tag not found\n")), -1);
	}
	else
	{
		idXml = xml_.substr(0, pos);
		xml_ = xml_.substr(pos + 2);
	}
	
	// Group tag
	
	pos = xml_.strstr(ACE_TEXT("<Group>"));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Client::fromXml ] ERROR: Parse error, <Group> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Client::fromXml ] ERROR: Parse error, <Group> tag not found\n")), -1);
	}
	else
	{
		xml_ = xml_.substr(pos + 7);
	}

	pos = xml_.strstr(ACE_TEXT("</Group>"));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Client::fromXml ] ERROR: Parse error, </Group> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Client::fromXml ] ERROR: Parse error, </Group> tag not found\n")), -1);
	}
	else
	{
		groupXml = xml_.substr(0, pos);
		xml_ = xml_.substr(pos + 8);
	}

	// Name tag
	
	pos = xml_.strstr(ACE_TEXT("<Name>"));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Client::fromXml ] ERROR: Parse error, <Name> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Client::fromXml ] ERROR: Parse error, <Name> tag not found\n")), -1);
	}
	else
	{
		xml_ = xml_.substr(pos + 6);
	}

	pos = xml_.strstr(ACE_TEXT("</Name>"));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Client::fromXml ] ERROR: Parse error, </Name> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Client::fromXml ] ERROR: Parse error, </Name> tag not found\n")), -1);
	}
	else
	{
		nameXml = xml_.substr(0, pos);
		xml_ = xml_.substr(pos + 7);
	}

	// Description tag
	
	pos = xml_.strstr(ACE_TEXT("<Description>"));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Client::fromXml ] ERROR: Parse error, <Description> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Client::fromXml ] ERROR: Parse error, <Description> tag not found\n")), -1);
	}
	else
	{
		xml_ = xml_.substr(pos + 13);
	}

	pos = xml_.strstr(ACE_TEXT("</Description>"));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Client::fromXml ] ERROR: Parse error, </Description> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Client::fromXml ] ERROR: Parse error, </Description> tag not found\n")), -1);
	}
	else
	{
		descriptionXml = xml_.substr(0, pos);
		xml_ = xml_.substr(pos + 14);
	}

	// Server tag
	
	pos = xml_.strstr(ACE_TEXT("<Server>"));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Client::fromXml ] ERROR: Parse error, <Server> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Client::fromXml ] ERROR: Parse error, <Server> tag not found\n")), -1);
	}
	else
	{
		xml_ = xml_.substr(pos + 8);
	}

	pos = xml_.strstr(ACE_TEXT("</Server>"));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Client::fromXml ] ERROR: Parse error, </Server> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Client::fromXml ] ERROR: Parse error, </Server> tag not found\n")), -1);
	}
	else
	{
		serverXml = xml_.substr(0, pos);
		xml_ = xml_.substr(pos + 9);
	}

	// Params tag
	
	pos = xml_.strstr(ACE_TEXT("<Params>"));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Client::fromXml ] ERROR: Parse error, <Params> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Client::fromXml ] ERROR: Parse error, <Params> tag not found\n")), -1);
	}
	else
	{
		xml_ = xml_.substr(pos + 8);
	}

	pos = xml_.strstr(ACE_TEXT("</Params>"));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Client::fromXml ] ERROR: Parse error, </Params> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Client::fromXml ] ERROR: Parse error, </Params> tag not found\n")), -1);
	}
	else
	{
		paramsXml = xml_.substr(0, pos);
		xml_ = xml_.substr(pos + 9);
	}

	// Path tag
	
	pos = xml_.strstr(ACE_TEXT("<Path>"));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Client::fromXml ] ERROR: Parse error, <Path> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Client::fromXml ] ERROR: Parse error, <Path> tag not found\n")), -1);
	}
	else
	{
		xml_ = xml_.substr(pos + 6);
	}

	pos = xml_.strstr(ACE_TEXT("</Path>"));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Client::fromXml ] ERROR: Parse error, </Path> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Client::fromXml ] ERROR: Parse error, </Path> tag not found\n")), -1);
	}
	else
	{
		pathXml = xml_.substr(0, pos);
		xml_ = xml_.substr(pos + 7);
	}

	// FlowInfo tag
	
	pos = xml_.strstr(ACE_TEXT("<FlowInfo>"));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Client::fromXml ] ERROR: Parse error, <FlowInfo> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Client::fromXml ] ERROR: Parse error, <FlowInfo> tag not found\n")), -1);
	}
	else
	{
		xml_ = xml_.substr(pos + 10);
	}

	pos = xml_.strstr(ACE_TEXT("</FlowInfo>"));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Client::fromXml ] ERROR: Parse error, </FlowInfo> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Client::fromXml ] ERROR: Parse error, </FlowInfo> tag not found\n")), -1);
	}
	else
	{
		flowInfoXml = xml_.substr(0, pos);
		xml_ = xml_.substr(pos + 11);
	}

	// </Client> tag
	
	pos = xml_.strstr(ACE_TEXT("</Client>"));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Client::fromXml ] ERROR: Parse error, </Client> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Client::fromXml ] ERROR: Parse error, </Client> tag not found\n")), -1);
	}

	ACE_ASSERT(idXml.compare(Client::getIDFromGroupAndName(groupXml, nameXml)) == 0);

	init(groupXml, nameXml);
	setDescription(descriptionXml);
	setServer(serverXml);
	setParams(paramsXml);
	setPath(pathXml);
	setFlowInfo(flowInfoXml);
	
	return 0;
}

int Client::fini()
{
	ACE_TRACE(ACE_TEXT("Client::fini"));
	
	return 0;
}

ACE_TString Client::getIDFromGroupAndName(ACE_TString group_, ACE_TString name_)
{
	ACE_TRACE(ACE_TEXT("Client::getIDFromGroupAndName"));
	
	ACE_TString id = group_ + ACE_TEXT(":") + name_;
	
	return id;
}

int Client::setDescription(ACE_TString description_)
{
	ACE_TRACE(ACE_TEXT("Client::setDescription"));
	
	description = description_;
	
	return 0;
}

int Client::setServer(ACE_TString server_)
{
	ACE_TRACE(ACE_TEXT("Client::setServer"));
	
	server = server_;
	
	return 0;
}

int Client::setPath(ACE_TString path_)
{
	ACE_TRACE(ACE_TEXT("Client::setPath"));
	
	path = path_;
	
	return 0;
}

int Client::setParams(ACE_TString params_)
{
	ACE_TRACE(ACE_TEXT("Client::setParams"));

	params = params_;
	
	return 0;
}

int Client::setFlowInfo(ACE_TString flowinfo_)
{
	ACE_TRACE(ACE_TEXT("Client::setFlowInfo"));

	flowinfo = flowinfo_;
	
	return 0;
}

ACE_TString Client::getID()
{
	ACE_TRACE(ACE_TEXT("Client::getID"));
	
	return id;
}

ACE_TString Client::getGroup()
{
	ACE_TRACE(ACE_TEXT("Client::getGroup"));
	
	return group;
}

ACE_TString Client::getName()
{
	ACE_TRACE(ACE_TEXT("Client::getName"));
	
	return name;
}

ACE_TString Client::getDescription()
{
	ACE_TRACE(ACE_TEXT("Client::getDescription"));
	
	return description;
}

ACE_TString Client::getServer()
{
	ACE_TRACE(ACE_TEXT("Client::getServer"));
	
	return server;
}

ACE_TString Client::getPath()
{
	ACE_TRACE(ACE_TEXT("Client::getPath"));
	
	return path;
}

ACE_TString Client::getParams()
{
	ACE_TRACE(ACE_TEXT("Client::getParams"));
	
	return params;
}

ACE_TString Client::getFlowInfo()
{
	ACE_TRACE(ACE_TEXT("Client::getFlowInfo"));
	
	return flowinfo;
}

ACE_TString Client::toXmlWithIndent(int n_)
{
	ACE_TRACE(ACE_TEXT("Client::toXmlWithIndent"));
	
	if (n_ < 0 || n_ > 255)
	{
		ACE_ERROR((LM_ERROR, ACE_TEXT("[ Client::toXmlWithIndent ] ERROR: indent lower than 0 or greater than 255\n")));
	}

	ACE_TString unit = ACE_TEXT("    ");
	ACE_TString indent = ACE_TEXT("");
	
	for (int i = 0; i < n_; i++)
	{
		indent += unit;
	}	

	ACE_TString xml = ACE_TEXT("");
	
	xml += indent;
	xml += ACE_TEXT("<Client ID=\"");
	xml += getID();
	xml += ACE_TEXT("\">\n");

	xml += indent;
	xml += unit;
	xml += ACE_TEXT("<Group>");
	xml += getGroup();
	xml += ACE_TEXT("</Group>\n");
	
	xml += indent;
	xml += unit;
	xml += ACE_TEXT("<Name>");
	xml += getName();
	xml += ACE_TEXT("</Name>\n");

	xml += indent;
	xml += unit;
	xml += ACE_TEXT("<Description>");
	xml += getDescription();
	xml += ACE_TEXT("</Description>\n");

	xml += indent;
	xml += unit;
	xml += ACE_TEXT("<Server>");
	xml += getServer();
	xml += ACE_TEXT("</Server>\n");

	xml += indent;
	xml += unit;
	xml += ACE_TEXT("<Params>");
	xml += getParams();
	xml += ACE_TEXT("</Params>\n");

	xml += indent;
	xml += unit;
	xml += ACE_TEXT("<Path>");
	xml += getPath();
	xml += ACE_TEXT("</Path>\n");

	xml += indent;
	xml += unit;
	xml += ACE_TEXT("<FlowInfo>");
	xml += getFlowInfo();
	xml += ACE_TEXT("</FlowInfo>\n");

	xml += indent;
	xml += ACE_TEXT("</Client>\n");
	
	return xml;
}

ACE_TString Client::toXml()
{
	ACE_TRACE(ACE_TEXT("Client::toXml"));
	
	return toXmlWithIndent(0);
}

int Client::addModifications(ACE_TString modif_)
{
	ACE_TRACE(ACE_TEXT("Client::addModifications"));
	modifications.enqueue_tail(modif_);		
	return 0;
}

int Client::clear()
{
	ACE_TRACE(ACE_TEXT("Client::clear"));	
	modifications.reset();
	return 0;
}
