#include "Flow.h"
#include "GlobalList.h"
#include "../Log_Manager.h"

#include <set>

Flow::Flow(ACE_TString group_, ACE_TString type_)
{	
	ACE_TRACE(ACE_TEXT("Flow::Flow"));
	init(group_, type_);
}

Flow::Flow(ACE_TString xml_)
{
	ACE_TRACE(ACE_TEXT("Flow::Flow"));
	init(xml_);
}

Flow::~Flow()
{
	ACE_TRACE(ACE_TEXT("Flow::~Flow"));
	fini();
}

int Flow::init(ACE_TString group_, ACE_TString type_)
{
	ACE_TRACE(ACE_TEXT("Flow::init"));

	if (group_ == ACE_TEXT(""))
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::init ] ERROR: the group of the flow is empty\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::init ] ERROR: the group of the flow is empty\n")), -1);
	}
	
	if (type_ == ACE_TEXT(""))
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::init ] ERROR: the type of the flow is empty\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::init ] ERROR: the type of the flow is empty\n")), -1);
	}

	id = Flow::getIDFromGroupAndType(group_, type_);
	group = group_;
	type = type_;
	setStatus(FLOW_STATUS_UNKNOWN);
	setProducerStatus(CLIENT_STATUS_UNKNOWN);
	setNumberOfExpectedConsumers(0);
	
	CONSUMER_LIST consumerList;
	
	return 0;
}
//Update OK
int Flow::init(ACE_TString xml_)
{
	ACE_TRACE(ACE_TEXT("Flow::init"));

	int pos, pos2;
	ACE_TString idXml;
	ACE_TString groupXml;
	ACE_TString typeXml;
	ACE_TString nameXml;
	ACE_TString descriptionXml;
	u_short portNumberXml;
	u_short blockSizeXml;
	u_short blockCountXml;
	FlowStatus statusXml;
	ACE_TString producerIDXml;
	ClientStatus producerStatusXml;
	ACE_TString serverProducerIDXml;
	CONSUMER_LIST consumerListXml;
	ACE_TString consumerIDXml;
	ClientInfo *clientInfoXml;
	
	// <Flow> tag
	
	pos = xml_.strstr(ACE_TEXT("<Flow ID=\""));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Client::fromXml ] ERROR: Parse error, <Flow> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Client::fromXml ] ERROR: Parse error, <Flow> tag not found\n")), -1);
	}
	else
	{
		xml_ = xml_.substr(pos + 10);
	}

	pos = xml_.strstr(ACE_TEXT("\">"));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Client::fromXml ] ERROR: Parse error, ending of <Flow> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Client::fromXml ] ERROR: Parse error, ending of <Flow> tag not found\n")), -1);
	}
	else
	{
		idXml = xml_.substr(0, pos);
		xml_ = xml_.substr(pos + 2);
	}

	// Group tag
	
	pos = xml_.strstr(ACE_TEXT("<Group>"));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, <Group> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, <Group> tag not found\n")), -1);
	}
	else
	{
		xml_ = xml_.substr(pos + 7);
	}

	pos = xml_.strstr(ACE_TEXT("</Group>"));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, </Group> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, </Group> tag not found\n")), -1);
	}
	else
	{
		groupXml = xml_.substr(0, pos);
		xml_ = xml_.substr(pos + 8);
	}

	// Type tag
	
	pos = xml_.strstr(ACE_TEXT("<Type>"));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, <Type> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, <Type> tag not found\n")), -1);
	}
	else
	{
		xml_ = xml_.substr(pos + 6);
	}

	pos = xml_.strstr(ACE_TEXT("</Type>"));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, </Type> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, </Type> tag not found\n")), -1);
	}
	else
	{
		typeXml = xml_.substr(0, pos);
		xml_ = xml_.substr(pos + 7);
	}
	
	// Name tag
	
	pos = xml_.strstr(ACE_TEXT("<Name>"));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, <Name> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, <Name> tag not found\n")), -1);
	}
	else
	{
		xml_ = xml_.substr(pos + 6);
	}

	pos = xml_.strstr(ACE_TEXT("</Name>"));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, </Name> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, </Name> tag not found\n")), -1);
	}
	else
	{
		nameXml = xml_.substr(0, pos);
		xml_ = xml_.substr(pos + 7);
	}

	// Description tag
	
	pos = xml_.strstr(ACE_TEXT("<Description>"));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, <Description> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, <Description> tag not found\n")), -1);
	}
	else
	{
		xml_ = xml_.substr(pos + 13);
	}

	pos = xml_.strstr(ACE_TEXT("</Description>"));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, </Description> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, </Description> tag not found\n")), -1);
	}
	else
	{
		descriptionXml = xml_.substr(0, pos);
		xml_ = xml_.substr(pos + 14);
	}

	// PortNumber tag
	
	pos = xml_.strstr(ACE_TEXT("<PortNumber>"));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, <PortNumber> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, <PortNumber> tag not found\n")), -1);
	}
	else
	{
		xml_ = xml_.substr(pos + 12);
	}

	pos = xml_.strstr(ACE_TEXT("</PortNumber>"));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, </PortNumber> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, </PortNumber> tag not found\n")), -1);
	}
	else
	{
		portNumberXml = ACE_OS::atoi(xml_.substr(0, pos).c_str());
		xml_ = xml_.substr(pos + 13);
	}

	// BlockSize tag
	
	pos = xml_.strstr(ACE_TEXT("<BlockSize>"));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, <BlockSize> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, <BlockSize> tag not found\n")), -1);
	}
	else
	{
		xml_ = xml_.substr(pos + 11);
	}

	pos = xml_.strstr(ACE_TEXT("</BlockSize>"));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, </BlockSize> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, </BlockSize> tag not found\n")), -1);
	}
	else
	{
		blockSizeXml = ACE_OS::atoi(xml_.substr(0, pos).c_str());
		xml_ = xml_.substr(pos + 12);
	}

	// BlockCount tag
	
	pos = xml_.strstr(ACE_TEXT("<BlockCount>"));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, <BlockCount> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, <BlockCount> tag not found\n")), -1);
	}
	else
	{
		xml_ = xml_.substr(pos + 12);
	}

	pos = xml_.strstr(ACE_TEXT("</BlockCount>"));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, </BlockCount> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, </BlockCount> tag not found\n")), -1);
	}
	else
	{
		blockCountXml = ACE_OS::atoi(xml_.substr(0, pos).c_str());
		xml_ = xml_.substr(pos + 13);
	}

	// Status tag
	
	pos = xml_.strstr(ACE_TEXT("<Status>"));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, <Status> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, <Status> tag not found\n")), -1);
	}
	else
	{
		xml_ = xml_.substr(pos + 8);
	}

	pos = xml_.strstr(ACE_TEXT("</Status>"));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, </Status> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, </Status> tag not found\n")), -1);
	}
	else
	{
		statusXml = (FlowStatus) ACE_OS::atoi(xml_.substr(0, pos).c_str());
		xml_ = xml_.substr(pos + 9);
	}

	// Producer tag
	
	pos = xml_.strstr(ACE_TEXT("<Producer RefID=\""));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, <Producer> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, <Producer> tag not found\n")), -1);
	}
	else
	{
		xml_ = xml_.substr(pos + 17);
	}

	pos = xml_.strstr(ACE_TEXT("\" Status=\""));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, Status attribute of <Producer> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, Status attribute of <Producer> tag not found\n")), -1);
	}
	else
	{
		producerIDXml = xml_.substr(0, pos);
		xml_ = xml_.substr(pos + 10);
	}

	pos = xml_.strstr(ACE_TEXT("\" />"));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, end of <Producer> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, end of <Producer> tag not found\n")), -1);
	}
	else
	{
		producerStatusXml = (ClientStatus) ACE_OS::atoi(xml_.substr(0, pos).c_str());
		xml_ = xml_.substr(pos + 4);
	}

	// ServerProducerID tag
	
	pos = xml_.strstr(ACE_TEXT("<ServerProducerID>"));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, <ServerProducerID> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, <ServerProducerID> tag not found\n")), -1);
	}
	else
	{
		xml_ = xml_.substr(pos + 18);
	}

	pos = xml_.strstr(ACE_TEXT("</ServerProducerID>"));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, </ServerProducerID> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, </ServerProducerID> tag not found\n")), -1);
	}
	else
	{
		serverProducerIDXml = xml_.substr(0, pos).c_str();
		xml_ = xml_.substr(pos + 19);
	}

	// ConsumerList tag
	
	pos = xml_.strstr(ACE_TEXT("<ConsumerList>"));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, <ConsumerList> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, <ConsumerList> tag not found\n")), -1);
	}
	else
	{
		xml_ = xml_.substr(pos + 14);
	}

	// Process all Consumers

	pos = xml_.strstr(ACE_TEXT("<Consumer RefID=\""));
	while (pos != -1)
	{
	    clientInfoXml = new ClientInfo;
		xml_ = xml_.substr(pos + 17);
	
		pos2 = xml_.strstr(ACE_TEXT("\" Status=\""));
		if (pos2 == -1)
		{
			ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, Status attribute of <Consumer> tag not found\n")));
			return -1;
			//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, Status attribute of <Consumer> tag not found\n")), -1);
		}
		else
		{
			consumerIDXml = xml_.substr(0, pos2);
			xml_ = xml_.substr(pos2 + 10);
		}

		pos2 = xml_.strstr(ACE_TEXT("\" GivenFlowName=\""));
		if (pos2 == -1)
		{
			ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, GivenFlowName attribute of <Consumer> tag not found\n")));
			return -1;
			//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, Status attribute of <Consumer> tag not found\n")), -1);
		}
		else
		{
		        clientInfoXml->status = (ClientStatus) ACE_OS::atoi(xml_.substr(0, pos2).c_str());
				xml_ = xml_.substr(pos2 + 17);
		}

		pos2 = xml_.strstr(ACE_TEXT("\" ConnectionToDuplicatorSuccessful=\""));
		if (pos2 == -1)
		{
			ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, ConnectionToDuplicatorSuccessful attribute of <Consumer> tag not found\n")));
			return -1;
			//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, Status attribute of <Consumer> tag not found\n")), -1);
		}
		else
		{
		        clientInfoXml->givenFlowName = xml_.substr(0, pos2);
				xml_ = xml_.substr(pos2 + 36);
		}

		pos2 = xml_.strstr(ACE_TEXT("\" />"));
		if (pos2 == -1)
		{
			ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, end of <Consumer> tag not found\n")));
			return -1;
			//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, end of <Consumer> tag not found\n")), -1);
		}
		else
		{
			clientInfoXml->connectionToDuplicatorValidated = ACE_OS::atoi(xml_.substr(0, pos2).c_str());
			xml_ = xml_.substr(pos2 + 4);
		}

		consumerListXml.trybind(consumerIDXml, clientInfoXml);

		pos = xml_.strstr(ACE_TEXT("<Consumer RefID=\""));
	}

	pos = xml_.strstr(ACE_TEXT("</ConsumerList>"));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, </ConsumerList> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, </ConsumerList> tag not found\n")), -1);
	}
	else
	{
		xml_ = xml_.substr(pos + 15);
	}

	// </Flow> tag
	
	pos = xml_.strstr(ACE_TEXT("</Flow>"));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, </Flow> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, </Flow> tag not found\n")), -1);
	}

	ACE_ASSERT(idXml.compare(Flow::getIDFromGroupAndType(groupXml, typeXml)) == 0);

	init(groupXml, typeXml);
	
	setName(nameXml);
	setDescription(descriptionXml);
	setPortNumber(portNumberXml);
	setBlockSize(blockSizeXml);
	setBlockCount(blockCountXml);
	setStatus(statusXml);
	setProducer(producerIDXml);
	setProducerStatus(producerStatusXml);
	setServerProducerID(serverProducerIDXml);

	
	for (CONSUMER_ITERATOR ci = consumerListXml.begin(); ci != consumerListXml.end(); ci++)
	{
		addConsumer(Flow::getConsumerIDFromIterator(ci), Flow::getConsumerGivenFlowNameFromIterator(ci));
		setConsumerStatus(Flow::getConsumerIDFromIterator(ci), Flow::getConsumerStatusFromIterator(ci));
		setConsumerConnectionToDuplicatorVerified(Flow::getConsumerIDFromIterator(ci), isConsumerConnectionToDuplicatorVerifiedFromIterator(ci));
	}

	return 0;
}

	    
int Flow::updateProducer(ACE_TString flowXML_) {

  	ACE_TRACE(ACE_TEXT("Flow::updateProducer"));

	int pos;
	ACE_TString flowID_;
		
	// We parse the client parameter in order to find the flow ID
	
	pos = flowXML_.strstr(ACE_TEXT("<Flow ID=\""));
	if (pos == -1) 
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ FlowList::updateProducer ] ERROR: Parse error, <Flow> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ FlowList::updateProducer ] ERROR: Parse error, <Flow> tag not found\n")), -1);
	}
	else 
	{
		flowXML_ = flowXML_.substr(pos + 10);
	}

	pos = flowXML_.strstr(ACE_TEXT("\">"));
	if (pos == -1) 
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ FlowList::updateProducer ] ERROR: Parse error, ending of <Flow> tag not found\n")));
		return -1;	
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ FlowList::updateProducer ] ERROR: Parse error, ending of <Flow> tag not found\n")), -1);
	}
	else {
		flowID_ = flowXML_.substr(0, pos);
	}

	// Is it the good flow?
	
	if (flowID_ != getID()) {
	  ACE_DEBUG((SF2D_DEBUG_PREFIX ACE_TEXT("[ Flow::updateProducer ] This flow is not the good to update does not contain flow\n")));
		return -1;
	}
	
    // We must parse and update the information regarding the producer

	ACE_TString producerIDXml;
	ClientStatus producerStatusXml;
	ACE_TString serverProducerIDXml;
	
	pos = flowXML_.strstr(ACE_TEXT("<Producer RefID=\""));
	if (pos == -1) 
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::updateProducer ] ERROR: Parse error, <Producer> tag not found\n")));
		return -1;	
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::updateProducer ] ERROR: Parse error, <Producer> tag not found\n")), -1);
	}
	else {
		flowXML_ = flowXML_.substr(pos + 17);
	}
	  
	pos = flowXML_.strstr(ACE_TEXT("\" Status=\""));
	if (pos == -1) 
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::updateProducer ] ERROR: Parse error, Status attribute of <Producer> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::updateProducer ] ERROR: Parse error, Status attribute of <Producer> tag not found\n")), -1);
	}
	else {
	    producerIDXml = flowXML_.substr(0, pos);
		flowXML_ = flowXML_.substr(pos + 10);
	}
	  
	pos = flowXML_.strstr(ACE_TEXT("\" />"));
	if (pos == -1) 
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::updateProducer ] ERROR: Parse error, end of <Producer> tag not found\n")));
		return -1;
	    //ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::updateProducer ] ERROR: Parse error, end of <Producer> tag not found\n")), -1);
	}
	else {
	    producerStatusXml = (ClientStatus) ACE_OS::atoi(flowXML_.substr(0, pos).c_str());
		flowXML_ = flowXML_.substr(pos + 4);
	}
	
	// ServerProducerID tag
	
	pos = flowXML_.strstr(ACE_TEXT("<ServerProducerID>"));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, <ServerProducerID> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, <ServerProducerID> tag not found\n")), -1);
	}
	else
	{
		flowXML_ = flowXML_.substr(pos + 18);
	}

	pos = flowXML_.strstr(ACE_TEXT("</ServerProducerID>"));
	if (pos == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, </ServerProducerID> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, </ServerProducerID> tag not found\n")), -1);
	}
	else
	{
		serverProducerIDXml = flowXML_.substr(0, pos).c_str();
		flowXML_ = flowXML_.substr(pos + 19);
	}

	setProducer(producerIDXml);
	setProducerStatus(producerStatusXml);
	setServerProducerID(serverProducerIDXml);
		
	return 0;
}

//need to be updated for connectionValidation
int Flow::updateConsumers(ACE_TString flowXML_) {

  	ACE_TRACE(ACE_TEXT("Flow::updateConsumers"));

	int pos, pos2;
	ACE_TString flowID_;
		
	// We parse the client parameter in order to find the flow ID
	
	pos = flowXML_.strstr(ACE_TEXT("<Flow ID=\""));
	if (pos == -1) \
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ FlowList::update ] ERROR: Parse error, <Flow> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ FlowList::update ] ERROR: Parse error, <Flow> tag not found\n")), -1);
	}
	else {
		flowXML_ = flowXML_.substr(pos + 10);
	}

	pos = flowXML_.strstr(ACE_TEXT("\">"));
	if (pos == -1) 
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ FlowList::update ] ERROR: Parse error, ending of <Flow> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ FlowList::update ] ERROR: Parse error, ending of <Flow> tag not found\n")), -1);
	}
	else {
		flowID_ = flowXML_.substr(0, pos);
	}

	// Is it the good flow?
	
	if (flowID_ != getID()) {
	  ACE_DEBUG((SF2D_DEBUG_PREFIX ACE_TEXT("[ Flow::update ] This flow is not the good to update does not contain flow\n")));
		return -1;
	}
	
    // We must parse and update the information regarding the consumers
	CONSUMER_LIST consumerListXml;
	ACE_TString consumerIDXml;
	ClientInfo *clientInfoXml = new ClientInfo;

	pos = flowXML_.strstr(ACE_TEXT("<ConsumerList>"));
	if (pos == -1) 
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::update ] ERROR: Parse error, <ConsumerList> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::update ] ERROR: Parse error, <ConsumerList> tag not found\n")), -1);
	}
	else {
	    flowXML_ = flowXML_.substr(pos + 14);
	}

	// Process all Consumers

	pos = flowXML_.strstr(ACE_TEXT("<Consumer RefID=\""));
	while (pos != -1) {
		flowXML_ = flowXML_.substr(pos + 17);
	
	    pos2 = flowXML_.strstr(ACE_TEXT("\" Status=\""));
	    if (pos2 == -1) 
		{
			ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::update ] ERROR: Parse error, Status attribute of <Consumer> tag not found\n")));
			return -1;	    
			//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::update ] ERROR: Parse error, Status attribute of <Consumer> tag not found\n")), -1);
	    }
	    else {
	      consumerIDXml = flowXML_.substr(0, pos2);
	      flowXML_ = flowXML_.substr(pos2 + 10);
	    }

		pos2 = flowXML_.strstr(ACE_TEXT("\" GivenFlowName=\""));
		if (pos2 == -1)
		{
			ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, GivenFlowName attribute of <Consumer> tag not found\n")));
			return -1;
			//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, GivenFlowName attribute of <Consumer> tag not found\n")), -1);
		}
		else
		{
		        clientInfoXml->status = (ClientStatus) ACE_OS::atoi(flowXML_.substr(0, pos2).c_str());
				flowXML_ = flowXML_.substr(pos2 + 17);
		}

		pos2 = flowXML_.strstr(ACE_TEXT("\" ConnectionToDuplicatorSuccessful=\""));
		if (pos2 == -1)
		{
			ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, ConnectionToDuplicatorSuccessful attribute of <Consumer> tag not found\n")));
			return -1;
			//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, ConnectionToDuplicatorSuccessful attribute of <Consumer> tag not found\n")), -1);
		}
		else
		{
		        clientInfoXml->givenFlowName = flowXML_.substr(0, pos2);
				flowXML_ = flowXML_.substr(pos2 + 36);
		}

		pos2 = flowXML_.strstr(ACE_TEXT("\" />"));
		if (pos2 == -1)
		{
			ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, end of <Consumer> tag not found\n")));
			return -1;
			//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, end of <Consumer> tag not found\n")), -1);
		}
		else
		{
			clientInfoXml->connectionToDuplicatorValidated = ACE_OS::atoi(flowXML_.substr(0, pos2).c_str());
			flowXML_ = flowXML_.substr(pos2 + 4);
		}

	    consumerListXml.trybind(consumerIDXml, clientInfoXml);

	    pos = flowXML_.strstr(ACE_TEXT("<Consumer RefID=\""));
	}

	pos = flowXML_.strstr(ACE_TEXT("</ConsumerList>"));
	if (pos == -1) 
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, </ConsumerList> tag not found\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::fromXml ] ERROR: Parse error, </ConsumerList> tag not found\n")), -1);
	}
	else {
	    flowXML_ = flowXML_.substr(pos + 15);
	}

	for (CONSUMER_ITERATOR ci = consumerListXml.begin(); ci != consumerListXml.end(); ci++) {
		addConsumer(Flow::getConsumerIDFromIterator(ci), Flow::getConsumerGivenFlowNameFromIterator(ci));
	    setConsumerStatus(Flow::getConsumerIDFromIterator(ci), Flow::getConsumerStatusFromIterator(ci));
		setConsumerConnectionToDuplicatorVerified(Flow::getConsumerIDFromIterator(ci), isConsumerConnectionToDuplicatorVerifiedFromIterator(ci));
	}
	
	return 0;
}

int Flow::fini()
{
	return 0;
}

ACE_TString Flow::getIDFromGroupAndType(ACE_TString group_, ACE_TString type_)
{
	ACE_TRACE(ACE_TEXT("Client::getIDFromGroupAndType"));
	
	ACE_TString id = group_ + ACE_TEXT(":") + type_;
	
	return id;
}

int Flow::setName(ACE_TString name_)
{
	ACE_TRACE(ACE_TEXT("Flow::setName"));

	if (name_ == ACE_TEXT(""))
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::setName ] ERROR: the name of the flow is empty\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::setName ] ERROR: the name of the flow is empty\n")), -1);
	}
		
	name = name_;
	
	return 0;
}

int Flow::setDescription(ACE_TString description_)
{
	ACE_TRACE(ACE_TEXT("Flow::setDescription"));
	
	description = description_;
	
	return 0;
}

int Flow::setPortNumber(u_short portNumber_)
{
	ACE_TRACE(ACE_TEXT("Flow::setPortNumber"));
	
	portNumber = portNumber_;
	
	return 0;
}

int Flow::setBlockSize(u_short blockSize_)
{
	ACE_TRACE(ACE_TEXT("Flow::setBlockSize"));

	blockSize = blockSize_;
	
	return 0;
}

int Flow::setBlockCount(u_short blockCount_)
{
	ACE_TRACE(ACE_TEXT("Flow::setBlockCount"));
	
	blockCount = blockCount_;
	
	return 0;
}

int Flow::setStatus(FlowStatus flowStatus_)
{
	ACE_TRACE(ACE_TEXT("Flow::setStatus"));
	
	ACE_DEBUG((SF2D_DEBUG_PREFIX ACE_TEXT("[ Flow::setStatus ] Flow: %s - FlowStatus: %d\n"), getID().c_str(), flowStatus_));
	
	status = flowStatus_;
	
	return 0;
}

int Flow::setNumberOfExpectedConsumers(unsigned int nbConsumersExpected_)
{
	ACE_TRACE(ACE_TEXT("Flow::setNumberOfExpectedConsumers"));

	nbConsumersExpected = nbConsumersExpected_;
	return 0;
}

int Flow::setNumberOfRemoteConsumersConnectedToLocalDuplicator(unsigned int nbRemoteConsumers) {

	ACE_TRACE(ACE_TEXT("Flow::setNumberOfRemoteConsumersConnectedToLocalDuplicator"));

	if  ( nbConsumersExpected == 0 )
		return -1;
	else {
		nbRemoteConsumersConnectedToLocalDuplicator = nbRemoteConsumers;
		return 0;
	}
}

unsigned int Flow::getNumberOfRemoteConsumersConnectedToLocalDuplicator() {
	ACE_TRACE(ACE_TEXT("Flow::getNumberOfRemoteConsumersConnectedToLocalDuplicator"));
	return nbRemoteConsumersConnectedToLocalDuplicator;
}

int Flow::setProducer(ACE_TString producerID_)
{
	ACE_TRACE(ACE_TEXT("Flow::setProducer"));

	if (producerID_ == ACE_TEXT(""))
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::setProducer ] ERROR: the ID of the producer is empty\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::setProducer ] WARNING: the ID of the producer is empty\n")), -1);
	}

	producerID = producerID_;

	// check if there are consumers
	if (countConsumers() == 0)
	{
		// no consumer
		// set the status of the producer to WAITING
		setProducerStatus(CLIENT_STATUS_WAITING);
		
		// set the status of the flow to PENDING
		setStatus(FLOW_STATUS_PENDING);
	}
	else
	{
		// there are one or more consumers
		// set the status of the producer to SWITCHED_ON
		setProducerStatus(CLIENT_STATUS_SWITCHED_ON);

		// set the status of the consumers to SWITCHED_ON
		ClientStatus clientStatus = CLIENT_STATUS_SWITCHED_ON;
		
		for (CONSUMER_ITERATOR ci = firstConsumer(); ci != lastConsumer(); ci++)
		{
			setConsumerStatus(getConsumerIDFromIterator(ci), clientStatus);
		}

		// set the status of the flow to RUNNING
		setStatus(FLOW_STATUS_RUNNING);
	}

	return 0;
}

int Flow::unsetProducer()
{
	ACE_TRACE(ACE_TEXT("Flow::unsetProducer"));

	// set the status of the producer to UNKNOWN
	setProducerStatus(CLIENT_STATUS_UNKNOWN);
	this->setNumberOfExpectedConsumers(0);

	producerID = "";
	serverProducerID = "";

	// check if there are consumers
	if (countConsumers() == 0)
	{
		// no consumers
		
		// set the status of the flow to UNKNOWN
		setStatus(FLOW_STATUS_UNKNOWN);
	}
	else	
	{
		// there are one or more consumers
		
		// set their status to WAITING
		ClientStatus clientStatus = CLIENT_STATUS_WAITING;
		for (CONSUMER_ITERATOR ci = firstConsumer(); ci != lastConsumer(); ci++)
		{
			setConsumerStatus(getConsumerIDFromIterator(ci), clientStatus);
		}

		// set the status of the flow to PENDING
		setStatus(FLOW_STATUS_PENDING);
	}
	
	return 0;
}

ACE_TString Flow::getID()
{
	ACE_TRACE(ACE_TEXT("Flow::getID"));
	
	return id;
}

ACE_TString Flow::getGroup()
{
	ACE_TRACE(ACE_TEXT("Flow::getGroup"));
	
	return group;
}

ACE_TString Flow::getType()
{
	ACE_TRACE(ACE_TEXT("Flow::getType"));
	
	return type;
}

ACE_TString Flow::getName()
{
	ACE_TRACE(ACE_TEXT("Flow::getName"));
	
	return name;
}

ACE_TString Flow::getDescription()
{
	ACE_TRACE(ACE_TEXT("Flow::getDescription"));
	
	return description;
}

u_short Flow::getPortNumber()
{
	ACE_TRACE(ACE_TEXT("Flow::getPortNumber"));
	
	return portNumber;
}

u_short Flow::getBlockSize()
{
	ACE_TRACE(ACE_TEXT("Flow::getBlockSize"));
	
	return blockSize;
}

u_short Flow::getBlockCount()
{
	ACE_TRACE(ACE_TEXT("Flow::getBlockCount"));
	
	return blockCount;
}

FlowStatus Flow::getStatus()
{
	ACE_TRACE(ACE_TEXT("Flow::getStatus"));
	
	return status;
}

unsigned int Flow::getNumberOfExpectedConsumers() 
{
	ACE_TRACE(ACE_TEXT("Flow::getNumberOfExpectedConsumers"));

	return nbConsumersExpected;
}

ACE_TString Flow::getProducer()
{
	ACE_TRACE(ACE_TEXT("Flow::getProducer"));
	
	return producerID;
}

ACE_TString Flow::getServerProducerID()
{
	ACE_TRACE(ACE_TEXT("Flow::getServerProducerID"));
	
	return serverProducerID;
}


int Flow::setServerProducerID(ACE_TString serverID_)
{
	ACE_TRACE(ACE_TEXT("Flow::setServerProducerID"));
		
	serverProducerID = serverID_;
	
	return 0;
}

int Flow::setProducerStatus(ClientStatus producerStatus_)
{
	ACE_TRACE(ACE_TEXT("Flow::setProducerStatus"));
	
	ACE_DEBUG((SF2D_DEBUG_PREFIX ACE_TEXT("[ Flow::setProducerStatus ] Flow: %s - ClientStatus: %d\n"), getID().c_str(), producerStatus_));

	producerStatus = producerStatus_;
	
	return 0;
}

ClientStatus Flow::getProducerStatus()
{
	ACE_TRACE(ACE_TEXT("Flow::getProducerStatus"));

	return producerStatus;
}

int Flow::addConsumer(ACE_TString consumerID_, ACE_TString givenFlowName_)
{
	ACE_TRACE(ACE_TEXT("Flow::addConsumer"));
	
	int result;
	
	if (consumerID_ == ACE_TEXT(""))
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::addConsumer ] ERROR: the ID of the consumer is empty\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::addConsumer ] ERROR: the ID of the consumer is empty\n")), -1);
	}

	ClientInfo *ci = new ClientInfo();
	
	
	// check if there is a producer
	if (getProducerStatus() == CLIENT_STATUS_UNKNOWN)
	{
		// no producer
		// set the status of the new consumer to WAITING
		ci->status = CLIENT_STATUS_WAITING;
		
		// set the status of the flow to PENDING
		setStatus(FLOW_STATUS_PENDING);
	}
	else
	{
	
		// there is a producer
		// set the status of the producer to SWITCHED_ON
		setProducerStatus(CLIENT_STATUS_SWITCHED_ON);

		// set the status of the new consumer to SWITCHED_ON
		ci->status = CLIENT_STATUS_SWITCHED_ON;

		// set the status of the flow to RUNNING
		setStatus(FLOW_STATUS_RUNNING);
	}

	ci->givenFlowName = givenFlowName_;
	ci->connectionToDuplicatorValidated = 0;

	result = consumerList.trybind(consumerID_, ci);


	if (result == 1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::addConsumer ] ERROR: Consumer '%s' already exists for this flow\n"), consumerID_.c_str()));
		return 1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::addConsumer ] ERROR: Consumer '%s' already exists for this flow\n"), consumerID_.c_str()), 1);
	}
	else if (result == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::addConsumer ] ERROR: Consumer '%s' not added\n"), consumerID_.c_str()));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::addConsumer ] ERROR: Consumer '%s' not added\n"), consumerID_.c_str()), -1);
	}
	else
	{
		ACE_DEBUG((SF2D_DEBUG_PREFIX ACE_TEXT("[ Flow::addConsumer ] Consumer '%s' successfully added\n"), consumerID_.c_str()));
		//ACE_DEBUG((SF2D_ANNOUNCE_PREFIX ACE_TEXT("Consumer '%s' successfully created flow '%s'\n"), consumerID_.c_str(), givenFlowName_.c_str() ));
	}

	return result;
}
	
int Flow::removeConsumer(ACE_TString consumerID_)
{
	ACE_TRACE(ACE_TEXT("Flow::removeConsumer"));

	int result;

	if (consumerID_ == ACE_TEXT(""))
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::removeConsumer ] ERROR: the ID of the consumer is empty\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::removeConsumer ] ERROR: the ID of the consumer is empty\n")), -1);
	}
	
	result = consumerList.unbind(consumerID_);
	
	if (result == 0)
	{
		if (countConsumers() == 0)
		{
			// no more consumers
			if (getProducerStatus() == CLIENT_STATUS_UNKNOWN)
			{
				// no producer
				// set the status of the flow to UNKNOWN
				setStatus(FLOW_STATUS_UNKNOWN);
			}
			else
			{
				// there is a producer
				// set the status of the producer to WAITING
				setProducerStatus(CLIENT_STATUS_WAITING);
				
				// set the status of the flow to PENDING
				setStatus(FLOW_STATUS_PENDING);
			}
		}
	}

	return result;
}
	
int Flow::containsConsumer(ACE_TString consumerID_)
{
	ACE_TRACE(ACE_TEXT("Flow::containsConsumer"));

	if (consumerID_ == ACE_TEXT(""))
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::containsConsumer ] ERROR: the ID of the consumer is empty\n")));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::containsConsumer ] ERROR: the ID of the consumer is empty\n")), -1);
	}

	return consumerList.find(consumerID_);
}

int Flow::countConsumers()
{
  ACE_TRACE(ACE_TEXT("Flow::countConsumers"));
  
  return (int) consumerList.current_size();
}

// By Imad	
int Flow::countSwitchedOnConsumers()
{
	ACE_TRACE(ACE_TEXT("Flow::countSwitchedOnConsumers"));
	
	int count =0;
	for (CONSUMER_ITERATOR ci = firstConsumer(); ci != lastConsumer(); ci++) {
	  ClientStatus clientStatus = Flow::getConsumerStatusFromIterator(ci);
	  if (clientStatus == CLIENT_STATUS_SWITCHED_ON)
	    count++;
	}
	return count;
}

// By Imad

 
int Flow::countSwitchedOffConsumers()
{
  ACE_TRACE(ACE_TEXT("Flow::countSwitchedOffConsumers"));
  
  int count =0;
  for (CONSUMER_ITERATOR ci = firstConsumer(); ci != lastConsumer(); ci++) {
    ClientStatus clientStatus = Flow::getConsumerStatusFromIterator(ci);
    if (clientStatus == CLIENT_STATUS_SWITCHED_OFF)
      count++;
  }
  
  return count;
}

int Flow::countConsumersOnServer( ACE_TString serverID_ )
{
  ACE_TRACE(ACE_TEXT("Flow::countConsumersOnServer"));
  int count = 0;
  GlobalList *gl = GLOBAL_LIST::instance(); 
  
  for (CONSUMER_ITERATOR ci = firstConsumer(); ci != lastConsumer(); ci++)
    {	
      ACE_TString clientid = Flow::getConsumerIDFromIterator(ci);
      if ( (gl->getClient(clientid))->getServer() == serverID_)
	count++;
    }
  
  return count;
}

unsigned int Flow::countServersHandlingFlow() {
	ACE_TRACE(ACE_TEXT("Flow::countServersHandlingFlow()"));
	GlobalList *gl = GLOBAL_LIST::instance(); 

	std::set<ACE_TString> serverList;
	serverList.clear();
	
	if ( producerID != "" )
		serverList.insert((gl->getClient(producerID))->getServer());

	for (CONSUMER_ITERATOR ci = firstConsumer(); ci != lastConsumer(); ci++)
    {	
      ACE_TString clientid = Flow::getConsumerIDFromIterator(ci);
      ACE_TString serverID = (gl->getClient(clientid))->getServer();
	  serverList.insert(serverID);
    }
	return serverList.size();
}

// By Imad
int Flow::countSwitchedOffConsumersOnServer( ACE_TString serverID_ )
{
  ACE_TRACE(ACE_TEXT("Flow::countConsumersOnServer"));
  int count = 0;
  GlobalList *gl = GLOBAL_LIST::instance(); 
  
  for (CONSUMER_ITERATOR ci = firstConsumer(); ci != lastConsumer(); ci++)
    {	
      ClientStatus clientStatus = Flow::getConsumerStatusFromIterator(ci);
      if (clientStatus == CLIENT_STATUS_SWITCHED_OFF) {
	ACE_TString clientid = Flow::getConsumerIDFromIterator(ci);
	if ( (gl->getClient(clientid))->getServer() == serverID_)
	  count++;
      }
    }
  
  return count;
}

 // By Imad
int Flow::countSwitchedOnConsumersOnServer( ACE_TString serverID_ )
{
  ACE_TRACE(ACE_TEXT("Flow::countConsumersOnServer"));
  int count = 0;
  GlobalList *gl = GLOBAL_LIST::instance(); 
  
  for (CONSUMER_ITERATOR ci = firstConsumer(); ci != lastConsumer(); ci++)
    {	
      ClientStatus clientStatus = Flow::getConsumerStatusFromIterator(ci);
      if (clientStatus == CLIENT_STATUS_SWITCHED_ON) {
	ACE_TString clientid = Flow::getConsumerIDFromIterator(ci);
	if ( (gl->getClient(clientid))->getServer() == serverID_)
	  count++;
      }
    }
  
  return count;
}


CONSUMER_ITERATOR Flow::firstConsumer()
{
	ACE_TRACE(ACE_TEXT("Flow::firstConsumer"));
	
	return consumerList.begin();
}
	
CONSUMER_ITERATOR Flow::lastConsumer()
{
	ACE_TRACE(ACE_TEXT("Flow::lastConsumer"));

	return consumerList.end();
}

int Flow::setConsumerStatus(ACE_TString consumerID_, ClientStatus consumerStatus_)
{
	ACE_TRACE(ACE_TEXT("Flow::setConsumerStatus"));
	
	int result;
	ClientInfo *ci;
	
	ACE_DEBUG((SF2D_DEBUG_PREFIX ACE_TEXT("[ Flow::setConsumerStatus ] Flow: %s - Consumer: %s - ClientStatus: %d\n"), getID().c_str(), consumerID_.c_str(), consumerStatus_));

	if (consumerList.find(consumerID_, ci) == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::setConsumerStatus ] ERROR: client %s does not exist\n"), consumerID_.c_str()));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::setConsumerStatus ] ERROR: client %s does not exist\n"), consumerID_.c_str()), -1);
	}
	
	ci->status = consumerStatus_;
	result = consumerList.rebind(consumerID_, ci);
	
	return result;
}

int Flow::setConsumerGivenFlowName(ACE_TString consumerID_, ACE_TString givenFlowName_)
{
	ACE_TRACE(ACE_TEXT("Flow::setConsumerGivenFlowName"));
	
	int result;
	ClientInfo *ci;
	
	ACE_DEBUG((SF2D_DEBUG_PREFIX ACE_TEXT("[ Flow::setConsumerGivenFlowName ] Flow: %s - Consumer: %s - GivenFlowName: %s\n"), getID().c_str(), consumerID_.c_str(), givenFlowName_.c_str()));

	if (consumerList.find(consumerID_, ci) == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::setConsumerGivenFlowName ] ERROR: client %s does not exist\n"), consumerID_.c_str()));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::setConsumerGivenFlowName ] ERROR: client %s does not exist\n"), consumerID_.c_str()), -1);
	}
	
	ci->givenFlowName = givenFlowName_;
	result = consumerList.rebind(consumerID_, ci);
	
	return result;
}

int Flow::setConsumerConnectionToDuplicatorVerified(ACE_TString consumerID_, int connectionOK) {
	ACE_TRACE(ACE_TEXT("Flow::setConsumerConnectionToDuplicatorVerified"));
	
	int result;
	ClientInfo *ci;
	
	ACE_DEBUG((SF2D_DEBUG_PREFIX ACE_TEXT("[ Flow::setConsumerConnectionToDuplicatorVerified ] Flow: %s - Consumer: %s - ConnectionVerified: %d\n"), getID().c_str(), consumerID_.c_str(), connectionOK));

	if (consumerList.find(consumerID_, ci) == -1)
	{
		ACE_DEBUG((SF2D_ERROR_PREFIX ACE_TEXT("[ Flow::setConsumerConnectionToDuplicatorVerified ] ERROR: client %s does not exist\n"), consumerID_.c_str()));
		return -1;
		//ACE_ERROR_RETURN((LM_ERROR, ACE_TEXT("[ Flow::setConsumerConnectionToDuplicatorVerified ] ERROR: client %s does not exist\n"), consumerID_.c_str()), -1);
	}
	
	ci->connectionToDuplicatorValidated = connectionOK;
	result = consumerList.rebind(consumerID_, ci);
	
	return result;
}

ACE_TString Flow::getConsumerIDFromIterator(CONSUMER_ITERATOR consumerIterator_)
{
	ACE_TRACE(ACE_TEXT("Flow::getConsumerIDFromIterator"));
	
	return (*consumerIterator_).ext_id_;
}

ClientStatus Flow::getConsumerStatusFromIterator(CONSUMER_ITERATOR consumerIterator_)
{
	ACE_TRACE(ACE_TEXT("Flow::getConsumerStatusFromIterator"));

	return (*consumerIterator_).int_id_->status;
}



ACE_TString Flow::getConsumerGivenFlowNameFromIterator(CONSUMER_ITERATOR consumerIterator_)
{
	ACE_TRACE(ACE_TEXT("Flow::getConsumerGivenFlowNameFromIterator"));

	return (*consumerIterator_).int_id_->givenFlowName;
}

int Flow::isConsumerConnectionToDuplicatorVerifiedFromIterator(CONSUMER_ITERATOR consumerIterator_) {
	ACE_TRACE(ACE_TEXT("Flow::isConsumerConnectionToDuplicatorVerifiedFromIterator"));
	
	return (*consumerIterator_).int_id_->connectionToDuplicatorValidated;
}

ClientStatus Flow::getConsumerStatus(ACE_TString consumerID_)
{
	ACE_TRACE(ACE_TEXT("Flow::getConsumerStatus"));
	
	ClientInfo *ci;
	
	if (consumerList.find(consumerID_, ci) == -1)
	{
		return CLIENT_STATUS_UNKNOWN;
	}
	else
	{
		return ci->status;
	}
}

ACE_TString Flow::getConsumerGivenFlowName(ACE_TString consumerID_)
{
	ACE_TRACE(ACE_TEXT("Flow::getConsumerGivenFlowName"));
	
	ClientInfo *ci;
	
	if (consumerList.find(consumerID_, ci) == -1)
	{
		return ACE_TEXT("");
	}
	else
	{
		return ci->givenFlowName;
	}
}

int Flow::isConsumerConnectionToDuplicatorVerified(ACE_TString consumerID_) {
	ACE_TRACE(ACE_TEXT("Flow::isConsumerConnectionToDuplicatorVerified"));
	
	ClientInfo *ci;
	
	if (consumerList.find(consumerID_, ci) == -1)
	{
		return -1;
	}
	else
	{
		return ci->connectionToDuplicatorValidated;
	}
}

int Flow::isSynchronizedFlowMustBeStarted() {
	ACE_TRACE(ACE_TEXT("Flow::isSynchronizedFlowMustBeStarted"));
	/*in this method, we verify that every expected consumer is connected to its 
	duplicator and that every remote duplicator is connected to the local duplicator
	provider.
	1) First we check that the provider is local to our machine. If the producer is 
	remote, this test is irrelevant.
	2) We check the consumer list of the flow: each consumer must have its connection
	confirmed
	3) We count the number of hosts, which consumes the flow. This number must be equal to
	(number of connection confirmed by the duplicator)-1. We don't count the current host. 
	*/

	//first we check 1)
	unsigned int nbConsumersConnected = 0;
	for (CONSUMER_ITERATOR ci = firstConsumer(); ci != lastConsumer(); ci++)
	{
		 if ( isConsumerConnectionToDuplicatorVerifiedFromIterator(ci) )
			nbConsumersConnected++;
	}
	if ( nbConsumersConnected < getNumberOfExpectedConsumers() )
		//we don't have enough consumers to start to transfer datat
		return -1;

	//then we checked 2)
	unsigned int nbServers = countServersHandlingFlow();
	if ( (nbServers - 1) == getNumberOfRemoteConsumersConnectedToLocalDuplicator() )
		return 0;
	else 
		return -1;
}


ACE_TString Flow::toXmlWithIndent(int n_)
{
	ACE_TRACE(ACE_TEXT("Flow::toXmlWithIndent"));

	if (n_ < 0 || n_ > 255)
	{
		ACE_ERROR((LM_ERROR, ACE_TEXT("[ Flow::toXmlWithIndent ] ERROR: indent lower than 0 or greater than 255\n")));
	}

	ACE_TString unit = ACE_TEXT("    ");
	ACE_TString indent = ACE_TEXT("");
	
	for (int i = 0; i < n_; i++)
	{
		indent += unit;
	}	

	ACE_TString xml = ACE_TEXT("");
	
	xml += indent;
	xml += ACE_TEXT("<Flow ID=\"");
	xml += getID();
	xml += ACE_TEXT("\">\n");

	xml += indent;
	xml += unit;
	xml += ACE_TEXT("<Group>");
	xml += getGroup();
	xml += ACE_TEXT("</Group>\n");

	xml += indent;
	xml += unit;
	xml += ACE_TEXT("<Type>");
	xml += getType();
	xml += ACE_TEXT("</Type>\n");
	
	xml += indent;
	xml += unit;
	xml += ACE_TEXT("<Name>");
	xml += getName();
	xml += ACE_TEXT("</Name>\n");
	
	xml += indent;
	xml += unit;
	xml += ACE_TEXT("<Description>");
	xml += getDescription();
	xml += ACE_TEXT("</Description>\n");

	ACE_TCHAR buf[11];

	xml += indent;
	xml += unit;
	xml += ACE_TEXT("<PortNumber>");
	xml += ACE_OS::itoa(getPortNumber(), buf, 10);
	xml += ACE_TEXT("</PortNumber>\n");

	xml += indent;
	xml += unit;
	xml += ACE_TEXT("<BlockSize>");
	xml += ACE_OS::itoa(getBlockSize(), buf, 10);
	xml += ACE_TEXT("</BlockSize>\n");

	xml += indent;
	xml += unit;
	xml += ACE_TEXT("<BlockCount>");
	xml += ACE_OS::itoa(getBlockCount(), buf, 10);
	xml += ACE_TEXT("</BlockCount>\n");

	xml += indent;
	xml += unit;
	xml += ACE_TEXT("<Status>");
	xml += ACE_OS::itoa(getStatus(), buf, 10);
	xml += ACE_TEXT("</Status>\n");

	xml += indent;
	xml += unit;
	xml += ACE_TEXT("<Producer RefID=\"");
	xml += getProducer();
	xml += ACE_TEXT("\" Status=\"");
	xml += ACE_OS::itoa(getProducerStatus(), buf, 10);
	xml += ACE_TEXT("\" />\n");
	
	xml += indent;
	xml += unit;
	xml += ACE_TEXT("<ServerProducerID>");
	xml += getServerProducerID();
	xml += ACE_TEXT("</ServerProducerID>\n");

	xml += indent;
	xml += unit;
	xml += ACE_TEXT("<ConsumerList>\n");
	for (CONSUMER_ITERATOR ci = firstConsumer(); ci != lastConsumer(); ci++)
	{
		xml += indent;
		xml += unit;
		xml += unit;
		xml += ACE_TEXT("<Consumer RefID=\"");
		xml += Flow::getConsumerIDFromIterator(ci);
		xml += ACE_TEXT("\" Status=\"");
		xml += ACE_OS::itoa(Flow::getConsumerStatusFromIterator(ci), buf, 10);
		xml += ACE_TEXT("\" GivenFlowName=\"");
		xml += Flow::getConsumerGivenFlowNameFromIterator(ci);
		xml += ACE_TEXT("\" ConnectionToDuplicatorSuccessful=\"");
		xml += ACE_OS::itoa(Flow::isConsumerConnectionToDuplicatorVerifiedFromIterator(ci), buf, 10);
		xml += ACE_TEXT("\" />\n");
	}
	xml += indent;
	xml += unit;
	xml += ACE_TEXT("</ConsumerList>\n");

	xml += indent;
	xml += ACE_TEXT("</Flow>\n");
	
	return xml;
}

ACE_TString Flow::toXml()
{
	ACE_TRACE(ACE_TEXT("Flow::toXml"));
	
	return toXmlWithIndent(0);
}

ACE_TString Flow::toXmlWithoutConsumers(int n_)
{
	ACE_TRACE(ACE_TEXT("Flow::toXmlWithoutConsumers"));

	if (n_ < 0 || n_ > 255)
	{
		ACE_ERROR((LM_ERROR, ACE_TEXT("[ Flow::toXmlWithoutConsumers ] ERROR: indent lower than 0 or greater than 255\n")));
	}

	ACE_TString unit = ACE_TEXT("    ");
	ACE_TString indent = ACE_TEXT("");
	
	for (int i = 0; i < n_; i++)
	{
		indent += unit;
	}	

	ACE_TString xml = ACE_TEXT("");
	
	xml += indent;
	xml += ACE_TEXT("<Flow ID=\"");
	xml += getID();
	xml += ACE_TEXT("\">\n");

	xml += indent;
	xml += unit;
	xml += ACE_TEXT("<Group>");
	xml += getGroup();
	xml += ACE_TEXT("</Group>\n");

	xml += indent;
	xml += unit;
	xml += ACE_TEXT("<Type>");
	xml += getType();
	xml += ACE_TEXT("</Type>\n");
	
	xml += indent;
	xml += unit;
	xml += ACE_TEXT("<Name>");
	xml += getName();
	xml += ACE_TEXT("</Name>\n");
	
	xml += indent;
	xml += unit;
	xml += ACE_TEXT("<Description>");
	xml += getDescription();
	xml += ACE_TEXT("</Description>\n");

	ACE_TCHAR buf[11];

	xml += indent;
	xml += unit;
	xml += ACE_TEXT("<PortNumber>");
	xml += ACE_OS::itoa(getPortNumber(), buf, 10);
	xml += ACE_TEXT("</PortNumber>\n");

	xml += indent;
	xml += unit;
	xml += ACE_TEXT("<BlockSize>");
	xml += ACE_OS::itoa(getBlockSize(), buf, 10);
	xml += ACE_TEXT("</BlockSize>\n");

	xml += indent;
	xml += unit;
	xml += ACE_TEXT("<BlockCount>");
	xml += ACE_OS::itoa(getBlockCount(), buf, 10);
	xml += ACE_TEXT("</BlockCount>\n");

	// In order to keep the synchronization, the status of the flow is set to FLOW_STATUS_PENDING
	// The status will automaticaly be updated when the Local Application description of the consumers
	// servers will be received! If it has already be received, the flow will not be created, it will
	// only be updated with the producer information
	xml += indent;
	xml += unit;
	xml += ACE_TEXT("<Status>");
	xml += ACE_OS::itoa(FLOW_STATUS_PENDING, buf, 10);
	xml += ACE_TEXT("</Status>\n");

	// In order to keep the synchronization, the status of the producer is set to CLIENT_STATUS_WAITING
	// The status will automaticaly be updated when the Local Application description of the consumers
	// servers will be received! If it has already be received, the flow will not be created, it will
	// only be updated with the producer information
	xml += indent;
	xml += unit;
	xml += ACE_TEXT("<Producer RefID=\"");
	xml += getProducer();
	xml += ACE_TEXT("\" Status=\"");
	xml += ACE_OS::itoa(CLIENT_STATUS_WAITING, buf, 10);
	xml += ACE_TEXT("\" />\n");
	
	xml += indent;
	xml += unit;
	xml += ACE_TEXT("<ServerProducerID>");
	xml += getServerProducerID();
	xml += ACE_TEXT("</ServerProducerID>\n");

	// In order to keep the synchronization, the list of consumers is set to empty.
	// The list will automaticaly be updated when the Local Application description of the consumers
	// servers will be received! If it has already be received, the flow will not be created, it will
	// only be updated with the producer information
	xml += indent;
	xml += unit;
	xml += ACE_TEXT("<ConsumerList>\n");
	xml += indent;
	xml += unit;
	xml += ACE_TEXT("</ConsumerList>\n");

	xml += indent;
	xml += unit;

	xml += indent;
	xml += ACE_TEXT("</Flow>\n");
	
	return xml;
}

ACE_TString Flow::toXmlWithoutProducer(int n_)
{
	ACE_TRACE(ACE_TEXT("Flow::toXmlWithoutProducer"));

	if (n_ < 0 || n_ > 255)
	{
		ACE_ERROR((LM_ERROR, ACE_TEXT("[ Flow::toXmlWithoutProducer ] ERROR: indent lower than 0 or greater than 255\n")));
	}

	ACE_TString unit = ACE_TEXT("    ");
	ACE_TString indent = ACE_TEXT("");
	
	for (int i = 0; i < n_; i++)
	{
		indent += unit;
	}	

	ACE_TString xml = ACE_TEXT("");
	
	xml += indent;
	xml += ACE_TEXT("<Flow ID=\"");
	xml += getID();
	xml += ACE_TEXT("\">\n");

	xml += indent;
	xml += unit;
	xml += ACE_TEXT("<Group>");
	xml += getGroup();
	xml += ACE_TEXT("</Group>\n");

	xml += indent;
	xml += unit;
	xml += ACE_TEXT("<Type>");
	xml += getType();
	xml += ACE_TEXT("</Type>\n");
	
	xml += indent;
	xml += unit;
	xml += ACE_TEXT("<Name>");
	xml += getName();
	xml += ACE_TEXT("</Name>\n");
	
	xml += indent;
	xml += unit;
	xml += ACE_TEXT("<Description>");
	xml += getDescription();
	xml += ACE_TEXT("</Description>\n");

	ACE_TCHAR buf[11];

	xml += indent;
	xml += unit;
	xml += ACE_TEXT("<PortNumber>");
	xml += ACE_OS::itoa(getPortNumber(), buf, 10);
	xml += ACE_TEXT("</PortNumber>\n");

	xml += indent;
	xml += unit;
	xml += ACE_TEXT("<BlockSize>");
	xml += ACE_OS::itoa(getBlockSize(), buf, 10);
	xml += ACE_TEXT("</BlockSize>\n");

	xml += indent;
	xml += unit;
	xml += ACE_TEXT("<BlockCount>");
	xml += ACE_OS::itoa(getBlockCount(), buf, 10);
	xml += ACE_TEXT("</BlockCount>\n");

	// In order to keep the synchronization, the status of the flow is set to FLOW_STATUS_PENDING
	// The status will automaticaly be updated when the Local Application description of the producer
	// server will be received! If it has already be received, the flow will not be created, it will
	// only be updated with the consumers information
	xml += indent;
	xml += unit;
	xml += ACE_TEXT("<Status>");
	xml += ACE_OS::itoa(FLOW_STATUS_PENDING, buf, 10);
	xml += ACE_TEXT("</Status>\n");

	// In order to keep the synchronization, the status of the producer is set to CLIENT_STATUS_UNKNOWN
	// The status will automaticaly be updated when the Local Application description of the producer
	// server will be received! If it has already be received, the flow will not be created, it will
	// only be updated with the consumers information
    
	xml += indent;
	xml += unit;
	xml += ACE_TEXT("<Producer RefID=\"");
	xml += "";
	xml += ACE_TEXT("\" Status=\"");
	xml += ACE_OS::itoa(CLIENT_STATUS_UNKNOWN, buf, 10);
	xml += ACE_TEXT("\" />\n");
	
	xml += indent;
	xml += unit;
	xml += ACE_TEXT("<ServerProducerID></ServerProducerID>\n");

	xml += indent;
	xml += unit;
	xml += ACE_TEXT("<ConsumerList>\n");
	GlobalList *gl = GLOBAL_LIST::instance();
	// We save the name of the current machine (the machine on which the Smartflow Server is running)
	ACE_TCHAR localname[99+1];
	if (ACE_OS::hostname (localname,99) == -1) 
	        ACE_ERROR ((LM_ERROR,"%p\n","hostname"));
	for (CONSUMER_ITERATOR ci = firstConsumer(); ci != lastConsumer(); ci++)
	{
	        // We put only the consumers running on the current server
	        Client *consumer = gl->getClient(Flow::getConsumerIDFromIterator(ci));
		ACE_TString servername = consumer->getServer();
		// We test if the client is running on the current server or on another
		if (servername == localname) {
		  // The client is running on the current server, we add it to the LocalList
		  xml += indent;
		  xml += unit;
		  xml += unit;
		  xml += ACE_TEXT("<Consumer RefID=\"");
		  xml += Flow::getConsumerIDFromIterator(ci);
		  xml += ACE_TEXT("\" Status=\"");
		  // In order to keep the synchronization, the status of the client is set to CLIENT_STATUS_WAITING 
		  // (unless the client is in pause)
		  // The status will automaticaly be updated when the Local Application description of the producer
		  // server will be received! If it has already be received, the flow will not be created, it will
		  // only be updated with the consumers information
		  if (Flow::getConsumerStatusFromIterator(ci) == CLIENT_STATUS_SWITCHED_OFF)
			  xml += ACE_OS::itoa(CLIENT_STATUS_SWITCHED_OFF, buf, 10);
		  else
			  xml += ACE_OS::itoa(CLIENT_STATUS_WAITING, buf, 10);
		  xml += ACE_TEXT("\" GivenFlowName=\"");
		  xml += Flow::getConsumerGivenFlowNameFromIterator(ci);
		  xml += ACE_TEXT("\" ConnectionToDuplicatorSuccessful=\"");
		  xml += ACE_OS::itoa(Flow::isConsumerConnectionToDuplicatorVerifiedFromIterator(ci), buf, 10);
		  xml += ACE_TEXT("\" />\n");
		}
	}
	xml += indent;
	xml += unit;
	xml += ACE_TEXT("</ConsumerList>\n");

	xml += indent;
	xml += ACE_TEXT("</Flow>\n");
	
	return xml;
}
