#ifndef _LASTMODIFICATIONS_H_
#define _LASTMODIFICATIONS_H_

#include "ace/ACE.h"
#include "ace/SString.h"
#include "ace/Log_Msg.h"
#include "ace/Singleton.h"
#include "ace/Null_Mutex.h"
#include "ace/Containers_T.h"
//#include "ace/Unbounded_Queue.h"

#include "ClientList.h"

/**
 * This class implements the design pattern Singleton.
 * In order to make sure that only the singleton instance is created,
 * and that users cannot create their own instances,
 * the constructor is protected and the singleton is a friend of this class
 */


class LastModifications
{
	friend class ACE_Singleton<LastModifications, ACE_Null_Mutex>;
	
	protected:
		int init();
		int fini();
		
	public:
		
		ClientList * clientlistmodifications;

		LastModifications();
		
		virtual ~LastModifications();

		int addClient(Client* client_);
		
		int remove(ACE_TString clientID_);
		
		int addModifications(ACE_TString modif_);

		int clear();		

};

typedef ACE_Singleton<LastModifications, ACE_Null_Mutex> LAST_MODIFICATIONS;

#endif //_LASTMODIFICATIONS_H_
