#ifndef _SERVER_H_
#define _SERVER_H_

#include "ace/ACE.h"
#include "ace/SString.h"
#include "ace/Log_Msg.h"
#include "ace/Containers_T.h"

class Peer_Event_Handler;

/// This class describes a server object.

class Server
{	
	protected:
		int init(ACE_TString name_, ACE_TString ip_, ACE_TString os_);
		int fini();
		
		/// name of the server
		ACE_TString name;

		/// IP address of the server
		ACE_TString ip;
		
		/// OS of the client
		ACE_TString os;	
		
		Peer_Event_Handler* handler;

	public:
		
		/// Create a Server giving a name, an ip address and an os
		Server(ACE_TString name_, ACE_TString ip_, ACE_TString os_);
		
		/// Destroy the Server
		virtual ~Server();

		/// Get the name of the client
		
		/**
		 * @return the DNS name of the server
		 */
		ACE_TString getName();

		/// Get the IP of the server
		
		/**
		 * @return the IP address of the server
		 */
		ACE_TString getIP();


		/// Get the OS of the server
		
		/**
		 * @return the OS of the server
		 */
		ACE_TString getOS();
		
		///Set the handler of the server registred to the reactor
		
		/**
		 * @param h_ pointer to the handler of the servers
		 */
		 void setHandler(Peer_Event_Handler* h_);
		 
		 ///Get the handler of the server
		 
		 /**
		  * @return the handler of the server
		  */
		  Peer_Event_Handler* getHandler();
		
};

#endif //_SERVER_H_
