// Client able to launch the demo presented at the ICMI conference in Montreal (November 2006)

#include "Smartflow.h"

#include <iostream>

using namespace smartflow;
using namespace std;

int main(int argc, char **argv) {

	Smartflow *sf;

	sf = new Smartflow();
	
	int tmp_argc = 0;
    char **tmp_argv = NULL;
	
	if ( ! sf ) {
		cout << "Problem with the creation of the Smartflow object" << endl;
		return -1;
	}

	if (sf->init(tmp_argc, tmp_argv) != 0) {
		cout << "Problem with the initialization of the Smartflow object" << endl;
		return -1;
	}
    
	if ( ! sf->ready_to_run() )   {
		cout << "The Smartflow object is not ready to run" << endl;
		return -1;
	}
	
	if ( sf->connect_to_application_server("application_launcher","admin") != 0) 
    {
		cout << "Unable to connect to the application server" << endl;
		return -1;
    }

	sf->startClient("oscillo_provider.exe", "maia", "--sf clientname=oscillo_provider_windows --sf clientgroup=demo --sf clientpath=oscillo_provider.exe  --sf flow-flow_array_provider=ID1 --sf flowinfo=O%flow_array_provider%Flow_Audio_Array");
	sf->startClient("oscillo_consumer.exe", "maia", "--sf clientname=oscillo_consumer_windows --sf clientgroup=demo --sf clientpath=oscillo_consumer.exe  --sf flow-flow_array_consumer=ID1 --sf flowinfo=I%flow_array_consumer%Flow_Audio_Array");

	sf->startClient("/opt/Smartflow2/bin/clients/mp2_provider_macosx_mpeg2ts", "typhon.ncsl.nist.gov", "--sf clientname=mp2_provider_macosx_mpeg2ts --sf clientgroup=demo --sf clientpath=/opt/Smartflow2/bin/clients/mp2_provider_macosx_mpeg2ts --sf flow-mpeg2ts=ID5 --sf flowinfo=O%mpeg2ts%Flow_Video_Mpeg2TS");
	sf->startClient("/opt/Smartflow2/bin/clients/sf2replex", "typhon.ncsl.nist.gov", "--sf clientname=sf2replex --sf clientgroup=demo --sf clientpath=/opt/Smartflow2/bin/clients/sf2replex --sf flow-mpeg2ts=ID5 --sf flow-mpeg2es=ID8 --sf flowinfo=I%mpeg2ts%Flow_Video_Mpeg2TS%%O%mpeg2es%Flow_Video_Mpeg2ES");

	sf->startClient("/opt/Smartflow2/bin/clients/mpeg2es_2_ipl_decoder", "metis.ncsl.nist.gov", "--sf clientname=mpeg2es_2_ipl_decoder --sf clientgroup=demo --sf clientpath=/opt/Smartflow2/bin/clients/mpeg2es_2_ipl_decoder --sf flow-mpeg2es=ID8 --sf flow-ipl_flow=ID13 --sf flowinfo=I%mpeg2es%Flow_Video_Mpeg2ES%%O%ipl_flow%Flow_IplImage");
	sf->startClient("/opt/Smartflow2/bin/clients/augmentation", "metis.ncsl.nist.gov", "--sf clientname=augmentation --sf clientgroup=demo --sf clientpath=/opt/Smartflow2/bin/clients/augmentation --sf flow-flow_array_consumer=ID1 --sf flow-ipl_flow=ID13 --sf flowinfo=I%flow_array_consumer%Flow_Audio_Array%%I%ipl_flow%Flow_IplImage");

	return 0;
}