// Client able to stop the demo presented at the ICMI conference in Montreal (November 2006)

#include "Smartflow.h"

#include <iostream>

using namespace smartflow;
using namespace std;

int main(int argc, char **argv) {

	Smartflow *sf;

	sf = new Smartflow();
	
	int tmp_argc = 0;
    char **tmp_argv = NULL;
	
	if ( ! sf ) {
		cout << "Problem with the creation of the Smartflow object" << endl;
		return -1;
	}

	if (sf->init(tmp_argc, tmp_argv) != 0) {
		cout << "Problem with the initialization of the Smartflow object" << endl;
		return -1;
	}
    
	if ( ! sf->ready_to_run() )   {
		cout << "The Smartflow object is not ready to run" << endl;
		return -1;
	}
	
	if ( sf->connect_to_application_server("application_launcher","admin") != 0) 
    {
		cout << "Unable to connect to the application server" << endl;
		return -1;
    }

	sf->stopClient("augmentation", "demo");
	sf->stopClient("oscillo_consumer_windows", "demo");
	
	sf->stopClient("oscillo_provider_windows", "demo");
	sf->stopClient("mpeg2es_2_ipl_decoder", "demo");

	sf->stopClient("sf2replex", "demo");
	sf->stopClient("mp2_provider_macosx_mpeg2ts", "demo");

	return 0;
}