#include "Flow_BlockTest.h"
#include "duplicator_common_ACE.h"

#include <sstream>
#include <iostream>
#include <string>

using namespace std;

smartflow::Flow * create_flow(void)
{
	return new smartflow::Flow_BlockTest();
}


namespace smartflow {

string      		Flow_BlockTest::default_flow_type="Flow_BlockTest";
buffer_size_t		Flow_BlockTest::default_buffer_size = 10;
long        		Flow_BlockTest::default_history_size = 10;
string      		Flow_BlockTest::default_flow_desc="Fixed-size data blocks Flow";
	
Flow_BlockTest::Flow_BlockTest()
     :super(),current_buffer_size(default_buffer_size),current_history_size(default_history_size)
{
}

                //bool init(FlowManager *manager,const std::string &type,const std::string &name,const std::string &rgroup,const std::string &args,flow_direction_t mode, flow_policy_t policy, bool isSynchronized);
bool Flow_BlockTest::init(FlowManager *manager,const std::string &type,const std::string &name,const std::string &rgroup,const std::string &args,flow_direction_t mode, flow_policy_t policy, bool isSynchronized)
{
  bool okay = super::init(manager,type,name,rgroup,args,mode,policy,isSynchronized);
  if ( !okay ) return okay; /*forward error */
   
   current_buffer_size = default_buffer_size;
   current_history_size = default_history_size;
   int current_block_count = DUP_DEFAULT_BLOCK_COUNT;

   string tmp = parseArgs("blocksize",args);
   if ( ! tmp.empty() ) {
       istringstream is(tmp);
       is >> current_buffer_size;
   }
   tmp = parseArgs("history",args);
   if ( ! tmp.empty() ) {
       istringstream is(tmp);
       is >> current_history_size;
   }
   tmp = parseArgs("blockcount",args);
   if ( ! tmp.empty() ) {
     istringstream is(tmp);
     is >> current_block_count;
   }
   
   if ( !setMaxBufferSize(current_buffer_size) ) return false;
   if ( !setHistorySize(current_history_size) ) return false;
   if ( !setBlockCount(current_block_count) )   return false; 

   return true;
}

Flow_BlockTest::~Flow_BlockTest()
{
	current_buffer_size = current_history_size = 0;
}


std::string & Flow_BlockTest::getFlowType(void)
{
	return default_flow_type;
}
std::string & Flow_BlockTest::getFlowDesc(void)
{
	return default_flow_desc;
}
}//namespace
