#ifndef _FLOW_BLOCKTEST_H
#define _FLOW_BLOCKTEST_H

#include "ace/svc_export.h"

#include "Smartflow.h"
#include "Flow.h"

#include <string>

namespace smartflow {


/** This class is an exemple of a simple Flow class.
 * It simply exchange buffers of a given size, with a given history size.
 * They are passed as arguements, which are :
 * - blocksize=int    : the block size in byte, >0 and < MAXINT.Requiered.
 * - historysize=int : the size of the history. default 11.
 */
class ACE_Svc_Export Flow_BlockTest : public Flow {
  typedef Flow super;
  public:
   Flow_BlockTest();
   virtual ~Flow_BlockTest();
   virtual bool init(FlowManager *manager,const std::string &type,const std::string &name,const std::string &rgroup,const std::string &args,flow_direction_t mode, flow_policy_t policy, bool isSynchronized);
   virtual std::string & getFlowType(void);
   virtual std::string & getFlowDesc(void);
  
  private:
   static std::string      default_flow_type;
   static buffer_size_t    default_buffer_size;
   static long             default_history_size;
   static std::string      default_flow_desc;
  
   buffer_size_t     current_buffer_size;
   long              current_history_size;
  
};//class

} // namespace smartflow

extern "C" Smartflow_Export smartflow::Flow * create_flow(void);

#endif
