#include "Buffer.h"

namespace smartflow {

Buffer::Buffer()
{
	ACE_TRACE(ACE_TEXT("Buffer::Buffer"));
}
Buffer::~Buffer()
{
	ACE_TRACE(ACE_TEXT("Buffer::~Buffer"));
}

bool Buffer::init(MemoryManager *manager, Flow * flow)
{
	ACE_TRACE(ACE_TEXT("Buffer::init"));
  if (manager==0)
    return false;
  manager_ = manager;
  if (flow == 0)
    return false;
  flow_ = flow;
  return true;
}

Smartflow * Buffer::getSmartflow(void)
{
	ACE_TRACE(ACE_TEXT("Buffer::getSmartflow"));
  if (manager_)
    return manager_->get_smartflow();
  return NULL;
}
	
Smartflow * Buffer::get_smartflow(void) {
	ACE_TRACE(ACE_TEXT("Buffer::get_martflow"));
	return this->getSmartflow();
}
	
MemoryManager * Buffer::getManager(void)
{
	ACE_TRACE(ACE_TEXT("Buffer::getManager"));
  return manager_ ;
}

MemoryManager * Buffer::get_manager(void) {
	ACE_TRACE(ACE_TEXT("Buffer::get_manager"));
	return this->getManager();
}

Flow * Buffer::getFlow(void)
{
	ACE_TRACE(ACE_TEXT("Buffer::getFlow"));
	return flow_;
}
	
Flow * Buffer::get_flow(void) {
	ACE_TRACE(ACE_TEXT("Buffer::get_flow"));
	return this->getFlow();
}

buffer_size_t Buffer::get_max_size(void) {
	ACE_TRACE(ACE_TEXT("Buffer::get_max_size"));
	return this->getMaxSize();
}

buffer_size_t Buffer::get_size(void){
	ACE_TRACE(ACE_TEXT("Buffer::get_size"));
	return this->getSize();
}
	
bool Buffer::set_size(buffer_size_t new_size) {
	ACE_TRACE(ACE_TEXT("Buffer::set_size"));
	return this->setSize(new_size);
}

bool Buffer::init_buf(void) {
	ACE_TRACE(ACE_TEXT("Buffer::init_buf"));
	return this->initBuf();
}
	
data_type_t Buffer::get_next_data_type() {
	ACE_TRACE(ACE_TEXT("Buffer::get_next_data_type"));
	return this->getNextDataType();
}

buffer_size_t Buffer::get_next_data_size() {
	ACE_TRACE(ACE_TEXT("Buffer::get_next_data_size"));
	return this->getNextDataSize();
}

ACE_Time_Value Buffer::get_next_time_stamp() {
	ACE_TRACE(ACE_TEXT("Buffer::get_next_time_stamp"));
	return this->getNextTimeStamp();
}

bool Buffer::go_to_next_block() {
	ACE_TRACE(ACE_TEXT("Buffer::go_to_next_block"));
	return this->gotoNextBlock();
}

bool Buffer::push_data(void *src, buffer_size_t size) {
	ACE_TRACE(ACE_TEXT("Buffer::push_data"));
	return this->pushData(src, size);
}

bool Buffer::push_data(const void *src, buffer_size_t size) {
	ACE_TRACE(ACE_TEXT("Buffer::push_data"));
	return this->pushData(src, size);
}

bool Buffer::push_data_ts(void *src, buffer_size_t size, ACE_Time_Value *ts) {
	ACE_TRACE(ACE_TEXT("Buffer::push_data_ts"));
	return this->pushDataTS(src, size, ts);
}

bool Buffer::push_data_ts(const void *src, buffer_size_t size, ACE_Time_Value *ts) {
	ACE_TRACE(ACE_TEXT("Buffer::push_data_ts"));
	return this->pushDataTS(src, size, ts);
}

bool Buffer::push_metadata(void *src, buffer_size_t size, data_type_t type) {
	ACE_TRACE(ACE_TEXT("Buffer::push_metadata"));
	return this->pushMetadata(src, size, type);
}

bool Buffer::push_metadata(const void *src, buffer_size_t size, data_type_t type) {
	ACE_TRACE(ACE_TEXT("Buffer::push_metadata"));
	return this->pushMetadata(src, size, type);
}

bool Buffer::pop_data(void *src, buffer_size_t size) {
	ACE_TRACE(ACE_TEXT("Buffer::pop_data"));
	return this->popData(src, size);
}

bool Buffer::pop_metadata(void *src, buffer_size_t size ) {
	ACE_TRACE(ACE_TEXT("Buffer::pop_metadata"));
	return this->popMetadata(src, size);
}    

bool Buffer::pop_data_ts(void *src,buffer_size_t size, ACE_Time_Value *ts ) {
	ACE_TRACE(ACE_TEXT("Buffer::pop_data_ts"));
	return this->popDataTS(src, size, ts);
} 
	
/*****************************************************/

BufferIterator::BufferIterator() {
	ACE_TRACE(ACE_TEXT("BufferIterator::BufferIterator"));
  _hasTimestamp = false;
  //ts.tv_sec = 0;
  //ts.tv_nsec = 0;
  dataType = 0;
  size = 0;
  buffer = NULL;
  endOfBuffer = false;
  isDataPoped = true;
  newBuffer = true;
}

BufferIterator::~BufferIterator() {
}

bool BufferIterator::hasTimestamp() { 
	ACE_TRACE(ACE_TEXT("BufferIterator::hasTimestamp"));
	return _hasTimestamp; 
}

bool BufferIterator::has_timestamp() {
	ACE_TRACE(ACE_TEXT("BufferIterator::has_timestamp"));
	return this->hasTimestamp();
}
	
ACE_Time_Value BufferIterator::getTimestamp() { 
	ACE_TRACE(ACE_TEXT("BufferIterator::getTimestamp"));
	return ts; 
}

ACE_Time_Value BufferIterator::get_timestamp() { 
	ACE_TRACE(ACE_TEXT("BufferIterator::get_timestamp"));
	return this->getTimestamp();
}
	
data_type_t BufferIterator::getDataType() {
	ACE_TRACE(ACE_TEXT("BufferIterator::getDataType"));
	return dataType; 
}

data_type_t BufferIterator::get_data_type() {
	ACE_TRACE(ACE_TEXT("BufferIterator::get_data_type"));
	return this->getDataType();
}
	
ACE_UINT32 BufferIterator::getDataSize() {
	ACE_TRACE(ACE_TEXT("BufferIterator::getDataSize"));
	return size; 
}

ACE_UINT32 BufferIterator::get_data_size() {
	ACE_TRACE(ACE_TEXT("BufferIterator::get_data_size"));
	return this->getDataSize();
}
	
void BufferIterator::initBuffer(Buffer *_buffer) {
	ACE_TRACE(ACE_TEXT("BufferIterator::initBuffer"));
  _hasTimestamp = false;
  //ts.tv_sec = 0;
  //ts.tv_nsec = 0;
  dataType = 0;
  size = 0;
  buffer = _buffer;
  endOfBuffer = false;
  isDataPoped = true;
  newBuffer = true;
}

void BufferIterator::setBuffer(Buffer *_buffer) {
	ACE_TRACE(ACE_TEXT("BufferIterator::setBuffer"));
	initBuffer(_buffer);
}
	
void BufferIterator::set_buffer(Buffer *_buffer) {
	ACE_TRACE(ACE_TEXT("BufferIterator::set_buffer"));
	return this->setBuffer(_buffer);
}

void BufferIterator::next() {
	ACE_TRACE(ACE_TEXT("BufferIterator::next"));
  if ( !endOfBuffer && buffer != NULL ) {
    if ( !isDataPoped )
      buffer->gotoNextBlock();
    _hasTimestamp = false;
    //ts.tv_sec = 0;
    //ts.tv_nsec = 0;
    size = 0;
    dataType = buffer->getNextDataType();
    switch ( dataType ) {
    case DATA:
      size = buffer->getNextDataSize();
      isDataPoped = false;
      break;
    case METADATA:
      size = buffer->getNextDataSize();
      isDataPoped = false;
      break;
    case DATAWITHTIMESTAMP:
      _hasTimestamp = true;
      size = buffer->getNextDataSize();
      ts = buffer->getNextTimeStamp();
      isDataPoped = false;
      break;
    case SF_COMMAND:
      size = buffer->getNextDataSize();
      isDataPoped = false;
      //the pop is not yet implemented. We should never be in this case
      break;
    case ENDOFBUFFER:
      //no need to pop...
      endOfBuffer = true;
      break;
    default:
      if ( dataType > 9 ) {
	size = buffer->getNextDataSize();
	isDataPoped = false;
      }
      break;
    }
  }
}

bool BufferIterator::end() {
	ACE_TRACE(ACE_TEXT("BufferIterator::end"));
  return endOfBuffer;
}

void BufferIterator::init() {
	ACE_TRACE(ACE_TEXT("BufferIterator::init"));
  if ( newBuffer ) {
    next();
    newBuffer = false;
  }
}

bool BufferIterator::getData(void *data) {
	ACE_TRACE(ACE_TEXT("BufferIterator::getData"));
  if ( !isDataPoped && !endOfBuffer) {
    bool resultPop = false;
    switch ( dataType ) {
    case DATA:
      resultPop = buffer->popData(data, size);
      isDataPoped = true;
      break;
    case METADATA:
      resultPop = buffer->popMetadata(data, size);
      isDataPoped = true;
      break;
    case DATAWITHTIMESTAMP:
      resultPop = buffer->popDataTS(data, size, &ts);
      isDataPoped = true;
      break;
    case SF_COMMAND:
      //the pop is not yet implemented. We should never be in this case
      break;
    case ENDOFBUFFER:
      //no need to pop...
      break;
    default:
      if ( dataType > 9 ) {
	resultPop = buffer->popMetadata(data, size);
	isDataPoped = true;
      }
      break;
    } //end switch
    return resultPop;
  }//end if
  else {
    return false;
  }
}

bool BufferIterator::get_data(void *data) {
	ACE_TRACE(ACE_TEXT("BufferIterator::get_data"));
	return this->getData(data);
}
	
}



