#ifndef _CLIENT_HANDLER_H
#define _CLIENT_HANDLER_H

#include "ace/svc_export.h" // for exported symbols (windows)

#include "ace/OS.h"
#include "ace/SString.h"
#include "ace/Process.h"
#include "ace/Event_Handler.h"
#include "ace/INET_Addr.h"
#include "ace/Reactor.h"
#include "ace/SOCK_Stream.h"

#include "Smartflow.h"

namespace smartflow {
	
//forward declaration
class Thread_Client;

/// This class describes the Handler which is used to handle the connection with a Server of the NIST Data Flow System 2. She is registered to the reactor. She is instanced by the Peer_Acceptor_Event_Handler at each new "Accept" on the SF2D_DEFAULT_REMOTE_PORT.
class ACE_Svc_Export Client_Handler : public ACE_Event_Handler
{
	protected :

	/// Socket used to communicate with a smartflow2 server.
	ACE_SOCK_Stream remote_peer_;
	Thread_Client *parent;
     
	public :

	// These functions are overrided functions from ACE_Event_Handler.
	Client_Handler(ACE_Reactor *reactor, Thread_Client *parent_);
	virtual ~Client_Handler();
	virtual int handle_input(ACE_HANDLE);
	virtual int handle_close(ACE_HANDLE = ACE_INVALID_HANDLE, ACE_Reactor_Mask = 0);
	virtual ACE_HANDLE get_handle() const;
	ACE_SOCK_Stream &peer() {return remote_peer_;}

};
	
}
#endif
