#include <ConnectionManager.h>

namespace smartflow {

ConnectionManager::ConnectionManager()
{
	ACE_TRACE(ACE_TEXT("ConnectionManager::ConnectionManager"));
	sf_ = 0;
}
ConnectionManager::~ConnectionManager()
{
	ACE_TRACE(ACE_TEXT("ConnectionManager::~ConnectionManager"));
	sf_ = 0;
}
bool ConnectionManager::init(Smartflow *sf)
{
	ACE_TRACE(ACE_TEXT("ConnectionManager::init"));
	if (sf==0)
        	return false;
    sf_ = sf;
    return true;
}
Smartflow * ConnectionManager::getSmartflow(void)
{
	ACE_TRACE(ACE_TEXT("ConnectionManager::get_smartflow"));
 	return sf_;
}

Smartflow * ConnectionManager::get_smartflow(void) {
	return this->getSmartflow();
}
	
bool ConnectionManager::connect_to_application_server(const std::string &clientname, const std::string &clientgroup) {
	return this->connectToApplicationServer(clientname, clientgroup);
}
	
bool ConnectionManager::disconnect_from_application_server(void) {
	return this->disconnectFromApplicationServer();
}
	
bool ConnectionManager::get_flow(const std::string &type, const std::string &name, const std::string &group , const std::string &arg, flow_direction_t direction, int blockcount, int blocksize, int check, unsigned int numberOfConsumersExpected) {
	return this->getFlow(type, name, group , arg, direction, blockcount, blocksize, check, numberOfConsumersExpected);
}
	
bool ConnectionManager::remove_flow(const std::string &type, const std::string &name,const std::string &group) {
	return this->removeFlow(type, name, group);
}
	
bool ConnectionManager::check_flow(const std::string &type,const std::string &name,const std::string &group) {
	return this->checkFlow(type, name, group);
}
	
bool ConnectionManager::start_client(const std::string &clientpath, const std::string &server,const std::string &arguments,const std::string &parameters) {
	return this->start_client(clientpath, server, arguments, parameters);
}

bool ConnectionManager::stop_client(const std::string &clientname,const std::string &clientgroup) {
	return this->stopClient(clientname, clientgroup);
}

bool ConnectionManager::get_application_description(std::string &flowlist) {
	return this->getApplicationDescription(flowlist);
}
	
bool ConnectionManager::getServerList(std::string &serverlist) {
	return this->getServerList(serverlist);
}
	
bool ConnectionManager::get_last_modifications(std::string &modifications) {
	return this->getLastModifications(modifications);
}
	
bool ConnectionManager::send_log(const std::string &logMessage) {
	return this->sendLog(logMessage);
}
	
bool ConnectionManager::pause_flow(const std::string &clientname,const std::string &clientgroup,const std::string &flowtype,const std::string &flowgroup) {
	return this->pauseFlow(clientname, clientgroup, flowtype, flowgroup);
}
	
bool ConnectionManager::restart_flow(const std::string &clientname,const std::string &clientgroup,const std::string &flowtype,const std::string &flowgroup) {
	return this->restartFlow(clientname, clientgroup, flowtype, flowgroup);
}
	
} // namespace smartflow
