#include "ErrorManager.h"

namespace smartflow {

ErrorManager::ErrorManager() : sf_(0),error_(0)
{
	ACE_TRACE(ACE_TEXT("ErrorManager::ErrorManager"));
}
ErrorManager::~ErrorManager()
{
	ACE_TRACE(ACE_TEXT("ErrorManager::~ErrorManager"));
	sf_ = 0;
}
	
bool ErrorManager::init(Smartflow *sf)
{
	ACE_TRACE(ACE_TEXT("ErrorManager::init"));
	if (sf==0)
		return false;
    sf_ = sf;
    return true;
}

Smartflow * ErrorManager::getSmartflow(void)
{
	ACE_TRACE(ACE_TEXT("ErrorManager::getSmartflow"));
	return sf_;
}
	
	
Smartflow * ErrorManager::get_smartflow(void)
{
	ACE_TRACE(ACE_TEXT("ErrorManager::get_smartflow"));
 	return this->getSmartflow();
}

const std::string & ErrorManager::strError(void)
{ 
	ACE_TRACE(ACE_TEXT("ErrorManager::strerror"));
	int i;
	for ( i=0;duplicator_error[i].code != UNKNOWN_ERROR ; i++ )
	{	if ( duplicator_error[i].code == error_ )
			break;
	}
	return duplicator_error[i].message; 
}

const std::string & ErrorManager::str_error(void) {
	return this->strError();
}


#define _(charstring)  (charstring)

const Smartflow_Error ErrorManager::duplicator_error[] = 
{
	{ NO_ERRORS, _("No error") },
	{ INVALID_APPLICATION_NAME, _("Invalid application name.") } ,
	{ APPLICATION_ALREADY_EXIST, _("The application already exists within this program.") } ,
	{ SMARTFLOW_NOT_READY, _("The Smartflow is not ready, call Smartflow::init() first.") },	
	{ INVALID_FLOW, _("An invalid flow object has been given.") },	
	{ INVALID_PREFERENCE_FILE_XML,  _("The XML preference file is invalid or missing.") },
	{ INVALID_PREFERENCE_FILE_XML_NOWRITE,  _("The XML preference file cannot be written.") },
	{ INVALID_PREFERENCE_PAIR, _("The Preference value (key or value) is invalid.") },
	{ SERVER_CANNOT_CONNECT, _("Cannot connect to the application server.") },
	{ SERVER_IS_NOT_CONNECTED, _("The client is not connected to the server.") },
	{ SERVER_INVALID_PROTOCOL, _("The application server response is invalid.") },
	{ SERVER_INVALID_PARAMETER, _("Invalid data when sendign message to server.") },
	{ SERVER_ERROR_RESPONSE, _("The application server answered negatively to a request.") },
	{ FLOW_NOT_SET_ON_BUFFER, _("Buffer operation attempted but the flow is invalid.") },
	{ FLOW_MANAGER_NOT_EMPTY_ON_STARTUP, _("The Flow Manager is not empty while initialising.") },
	{ FLOW_ALREADY_EXIST, _("The flow already exist within this application in MakeFlow.") } ,
	{ FLOW_NOT_EXIST, _("The flow doesn't exist within this application in MakeFlow.") } ,
	{ FLOW_CANNOT_FIND_DLL, _("Cannot find the DLL associated with the flow type.") } ,
	{ FLOW_INVALID_DLL, _("Problem while trying to initialise the Flow DLL.") } ,
	{ FLOW_DLL_INSTANCE_NOT_VALID, _("Inconsistancy between the name of the flow in DLL and the request.")},
	{ FLOW_INVALID_FLOW_STATE, _("Invalid flow state in flow management.")},
	{ FLOW_CANNOT_CREATE_IMPL, _("Impossible to create the Implementation object for the flow.")},
	{ FLOWIMPL_CANNOT_SETUP_HISTORY, _("Cannot setup the history queue.")},
	{ FLOWIMPL_CANNOT_RUN_THREAD, _("Cannot start the reader/writer thread.")},
	{ FLOWIMPL_INVALID_FLOW_STATE, _("Invalid flow state while operating.")},
	{ FLOWIMPL_INVALID_QUEUE_STATE, _("Invalid history queue state while operating.")},
	{ FLOWIMPL_CANNOT_OPEN_DUPLICATOR, _("Problem while opening connection to the duplicator.")},
	{ FLOWIMPL_SERVICE_UNEXPECTED_QUIT, _("Error with duplicator communication.")},
	{ BUFFER_INVALID_SIZE, _("New buffer size too large or null.")},
    { FLOW_PROVIDER_PAUSE_ERROR, _("A Flow Provider cannot be paused or restarted.")},
	{ FLOW_QUEUE_POLICY_INVALID, _("Flow queue policy option not recognized.")},
	{ FLOW_SYNCHRONIZED_INVALID, _("Only Output flows can be synchronized.")},
	{ BUFFER_ALLOCATION_FAILED, _("The memory allocation of the buffer failded.")},
	{ NOT_YET_IMPLEMENTED, _("Not Yet implemented.")},
	{ UNKNOWN_ERROR, _("An unknown error occurs, please report as a bug.") } ,/* TO BE KEPT AS THE LAST ONE */
};


} // namespace SMARTFLOW 
