#include <FlowManager.h>

namespace smartflow {

FlowManager::FlowManager()
{
	ACE_TRACE(ACE_TEXT("FlowManager::FlowManager"));
	sf_ = 0;
}
FlowManager::~FlowManager()
{
	ACE_TRACE(ACE_TEXT("FlowManager::~FlowManager"));
	sf_ = 0;
}
	
bool FlowManager::init(Smartflow *sf)
{
	ACE_TRACE(ACE_TEXT("FlowManager::init"));
	if (sf==0)
        	return false;
        sf_ = sf;
        return true;
}
Smartflow * FlowManager::getSmartflow(void)
{
	ACE_TRACE(ACE_TEXT("FlowManager::getSmartflow"));
 	return sf_;
}
	
Smartflow * FlowManager::get_smartflow(void)
{
	ACE_TRACE(ACE_TEXT("FlowManager::get_smartflow"));
	return this->getSmartflow();
}
	
Flow* FlowManager::make_flow(const std::string &type,const std::string &name,const std::string &group,const std::string &arg,flow_direction_t direction, flow_policy_t policy, unsigned int numberOfConsumersExpected) {
	ACE_TRACE(ACE_TEXT("FlowManager::make_flow"));
	return this->makeFlow(type, name, group, arg, direction, policy, numberOfConsumersExpected);
}

Flow* FlowManager::find_flow(const std::string &fname) {
	ACE_TRACE(ACE_TEXT("FlowManager::find_flow"));
	return this->findFlow(fname);
}

bool FlowManager::destroy_flow(Flow *f) {
	ACE_TRACE(ACE_TEXT("FlowManager::destroy_flow"));
	return this->destroyFlow(f);
}

bool FlowManager::stop_all_flows() {
	ACE_TRACE(ACE_TEXT("FlowManager::stop_all_flows"));
	return this->stopAllFlows();
}

} // namespace SMARTFLOW 
