#ifndef _LOG_MANAGER_H
#define _LOG_MANAGER_H

#include "ace/svc_export.h" // for exported symbols (windows)

#include "Smartflow.h"

namespace smartflow {

class ACE_Svc_Export Log_Manager {

 public:
     /** \brief Class constructor. 
     * \warning This method does not initialise the object, the init() method
     * must be used for this purpose.
     * 
     */
    Log_Manager();
    
	/** \brief Class destructor.
     * Take care of any cleanup that is necessary to free the object.
     */
	virtual ~Log_Manager();
    
	/** \brief Class initialiser. Must be called just after the object
     * construction. 
     * \param sf The Smartflow object in which this object will be be registered.
     * \return 0 if the object is correctly initialised, otherwise -1. If possible,
     * an error will be set via Smartflow::seterror() to explain the error.
     */
	virtual bool init(Smartflow *sf, const char* name);
   
	/** \brief Return the Smartflow object associated with an instance of the class.
     * \return A pointer to the smartflow object, or NULL if an error occured.
     */
	Smartflow * getSmartflow(void);
    Smartflow * get_smartflow(void);

 
 private:
      Smartflow * sf_;
};

}//namespace smartflow
#endif

