#include "MemoryManager_ACE.h"
#include "Flow.h"
#include "ErrorManager.h"

// DEBUG
#include <iostream>
#include <stdio.h>

namespace smartflow {
MemoryManager_ACE::MemoryManager_ACE()
	:super()
{
	ACE_TRACE(ACE_TEXT("MemoryManager_ACE::MemoryManager_ACE"));
}
MemoryManager_ACE::~MemoryManager_ACE()
{
	ACE_TRACE(ACE_TEXT("MemoryManager_ACE::~MemoryManager_ACE"));
}
	
bool MemoryManager_ACE::init(Smartflow *sf)
{
	ACE_TRACE(ACE_TEXT("MemoryManager_ACE::init"));
	return super::init(sf);
}

Buffer * MemoryManager_ACE::mallocBuffer(Flow *flow, buffer_size_t sizeOfBuffer)
{
	ACE_TRACE(ACE_TEXT("MemoryManager_ACE::mallocBuffer"));

	if (sizeOfBuffer <= 0)
		sizeOfBuffer = flow->getMaxBufferSize();

	if ( flow == NULL ) {
		get_smartflow()->setError(FLOW_NOT_SET_ON_BUFFER);
		return NULL;
	}
	Buffer_ACE * new_buf = new Buffer_ACE();
	if ( new_buf->init(this, flow, sizeOfBuffer) == false) {
		delete new_buf;
		return NULL;
	}
	else
	   return new_buf;
}
void MemoryManager_ACE::freeBuffer(Buffer *buf)
{
	ACE_TRACE(ACE_TEXT("MemoryManager_ACE::free_buffer"));
	delete buf;
	return;
}

} // namespace SMARTFLOW
