#include <PreferenceManager.h>
#include <ErrorManager.h>

namespace smartflow {

PreferenceManager::PreferenceManager()
{
	ACE_TRACE(ACE_TEXT("PreferenceManager::PreferenceManager"));
	sf_ = 0;
}
PreferenceManager::~PreferenceManager()
{
	ACE_TRACE(ACE_TEXT("PreferenceManager::~PreferenceManager"));
	sf_ = 0;
}
	
bool PreferenceManager::init(Smartflow *sf)
{
	ACE_TRACE(ACE_TEXT("PreferenceManager::init"));
	if (sf==0)
        	return false;
    sf_ = sf;
    return true;
}

Smartflow * PreferenceManager::getSmartflow(void)
{
	ACE_TRACE(ACE_TEXT("PreferenceManager::getSmartflow"));
 	return sf_;
}
 
Smartflow * PreferenceManager::get_smartflow(void) {
	return this->getSmartflow();
}
	
void PreferenceManager::addPreference(string key, string value, string comment) {
    ACE_TRACE(ACE_TEXT("PreferenceManager::addPreference"));
	if ( key.empty() ||  value.empty() ) {
  	sf_->setError(INVALID_PREFERENCE_PAIR);
  }
   addPref(key,value,comment);
}
	
void PreferenceManager::add_preference(string key, string value, string comment) {
	this->addPreference(key, value, comment);
}

void PreferenceManager::remPreference(string key) {
	ACE_TRACE(ACE_TEXT("PreferenceManager::remPreference"));
  if ( key.empty() ) {
  	sf_->setError(INVALID_PREFERENCE_PAIR);
  }
    remPref(key);
}

void PreferenceManager::rem_preference(string key) {
	this->remPreference(key);
}
	
string  PreferenceManager::getPreferenceValue(string key) {
	ACE_TRACE(ACE_TEXT("PreferenceManager::getPreferenceValue"));
  if ( key.empty() ) {
  	  	sf_->setError(INVALID_PREFERENCE_PAIR);
  }
    return getPrefValue(key);
}

string  PreferenceManager::get_preference_value(string key) {
	return this->getPreferenceValue(key);
}
	
string  PreferenceManager::getPreferenceKey(int num) {
    ACE_TRACE(ACE_TEXT("PreferenceManager::getPreferenceKey"));
	if ( num < 1 ) {
		sf_->setError(INVALID_PREFERENCE_PAIR);
  }
    return getPrefKey(num);
}
	
string  PreferenceManager::get_preference_key(int num) {
	return this->getPreferenceKey(num);
}

string  PreferenceManager::getPreferenceComment(string key) {
    ACE_TRACE(ACE_TEXT("PreferenceManager::getPreferenceComment"));
	if ( key.empty() ) {
  	  	sf_->setError(INVALID_PREFERENCE_PAIR);
  }
  return getPrefComment(key);
}

string  PreferenceManager::get_preference_comment(string key) {
	return this->getPreferenceComment(key);
}
	
int  PreferenceManager::getPreferenceIntValue(string key) {
  ACE_TRACE(ACE_TEXT("PreferenceManager::getPreferenceIntValue"));
  if ( key.empty() ) {
  	sf_->setError(INVALID_PREFERENCE_PAIR);
  }
  return getPrefIntValue(key);
}
	
int  PreferenceManager::get_preference_int_value(string key) {
	return this->getPreferenceIntValue(key);
}

double  PreferenceManager::getPreferenceDoubleValue(string key) {
    ACE_TRACE(ACE_TEXT("PreferenceManager::getPreferenceDoubleValue"));
	if ( key.empty() ) {
  	sf_->setError(INVALID_PREFERENCE_PAIR);
  }
    return getPrefDoubleValue(key);
}
	
double  PreferenceManager::get_preference_double_value(string key) {
	return this->getPreferenceDoubleValue(key);
}
	
void PreferenceManager::view_prefs() {
	return this->viewPrefs();
}

	
bool PreferenceManager::init_args(int& argc, char**& argv, bool keepSFOptions) {
	return this->initArgs(argc, argv, keepSFOptions);
}

} // namespace SMARTFLOW 
