#include "ace/Get_Opt.h"
#include "ace/SString.h"

#include "Preference_Args.h"

#include <string>
#include <set>
#include <iostream>

using namespace std;
namespace smartflow {

Preference_Args::Preference_Args()
	:super()
{
	ACE_TRACE(ACE_TEXT("Preference_Args::Preference_Args"));
}

Preference_Args::~Preference_Args()
{
	ACE_TRACE(ACE_TEXT("Preference_Args::~Preference_Args"));
}

bool Preference_Args::init(PreferenceManager *manager)
{
	ACE_TRACE(ACE_TEXT("Preference_Args::init"));
	return super::init(manager);
}

bool Preference_Args::initPreferences(int &argc, char** &argv, bool keepSFOptions){
	ACE_TRACE(ACE_TEXT("Preference_Args::initPreferences"));
  ACE_TString fullstring, keystring, valuestring;
  if (( argc == 0) || (argv == NULL))
    return true;
  ACE_TCHAR **argv_;
  
  argv_ = (ACE_TCHAR **) malloc(sizeof(ACE_TCHAR*) * argc);
  
  for (int i = 0; i < argc; i++) {
    argv_[i] = ACE_TEXT_CHAR_TO_TCHAR(argv[i]);
  }

  std::set<int> index;
  index.clear();

  ACE_Get_Opt pref(argc, argv_, ACE_TEXT(""), 1, 0, ACE_Get_Opt::RETURN_IN_ORDER, 0);
  pref.long_option(ACE_TEXT("sf"),ACE_Get_Opt::ARG_REQUIRED);
  for ( int i; ( i = pref() ) != -1; )
    if ( i == 0 ) { /* A long option was found */
      fullstring = pref.opt_arg();
      index.insert(pref.opt_ind() - 2);
      index.insert(pref.opt_ind() - 1);
      unsigned int pos = fullstring.find(ACE_TEXT("="),0);
      if ( pos >=   1 ) {
	keystring = fullstring.substr(0, pos);
	if (  pos != ( fullstring.length() - 1 ) )
	  valuestring = fullstring.substr(pos+1, fullstring.length()-1);
	else 
	  valuestring = ACE_TEXT("");
	if ( ( (keystring.length() != 0) && (valuestring.length() != 0) ) ) {
	  string keystring_ = ACE_TEXT_ALWAYS_CHAR(keystring.c_str());
	  string valuestring_ = ACE_TEXT_ALWAYS_CHAR(valuestring.c_str());
	  addPreference(keystring_,valuestring_);
	  keystring = ACE_TEXT("");
	  valuestring = ACE_TEXT("");
	}
      }
    }

  char **new_argv;
  int new_argc = 0;
  string listargs = "";

  //we make a list of the remaining arguments
  new_argv = (char **) malloc( sizeof(char*) * (argc - index.size()));
  for ( int i = 0; i < argc; i++ ) {
    if ( index.count(i) == 0 ) {
      new_argv[new_argc] = argv[i];
      //we don't need the first argument, which is the name of the client node.
      if ( i != 0 ) {
	listargs.append(argv[i]);
	listargs.append(" ");
      }
      new_argc++;
    }
  }
  
  //listargs represents the list of the client parameters without the Smartflow options, i.e. the clientparam
  string keystring_ = ACE_TEXT_ALWAYS_CHAR("clientparam");
  string listargs_ = ACE_TEXT_ALWAYS_CHAR(listargs.c_str());
  
  //if there is no arguments, no need to put an empty variable in the list.
  if ( listargs_ != "")
    addPreference(keystring_,listargs_);

  //the user don't want to keep Smartflow options, we put the list of arguments, which don't concern the SF in argv.
  if ( !keepSFOptions ) {
    argv = new_argv;
    argc = new_argc;
  }
  
  return true;
}

} // namespace SMARTFLOW
