#ifndef _Preference_Hash_H
#define _Preference_Hash_H

#include "ace/svc_export.h" // for exported symbols (windows)

#include "Smartflow.h"
#include "Preference.h"

namespace smartflow {

/** \brief Class Preference_Hash .
 * Used as a Hash table to store a list of preferences.
 * The preference manager own one instance of this class. 
 * \author Nist Smartspace Group
 * \date 04-19-2004
 * \internal
*/
class ACE_Svc_Export Preference_Hash:public Preference {
/** Redefine Preference (which is the ancestor of Preference_Hash) as
    \b super . Facility taken from the Java language.
*/
typedef Preference super;
public:
	/** \brief Class constructor. 
         * \warning This method does not initialise the object, the init() method
         * must be used for this purpose.
        */
		Preference_Hash();
        /** \brief Class destructor.
        */
        virtual ~Preference_Hash();
        /** \brief Class initialiser. Must be called just after the object
         * construction. 
         * \param manager The manager in which this object will be registered
         * \return 0 if the object is correctly initialised, otherwise -1. If possible,
         * an error will be set via Smartflow::seterror() to explain the error.
        */
        virtual bool init(PreferenceManager *manager);
private:
}; // class Preference_Hash
}  // namespace SMARTFLOW
#endif
