#ifndef _THREAD_CLIENT_H
#define _THREAD_CLIENT_H

#include "ace/svc_export.h" // for exported symbols (windows)

#include "ace/OS.h"
#include "ace/SString.h"
#include "ace/Reactor.h"
#include "ace/Task.h"

#include "Smartflow.h"

namespace smartflow {
	
class Log_Handler;
class Client_Handler;
class ConnectionManager_ACE;

//The only purpose of this class is to stop the thread
//The handle_input stop the thread IN the thread context
class ACE_Svc_Export Thread_Stopper : public ACE_Event_Handler {
public:
	Thread_Stopper(ACE_Reactor *reactor);
	virtual ~Thread_Stopper();
	virtual int handle_input(ACE_HANDLE handle_ = ACE_INVALID_HANDLE);
};

class ACE_Svc_Export Thread_Client : public ACE_Task_Base 
{	
	friend class Client_Handler;
public:
	Thread_Client();
	Thread_Client(ACE_TString name, ACE_TString group, ConnectionManager_ACE *cm_);
	virtual ~Thread_Client();
	virtual int svc(void);
	
	void stop_thread();
	bool needToInvokeExitMethod();
	void setNeedToInvokeExitMethod(bool invoke);
	
	void setNameAndGroup(ACE_TString &name, ACE_TString &group);
	void setConnectionManger(ConnectionManager_ACE *cm_);
	
private:
	ACE_TString clientname;
	ACE_TString clientgroup;
	ConnectionManager_ACE *cm;
	ACE_Reactor *reactor;
	Log_Handler *theLogHandler;
	Client_Handler *theClientHandler;
	Thread_Stopper *theThreadStopper;
	
	bool invoke;
	void close_input_stream();
	
};

}//closing namespace
#endif
