#ifndef _XML_SAX_HANDLER_H
#define _XML_SAX_HANDLER_H

#include "ace/svc_export.h"

#include "ace/OS.h"
#include "ace/SString.h"

#include "ACEXML/common/SAXExceptions.h"
#include "ACEXML/parser/parser/Parser.h"
#include "ACEXML/common/DefaultHandler.h"
#include "ACEXML/common/InputSource.h"
#include "ACEXML/common/StrCharStream.h"

#include <string>
#include "Preference_XMLFile.h"

using namespace smartflow;

class ACE_Svc_Export XML_SaxHandler : public ACEXML_DefaultHandler
{
 public:

  // Construction-Destruction
  XML_SaxHandler(Preference_XMLFile *manager);
  virtual ~XML_SaxHandler(void);
  
  /* method reimplementation*/
  #if (ACE_MAJOR_VERSION < 5)
  virtual void characters(const ACEXML_Char *cdata,int start,int length  ACEXML_ENV_ARG_DECL_NOT_USED) ACE_THROW_SPEC ((ACEXML_SAXException));
  #endif    
  
  #if (ACE_MAJOR_VERSION > 5)
  virtual void characters(const ACEXML_Char *cdata,size_t start,size_t length  ACEXML_ENV_ARG_DECL_NOT_USED) ACE_THROW_SPEC ((ACEXML_SAXException));
  #endif
        
  #if (ACE_MAJOR_VERSION == 5)
    #if (ACE_MINOR_VERSION < 5)
        virtual void characters(const ACEXML_Char *cdata,int start,int length  ACEXML_ENV_ARG_DECL_NOT_USED) ACE_THROW_SPEC ((ACEXML_SAXException));
    #endif
    #if (ACE_MINOR_VERSION > 5)
        virtual void characters(const ACEXML_Char *cdata,size_t start,size_t length  ACEXML_ENV_ARG_DECL_NOT_USED) ACE_THROW_SPEC ((ACEXML_SAXException));
    #endif
    #if (ACE_MINOR_VERSION == 5)
        #if (ACE_BETA_VERSION >= 4)
            virtual void characters(const ACEXML_Char *cdata,size_t start,size_t length  ACEXML_ENV_ARG_DECL_NOT_USED) ACE_THROW_SPEC ((ACEXML_SAXException));
       #else
            virtual void characters(const ACEXML_Char *cdata,int start,int length  ACEXML_ENV_ARG_DECL_NOT_USED) ACE_THROW_SPEC ((ACEXML_SAXException));
       #endif
    #endif
  #endif
  //virtual void characters(   const ACEXML_Char *cdata,int start,int length  ACEXML_ENV_ARG_DECL_NOT_USED) ACE_THROW_SPEC ((ACEXML_SAXException));   
  //virtual void characters(   const ACEXML_Char *cdata,size_t start,size_t length  ACEXML_ENV_ARG_DECL_NOT_USED) ACE_THROW_SPEC ((ACEXML_SAXException));      
       
  virtual void endDocument(ACEXML_ENV_SINGLE_ARG_DECL_NOT_USED) ACE_THROW_SPEC ((ACEXML_SAXException));
  virtual void endElement(   const ACEXML_Char *uri, const ACEXML_Char *name, const ACEXML_Char *qName ACEXML_ENV_ARG_DECL_NOT_USED) ACE_THROW_SPEC ((ACEXML_SAXException));
  virtual void startDocument(ACEXML_ENV_SINGLE_ARG_DECL_NOT_USED) ACE_THROW_SPEC ((ACEXML_SAXException));
  virtual void startElement( const ACEXML_Char *uri, const ACEXML_Char *name, const ACEXML_Char *qName, ACEXML_Attributes *alist ACEXML_ENV_ARG_DECL_NOT_USED) ACE_THROW_SPEC ((ACEXML_SAXException));
  /* By Imad */
  virtual void ignorableWhitespace (const ACEXML_Char *, int, int  ACEXML_ENV_ARG_DECL_NOT_USED)  ACE_THROW_SPEC ((ACEXML_SAXException));
  virtual void fatalError(ACEXML_SAXParseException& ex ACEXML_ENV_ARG_DECL_NOT_USED) ACE_THROW_SPEC((ACEXML_SAXException));
  virtual void error(ACEXML_SAXParseException & ex ACEXML_ENV_ARG_DECL_NOT_USED) ACE_THROW_SPEC((ACEXML_SAXException));
  virtual void warning(ACEXML_SAXParseException & ex ACEXML_ENV_ARG_DECL_NOT_USED) ACE_THROW_SPEC((ACEXML_SAXException));
  /* ************ */                       		
  ACE_TString state;
  ACE_TString endState;
  
  private:
    smartflow::Preference_XMLFile *manager_;
    std::string key;
    std::string value;
    std::string comment;      		
}; //class XML_SaxHandler

#endif
