#ifndef DUPLICATOR_COMMON_ACE_H
#define DUPLICATOR_COMMON_ACE_H

#define DUP_MAX_FILENAME_LEN 1024
#define DUP_FLOW_FILENAME_PREFIX ACE_TEXT("sf2-")
#define DUP_FLOW_FILENAME_MMAP ACE_TEXT(".mmap")
#define DUP_FLOW_FILENAME_SOCKET ACE_TEXT(".sock")
#define DUP_FLOW_FILENAME_PSOCKET ACE_TEXT(".psock")

#define DUP_DEFAULT_BLOCK_COUNT  1

/** Local structure exchanged between clients and Duplicator's handlers.
\internal
    This structure is NEVER exchanged between remote clients so endianness
	is not an issue for the block_size member. 
	This struct must remain 4 bytes.
	The same structure is used for submitting blocks to local consumers or
	accepting blocks from local providers.
*/
typedef struct {
	char block_number;			/** The number of the block to read or fill */
	char placeholder;			/**  No use at the time of writing */
	unsigned long block_size;	/** Block size to read, or block size just written */
} local_block_t;


#endif
