#ifndef _CLIENTDESCGEN_H
#define _CLIENTDESCGEN_H

#include "MainWindowClientDescGen.h"

class ClientDescGen : public MainWindowClientDescGen {
	Q_OBJECT
	
public: 
	ClientDescGen( QWidget* parent = 0, const char* name = 0, Qt::WFlags fl = Qt::WType_TopLevel );
	~ClientDescGen();
	virtual void init();
	virtual bool writeClientFile( QString & fileName );
	virtual bool flowNameExists( QString name );
	
public slots:
	virtual void fileNew();
	virtual void fileOpen();
	virtual void fileSave();
	virtual void fileSaveAs();
	virtual void fileExit();
	virtual void browsePath();
	virtual void checkClientName();
	virtual void checkClientPath();
	virtual void closeEvent( QCloseEvent * e );
	virtual void addFlow();
	virtual void deleteFlow();
	virtual void editFlow();
	virtual void enableDeleteAndEditButtons();
	virtual void disableDeleteAndEditButtons();
	virtual void helpAbout();
	virtual void helpOverview();
	
protected:
	virtual bool readClientFile( QString fileName );
    virtual void clearAllFields();
    virtual void addFlowInListView( QString flowName, QString flowType, int direction );
	
private:
	virtual void enableSave();	
};

#endif
