#ifndef FLOWDESCRIPTIONDIALOG_H
#define FLOWDESCRIPTIONDIALOG_H

#include <QtCore/QVariant>
#include <QtGui/QGroupBox>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QComboBox>
#include <QtGui/QDialog>
#include <QtGui/QGridLayout>
#include <QtGui/QHBoxLayout>
#include <QtGui/QLabel>
#include <QtGui/QLineEdit>
#include <QtGui/QPushButton>
#include <QtGui/QRadioButton>
#include <QtGui/QSpacerItem>
#include <QtGui/QVBoxLayout>

#ifdef Q_OS_MAC
#define ON_MAC 1
#endif

#ifdef Q_OS_LINUX
#define ON_LINUX 1
#endif

#ifdef Q_OS_WIN
#define ON_WINDOWS 1
#endif


class Ui_FlowDescriptionDialog
{
public:
    QHBoxLayout *hboxLayout;
    QVBoxLayout *vboxLayout;
    QGroupBox *groupBox7;
    QHBoxLayout *hboxLayout1;
    QGridLayout *gridLayout;
    QHBoxLayout *hboxLayout2;
    QRadioButton *InputRadioButton;
    QSpacerItem *spacerItem;
    QRadioButton *OutputRadioButton;
    QSpacerItem *spacerItem1;
    QLabel *textLabel3;
    QLabel *textLabel4;
    QLabel *textLabel5;
    QComboBox *FlowTypeComboBox;
    QLineEdit *FlowNameLineEdit;
    QSpacerItem *spacerItem2;
    QHBoxLayout *hboxLayout3;
    QPushButton *OkButton;
    QSpacerItem *spacerItem3;
    QPushButton *CancelButton;

    void setupUi(QDialog *FlowDescriptionDialog)
    {
    if (FlowDescriptionDialog->objectName().isEmpty())
        FlowDescriptionDialog->setObjectName(QString::fromUtf8("FlowDescriptionDialog"));
    FlowDescriptionDialog->resize(410, 177);
    hboxLayout = new QHBoxLayout(FlowDescriptionDialog);
    hboxLayout->setSpacing(6);
    hboxLayout->setMargin(11);
    hboxLayout->setObjectName(QString::fromUtf8("hboxLayout"));
    vboxLayout = new QVBoxLayout();
    vboxLayout->setSpacing(6);
    vboxLayout->setObjectName(QString::fromUtf8("vboxLayout"));
    groupBox7 = new QGroupBox(FlowDescriptionDialog);
    groupBox7->setObjectName(QString::fromUtf8("groupBox7"));
	QVBoxLayout *theLayout = new QVBoxLayout;
	groupBox7->setLayout(theLayout);    
	groupBox7->layout()->setSpacing(6);
    groupBox7->layout()->setMargin(11);
    hboxLayout1 = new QHBoxLayout();
    QBoxLayout *boxlayout = qobject_cast<QBoxLayout *>(groupBox7->layout());
    if (boxlayout)
        boxlayout->addLayout(hboxLayout1);
    hboxLayout1->setAlignment(Qt::AlignTop);
    hboxLayout1->setObjectName(QString::fromUtf8("hboxLayout1"));
    gridLayout = new QGridLayout();
    gridLayout->setSpacing(6);
    gridLayout->setObjectName(QString::fromUtf8("gridLayout"));
    hboxLayout2 = new QHBoxLayout();
    hboxLayout2->setSpacing(6);
    hboxLayout2->setObjectName(QString::fromUtf8("hboxLayout2"));
    InputRadioButton = new QRadioButton(groupBox7);
    InputRadioButton->setObjectName(QString::fromUtf8("InputRadioButton"));
    InputRadioButton->setChecked(true);

    hboxLayout2->addWidget(InputRadioButton);

    spacerItem = new QSpacerItem(51, 20, QSizePolicy::Expanding, QSizePolicy::Minimum);

    hboxLayout2->addItem(spacerItem);

    OutputRadioButton = new QRadioButton(groupBox7);
    OutputRadioButton->setObjectName(QString::fromUtf8("OutputRadioButton"));

    hboxLayout2->addWidget(OutputRadioButton);

    spacerItem1 = new QSpacerItem(111, 20, QSizePolicy::Expanding, QSizePolicy::Minimum);

    hboxLayout2->addItem(spacerItem1);


    gridLayout->addLayout(hboxLayout2, 1, 1, 1, 1);

    textLabel3 = new QLabel(groupBox7);
    textLabel3->setObjectName(QString::fromUtf8("textLabel3"));
    textLabel3->setWordWrap(false);

    gridLayout->addWidget(textLabel3, 0, 0, 1, 1);

    textLabel4 = new QLabel(groupBox7);
    textLabel4->setObjectName(QString::fromUtf8("textLabel4"));
    textLabel4->setWordWrap(false);

    gridLayout->addWidget(textLabel4, 1, 0, 1, 1);

    textLabel5 = new QLabel(groupBox7);
    textLabel5->setObjectName(QString::fromUtf8("textLabel5"));
    textLabel5->setWordWrap(false);

    gridLayout->addWidget(textLabel5, 2, 0, 1, 1);

    FlowTypeComboBox = new QComboBox(groupBox7);
    FlowTypeComboBox->setObjectName(QString::fromUtf8("FlowTypeComboBox"));

    gridLayout->addWidget(FlowTypeComboBox, 2, 1, 1, 1);

    FlowNameLineEdit = new QLineEdit(groupBox7);
    FlowNameLineEdit->setObjectName(QString::fromUtf8("FlowNameLineEdit"));

    gridLayout->addWidget(FlowNameLineEdit, 0, 1, 1, 1);


    hboxLayout1->addLayout(gridLayout);


    vboxLayout->addWidget(groupBox7);

    spacerItem2 = new QSpacerItem(20, 21, QSizePolicy::Minimum, QSizePolicy::Expanding);

    vboxLayout->addItem(spacerItem2);

    hboxLayout3 = new QHBoxLayout();
    hboxLayout3->setSpacing(6);
    hboxLayout3->setObjectName(QString::fromUtf8("hboxLayout3"));
    OkButton = new QPushButton(FlowDescriptionDialog);
    OkButton->setObjectName(QString::fromUtf8("OkButton"));

    hboxLayout3->addWidget(OkButton);

    spacerItem3 = new QSpacerItem(61, 20, QSizePolicy::Expanding, QSizePolicy::Minimum);

    hboxLayout3->addItem(spacerItem3);

    CancelButton = new QPushButton(FlowDescriptionDialog);
    CancelButton->setObjectName(QString::fromUtf8("CancelButton"));

    hboxLayout3->addWidget(CancelButton);


    vboxLayout->addLayout(hboxLayout3);


    hboxLayout->addLayout(vboxLayout);

    textLabel3->setBuddy(FlowNameLineEdit);
    textLabel5->setBuddy(FlowTypeComboBox);
    QWidget::setTabOrder(FlowNameLineEdit, InputRadioButton);
    QWidget::setTabOrder(InputRadioButton, OutputRadioButton);
    QWidget::setTabOrder(OutputRadioButton, FlowTypeComboBox);
    QWidget::setTabOrder(FlowTypeComboBox, OkButton);
    QWidget::setTabOrder(OkButton, CancelButton);

    retranslateUi(FlowDescriptionDialog);
    QObject::connect(InputRadioButton, SIGNAL(clicked()), FlowDescriptionDialog, SLOT(uncheckOutputRadioButton()));
    QObject::connect(OutputRadioButton, SIGNAL(clicked()), FlowDescriptionDialog, SLOT(uncheckInputRadioButton()));
    QObject::connect(FlowNameLineEdit, SIGNAL(textChanged(QString)), FlowDescriptionDialog, SLOT(checkFlowName()));
    QObject::connect(CancelButton, SIGNAL(pressed()), FlowDescriptionDialog, SLOT(reject()));
    QObject::connect(OkButton, SIGNAL(pressed()), FlowDescriptionDialog, SLOT(accept()));

    QMetaObject::connectSlotsByName(FlowDescriptionDialog);
    } // setupUi

    void retranslateUi(QDialog *FlowDescriptionDialog)
    {
    FlowDescriptionDialog->setWindowTitle(QApplication::translate("FlowDescriptionDialog", "Flow Description", 0, QApplication::UnicodeUTF8));
    groupBox7->setTitle(QString());
    InputRadioButton->setText(QApplication::translate("FlowDescriptionDialog", "Input", 0, QApplication::UnicodeUTF8));
    OutputRadioButton->setText(QApplication::translate("FlowDescriptionDialog", "Output", 0, QApplication::UnicodeUTF8));
    textLabel3->setText(QApplication::translate("FlowDescriptionDialog", "Name", 0, QApplication::UnicodeUTF8));
    textLabel4->setText(QApplication::translate("FlowDescriptionDialog", "Direction", 0, QApplication::UnicodeUTF8));
    textLabel5->setText(QApplication::translate("FlowDescriptionDialog", "Type", 0, QApplication::UnicodeUTF8));
    OkButton->setText(QApplication::translate("FlowDescriptionDialog", "&OK", 0, QApplication::UnicodeUTF8));
    OkButton->setShortcut(QApplication::translate("FlowDescriptionDialog", "Alt+O", 0, QApplication::UnicodeUTF8));
    CancelButton->setText(QApplication::translate("FlowDescriptionDialog", "&Cancel", 0, QApplication::UnicodeUTF8));
    CancelButton->setShortcut(QApplication::translate("FlowDescriptionDialog", "Alt+C", 0, QApplication::UnicodeUTF8));
    Q_UNUSED(FlowDescriptionDialog);
    } // retranslateUi

};

namespace Ui {
    class FlowDescriptionDialog: public Ui_FlowDescriptionDialog {};
} // namespace Ui

class FlowDescriptionDialog : public QDialog, public Ui::FlowDescriptionDialog
{
    Q_OBJECT

public:
    FlowDescriptionDialog(QWidget* parent = 0, const char* name = 0, bool modal = false, Qt::WindowFlags fl = 0);
    ~FlowDescriptionDialog();

    virtual void init();
    virtual void setBaseName( QString name );

public slots:
    virtual void checkFlowName();
    virtual void enableOKButton();
    virtual void uncheckInputRadioButton();
    virtual void uncheckOutputRadioButton();
    virtual void accept();

protected:
    bool flowNameOK;
    QString baseName;

    virtual void initFlowList();

protected slots:
    virtual void languageChange();

};

#endif // FLOWDESCRIPTIONDIALOG_H
