/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
#include "ClientDescGen.h"

#include <QtCore/QDir>
#include <QtGui/QMessageBox>

#include <iostream>
using namespace std;

void FlowDescriptionDialog::checkFlowName()
{
    if ( (FlowNameLineEdit->text()).isEmpty() ) {
		flowNameOK = false;
    }	
    else {
		flowNameOK = true;
    }
    enableOKButton();
}


void FlowDescriptionDialog::init()
{
    flowNameOK = false;
    
    baseName = "";
    
    QRegExp rxFlowName( "\\w+$" );
    QValidator* validatorFlowName = new QRegExpValidator( rxFlowName, this );
    FlowNameLineEdit->setValidator( validatorFlowName );
	
	FlowTypeComboBox->setEditable (true);
	FlowTypeComboBox->setValidator( validatorFlowName );
	
    initFlowList();
    
    enableOKButton();
}


void FlowDescriptionDialog::enableOKButton()
{
    if ( flowNameOK )
		OkButton->setEnabled(true);
    else
		OkButton->setEnabled(false);
}




void FlowDescriptionDialog::uncheckInputRadioButton()
{
    InputRadioButton->setChecked(false);
}


void FlowDescriptionDialog::uncheckOutputRadioButton()
{
    OutputRadioButton->setChecked(false);
}


void FlowDescriptionDialog::initFlowList()
{
    QDir flowDirectory(getenv("SF2_ROOT"));
    flowDirectory.cd("lib"); flowDirectory.cd("flows");
#ifdef ON_MAC
	QRegExp rxp( "\(\\.\\d+)*\\.dylib$", true, false );
#endif
#ifdef ON_LINUX
	QRegExp rxp( "\(\\.\\d+)*\\.so$", true, false );
#endif
#ifdef ON_WINDOWS
	QRegExp rxp( "\(\\.\\d+)*\\.dll$", true, false );
#endif
    for ( unsigned int i = 0; i < flowDirectory.count(); i++ ) {
		rxp.indexIn(flowDirectory[i]);
		//cout << "str=" << flowDirectory[i].toStdString() << " pos=" << rxp.pos(0) << endl;
		int pos = rxp.pos(0);
		if ( pos != -1 ) {
			QString tmp =  flowDirectory[i];
			tmp.remove(rxp);
#ifdef ON_MAC
			tmp.remove(0,3);
#endif
#ifdef ON_LINUX
			tmp.remove(0,3);
#endif
			//cout << tmp.toStdString() << endl; 
			if ( FlowTypeComboBox->findText(tmp) == -1 )
				FlowTypeComboBox->insertItem(tmp);
		}
    }
}


void FlowDescriptionDialog::accept()
{
    if ( ((ClientDescGen *) parent())->flowNameExists(FlowNameLineEdit->text()) && FlowNameLineEdit->text() != baseName )
		QMessageBox:: warning(this, tr("Attention"), 
							  tr("This flow name already exists. Each flow needs to have a different name."),	
							  tr("Ok"));
    else
		QDialog::accept();
    
}


void FlowDescriptionDialog::setBaseName( QString name )
{
    baseName = name;
}
