#ifndef _ADDCLIENTTOOL_H
#define _ADDCLIENTTOOL_H

#include "AddClientToolBase.h"
#include "model/GlobalCC.h"
#include "model/Client.h"

#include <QtGui/QWidget>
#include <QtGui/QToolButton>

#include <set>

class ClientToolButton;

class AddClientTool : public AddClientToolBase {
	Q_OBJECT 
public:
	AddClientTool( QWidget* parent, const char* name = 0 ,bool modal = FALSE, Qt::WFlags fl = 0 );
	~AddClientTool();
	
	void initToolButton();
	void unToogleButtons();
	void deleteButtonList(); 
	ClientToolButton* getCurrentButton() { return current; }
	
protected slots:
	void setCurrentClient(ClientToolButton *c);
	void reject();
	
signals:
	void deleteSignal();
	
private:
	ClientToolButton *current; 
	std::set<ClientToolButton *> buttonList;
};

class ClientToolButton : public QToolButton {
	Q_OBJECT
public:
	ClientToolButton(ClientConf *cc, QWidget * parent, const char * name = 0 );
	
	ClientConf* getModel();
	
signals:
	void clicked(ClientToolButton *);
	
public slots:    
	void emitTheClick();
	
private:
		ClientConf *model;
};

#endif // _ADDCLIENTDIALOG_H
