#include "ApplicationMonitorBase.h"

#include <QtCore/QVariant>
#include <QtGui/QPixmap>

/*
 *  Constructs a ApplicationMonitorBase as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 */
ApplicationMonitorBase::ApplicationMonitorBase(QWidget* parent, const char* name, Qt::WindowFlags fl)
    : QWidget(parent, name, fl)
{
    setupUi(this);

}

/*
 *  Destroys the object and frees any allocated resources
 */
ApplicationMonitorBase::~ApplicationMonitorBase()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void ApplicationMonitorBase::languageChange()
{
    retranslateUi(this);
}

void ApplicationMonitorBase::refreshServerView()
{
    qWarning("ApplicationMonitorBase::refreshServerView(): Not implemented yet");
}

void ApplicationMonitorBase::refreshClientView()
{
    qWarning("ApplicationMonitorBase::refreshClientView(): Not implemented yet");
}

void ApplicationMonitorBase::refreshFlowView()
{
    qWarning("ApplicationMonitorBase::refreshFlowView(): Not implemented yet");
}

