#ifndef APPLICATIONMONITORBASE_H
#define APPLICATIONMONITORBASE_H

#include <QtCore/QVariant>
#include <QtGui/QTreeWidget>
#include <QtGui/QHeaderView>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QHBoxLayout>
#include <QtGui/QTabWidget>
#include <QtGui/QWidget>

class Ui_ApplicationMonitorBase
{
public:
    QHBoxLayout *hboxLayout;
    QTabWidget *monitorTabWidget;
    QWidget *serversTab;
    QHBoxLayout *hboxLayout1;
    QTreeWidget *serverListView;
    QWidget *clientsTab;
    QHBoxLayout *hboxLayout2;
	QTreeWidget *clientListView;
    QWidget *flowsTab;
    QHBoxLayout *hboxLayout3;
    QTreeWidget *flowListView;

    void setupUi(QWidget *ApplicationMonitorBase)
    {
    if (ApplicationMonitorBase->objectName().isEmpty())
        ApplicationMonitorBase->setObjectName(QString::fromUtf8("ApplicationMonitorBase"));
    ApplicationMonitorBase->resize(314, 435);
    hboxLayout = new QHBoxLayout(ApplicationMonitorBase);
    hboxLayout->setSpacing(6);
    hboxLayout->setMargin(0);
    hboxLayout->setObjectName(QString::fromUtf8("hboxLayout"));
    monitorTabWidget = new QTabWidget(ApplicationMonitorBase);
    monitorTabWidget->setObjectName(QString::fromUtf8("monitorTabWidget"));
    monitorTabWidget->setTabShape(QTabWidget::Rounded);
    serversTab = new QWidget();
    serversTab->setObjectName(QString::fromUtf8("serversTab"));
    hboxLayout1 = new QHBoxLayout(serversTab);
    hboxLayout1->setSpacing(6);
    hboxLayout1->setMargin(11);
    hboxLayout1->setObjectName(QString::fromUtf8("hboxLayout1"));
    
	QStringList theLabel;
	theLabel << "Name";
	
	serverListView = new QTreeWidget(serversTab);
	serverListView->setColumnCount(1);
	serverListView->setHeaderLabels(theLabel);
	serverListView->header()->setMovable(false);
	serverListView->header()->setResizeMode(0, QHeaderView::Stretch);

    hboxLayout1->addWidget(serverListView);

    monitorTabWidget->addTab(serversTab, QString());
    clientsTab = new QWidget();
    clientsTab->setObjectName(QString::fromUtf8("clientsTab"));
    hboxLayout2 = new QHBoxLayout(clientsTab);
    hboxLayout2->setSpacing(6);
    hboxLayout2->setMargin(11);
    hboxLayout2->setObjectName(QString::fromUtf8("hboxLayout2"));
    
	clientListView = new QTreeWidget(clientsTab);
	clientListView->setColumnCount(1);
	clientListView->setHeaderLabels(theLabel);
	clientListView->header()->setMovable(false);
	clientListView->header()->setResizeMode(0, QHeaderView::Stretch);
	
    hboxLayout2->addWidget(clientListView);

    monitorTabWidget->addTab(clientsTab, QString());
    flowsTab = new QWidget();
    flowsTab->setObjectName(QString::fromUtf8("flowsTab"));
    hboxLayout3 = new QHBoxLayout(flowsTab);
    hboxLayout3->setSpacing(6);
    hboxLayout3->setMargin(11);
    hboxLayout3->setObjectName(QString::fromUtf8("hboxLayout3"));
    
	flowListView = new QTreeWidget(flowsTab);
	flowListView->setColumnCount(3);
	QStringList theFLabel;
	theFLabel << "Name" << "Type" << "ID";
	flowListView->setHeaderLabels(theFLabel);
	flowListView->header()->setMovable(false);
	flowListView->header()->setResizeMode(0, QHeaderView::Interactive);
    flowListView->header()->setResizeMode(1, QHeaderView::Interactive);
	flowListView->header()->setResizeMode(2, QHeaderView::Interactive);

    hboxLayout3->addWidget(flowListView);

    monitorTabWidget->addTab(flowsTab, QString());

    hboxLayout->addWidget(monitorTabWidget);


    retranslateUi(ApplicationMonitorBase);

    QMetaObject::connectSlotsByName(ApplicationMonitorBase);
    } // setupUi

    void retranslateUi(QWidget *ApplicationMonitorBase)
    {
    ApplicationMonitorBase->setWindowTitle(QApplication::translate("ApplicationMonitorBase", "Application Monitor", 0, QApplication::UnicodeUTF8));
    ApplicationMonitorBase->setProperty("whatsThis", QVariant(QApplication::translate("ApplicationMonitorBase", "This window is used to see the clients, servers and flows used in the application", 0, QApplication::UnicodeUTF8)));
    monitorTabWidget->setProperty("whatsThis", QVariant(QApplication::translate("ApplicationMonitorBase", "This window is used to see the clients, servers and flows used in the application", 0, QApplication::UnicodeUTF8)));
    //serverListView->header()->setLabel(0, QApplication::translate("ApplicationMonitorBase", "Name", 0, QApplication::UnicodeUTF8));
    monitorTabWidget->setTabText(monitorTabWidget->indexOf(serversTab), QApplication::translate("ApplicationMonitorBase", "Servers", 0, QApplication::UnicodeUTF8));
    //clientListView->header()->setLabel(0, QApplication::translate("ApplicationMonitorBase", "Name", 0, QApplication::UnicodeUTF8));
    monitorTabWidget->setTabText(monitorTabWidget->indexOf(clientsTab), QApplication::translate("ApplicationMonitorBase", "Clients", 0, QApplication::UnicodeUTF8));
    //flowListView->header()->setLabel(0, QApplication::translate("ApplicationMonitorBase", "Name", 0, QApplication::UnicodeUTF8));
    monitorTabWidget->setTabText(monitorTabWidget->indexOf(flowsTab), QApplication::translate("ApplicationMonitorBase", "Flows", 0, QApplication::UnicodeUTF8));
    Q_UNUSED(ApplicationMonitorBase);
    } // retranslateUi

};

namespace Ui {
    class ApplicationMonitorBase: public Ui_ApplicationMonitorBase {};
} // namespace Ui

class ApplicationMonitorBase : public QWidget, public Ui::ApplicationMonitorBase
{
    Q_OBJECT

public:
    ApplicationMonitorBase(QWidget* parent = 0, const char* name = 0, Qt::WindowFlags fl = 0);
    ~ApplicationMonitorBase();

    virtual void refreshServerView();
    virtual void refreshClientView();
    virtual void refreshFlowView();

protected slots:
    virtual void languageChange();

};

#endif // APPLICATIONMONITORBASE_H
