#include "ClientAppEditor.h"
#include "mainwindow.h"

#include <QtGui/QComboBox>
#include <QtGui/QPushButton>
#include <QtGui/QLineEdit>
#include <QtGui/QPixmap>

#include <map>

ClientAppEditor::ClientAppEditor(ClientConf *cc, QWidget* parent, const char* name, bool modal, Qt::WFlags fl) : ClientAppEditorBase(parent, name, modal, fl) {
    cconf = cc;
    capp = 0;
    s  = 0;
    //the name of the client is read only
    clientNameTextLabel->setText(cconf->getName());
    //clientNameLineEdit->setReadOnly ( true );
    //no test about the parameters
    //we have to initialize the server list.
    initServerList();
}

ClientAppEditor::ClientAppEditor(ClientApp *ca, QWidget* parent, const char* name, bool modal, Qt::WFlags fl) : ClientAppEditorBase(parent, name, modal, fl) {
    capp = ca;
    cconf = 0;
    s  = 0;
    //the name of the client is read only
    clientNameTextLabel->setText(capp->getName());
    //clientNameLineEdit->setReadOnly ( true );
    //no test about the parameters
    //we have to initialize the server list.
    initServerList();
    clientServerComboBox->setCurrentText(ca->getServer()->getName());
    clientParametersLineEdit->setText(ca->getParam());
}

ClientAppEditor::~ClientAppEditor() {}

Server* ClientAppEditor::getServer() {
    return s;
}

QString& ClientAppEditor::getParam() {
    return par;
}

void ClientAppEditor::initServerList() {
    clientServerComboBox->clear();
      std::map<unsigned int, Server *>* serverList = MainWindow::instance()->global->getServerList()->getServerList();
    std::map<unsigned int, Server *>::iterator iter;
    for ( iter = serverList->begin(); iter != serverList->end(); iter++ ) {
	clientServerComboBox->insertItem ( QPixmap("images/RegServer.xpm"), iter->second->getName());
    }
}

void ClientAppEditor::enableOkButton() {
    clientOkButton->setEnabled(true);
}

void ClientAppEditor::accept() {
    QString serverName = clientServerComboBox->currentText();
    s = MainWindow::instance()->global->getServerList()->getServer(serverName);
    par = clientParametersLineEdit->text();
    ClientAppEditorBase::accept();
}
