#include "ClientEditorBase.h"

#include <QtCore/QVariant>
#include <QtGui/QPixmap>

/*
 *  Constructs a ClientEditorBase as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  true to construct a modal dialog.
 */
ClientEditorBase::ClientEditorBase(QWidget* parent, const char* name, bool modal, Qt::WindowFlags fl)
    : QDialog(parent, name, modal, fl)
{
    setupUi(this);

}

/*
 *  Destroys the object and frees any allocated resources
 */
ClientEditorBase::~ClientEditorBase()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void ClientEditorBase::languageChange()
{
    retranslateUi(this);
}

void ClientEditorBase::browseClient()
{
    qWarning("ClientEditorBase::browseClient(): Not implemented yet");
}

void ClientEditorBase::checkClient()
{
    qWarning("ClientEditorBase::checkClient(): Not implemented yet");
}

void ClientEditorBase::notApproved()
{
    qWarning("ClientEditorBase::notApproved(): Not implemented yet");
}

void ClientEditorBase::enableOKButton()
{
    qWarning("ClientEditorBase::enableOKButton(): Not implemented yet");
}

