#include "ClientPathEditor.h"

#include <QtCore/QString>
#include <QtGui/QLineEdit>
#include <QtGui/QPushButton>
#include <QtGui/QFileDialog>

ClientPathEditor::ClientPathEditor( ConfigurationClientList* parent, ClientConf *cc) : ClientPathEditorBase(parent, "clientPathEditor", true) {
  theClient = cc;
  clientNameLabel->setText(theClient->getName());
  pathLineEdit->setText(theClient->getPath());
}


ClientPathEditor::~ClientPathEditor() {}
  
QString ClientPathEditor::getNewPath() {
  QString tmp = pathLineEdit->text();
  return tmp;
}
  
void ClientPathEditor::browsePath() {
  QFileDialog dialog(this, "Select Client Executable", "", "Client executable file (*)");
	dialog.setFileMode( QFileDialog::AnyFile );
  QString clientname;
  if ( dialog.exec() == QDialog::Accepted ) {
    clientname = dialog.selectedFile();
    if ( !clientname.isEmpty() ) {   
      pathLineEdit->setText(clientname);
      
    }
  }
}

void ClientPathEditor::pathIsOk(const QString &s) {
  if ( s.isEmpty() )
    okButton->setEnabled(false);
  else
   okButton->setEnabled(true); 
}
