#ifndef CLIENTPATHEDITORBASE_H
#define CLIENTPATHEDITORBASE_H

#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QGroupBox>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QDialog>
#include <QtGui/QGridLayout>
#include <QtGui/QHBoxLayout>
#include <QtGui/QLabel>
#include <QtGui/QLineEdit>
#include <QtGui/QPushButton>
#include <QtGui/QSpacerItem>
#include <QtGui/QToolButton>
#include <QtGui/QVBoxLayout>

class Ui_ClientPathEditorBase
{
public:
    QHBoxLayout *hboxLayout;
    QVBoxLayout *vboxLayout;
    QGroupBox *groupBox3;
    QHBoxLayout *hboxLayout1;
    QGridLayout *gridLayout;
    QLabel *textLabel1;
    QHBoxLayout *hboxLayout2;
    QLineEdit *pathLineEdit;
    QToolButton *browseButton;
    QLabel *textLabel2;
    QLabel *clientNameLabel;
    QSpacerItem *spacerItem;
    QHBoxLayout *hboxLayout3;
    QPushButton *okButton;
    QSpacerItem *spacerItem1;
    QPushButton *cancelButton;
	
    void setupUi(QDialog *ClientPathEditorBase)
    {
		if (ClientPathEditorBase->objectName().isEmpty())
			ClientPathEditorBase->setObjectName(QString::fromUtf8("ClientPathEditorBase"));
		ClientPathEditorBase->resize(400, 158);
		hboxLayout = new QHBoxLayout(ClientPathEditorBase);
		hboxLayout->setSpacing(6);
		hboxLayout->setMargin(11);
		hboxLayout->setObjectName(QString::fromUtf8("hboxLayout"));
		vboxLayout = new QVBoxLayout();
		vboxLayout->setSpacing(6);
		vboxLayout->setObjectName(QString::fromUtf8("vboxLayout"));
		groupBox3 = new QGroupBox(ClientPathEditorBase);
		groupBox3->setObjectName(QString::fromUtf8("groupBox3"));
		QVBoxLayout *theLayout = new QVBoxLayout;
		groupBox3->setLayout(theLayout);
		groupBox3->layout()->setSpacing(6);
		groupBox3->layout()->setMargin(11);
		hboxLayout1 = new QHBoxLayout();
		QBoxLayout *boxlayout = qobject_cast<QBoxLayout *>(groupBox3->layout());
		if (boxlayout)
			boxlayout->addLayout(hboxLayout1);
		hboxLayout1->setAlignment(Qt::AlignTop);
		hboxLayout1->setObjectName(QString::fromUtf8("hboxLayout1"));
		gridLayout = new QGridLayout();
		gridLayout->setSpacing(6);
		gridLayout->setObjectName(QString::fromUtf8("gridLayout"));
		textLabel1 = new QLabel(groupBox3);
		textLabel1->setObjectName(QString::fromUtf8("textLabel1"));
		textLabel1->setWordWrap(false);
		
		gridLayout->addWidget(textLabel1, 0, 0, 1, 1);
		
		hboxLayout2 = new QHBoxLayout();
		hboxLayout2->setSpacing(6);
		hboxLayout2->setObjectName(QString::fromUtf8("hboxLayout2"));
		pathLineEdit = new QLineEdit(groupBox3);
		pathLineEdit->setObjectName(QString::fromUtf8("pathLineEdit"));
		
		hboxLayout2->addWidget(pathLineEdit);
		
		browseButton = new QToolButton(groupBox3);
		browseButton->setObjectName(QString::fromUtf8("browseButton"));
		
		hboxLayout2->addWidget(browseButton);
		
		
		gridLayout->addLayout(hboxLayout2, 1, 1, 1, 1);
		
		textLabel2 = new QLabel(groupBox3);
		textLabel2->setObjectName(QString::fromUtf8("textLabel2"));
		textLabel2->setWordWrap(false);
		
		gridLayout->addWidget(textLabel2, 1, 0, 1, 1);
		
		clientNameLabel = new QLabel(groupBox3);
		clientNameLabel->setObjectName(QString::fromUtf8("clientNameLineEdit"));
		clientNameLabel->setAcceptDrops(false);
		clientNameLabel->setFrameStyle(QFrame::StyledPanel);
		
		gridLayout->addWidget(clientNameLabel, 0, 1, 1, 1);
		
		
		hboxLayout1->addLayout(gridLayout);
		
		
		vboxLayout->addWidget(groupBox3);
		
		spacerItem = new QSpacerItem(20, 31, QSizePolicy::Minimum, QSizePolicy::Expanding);
		
		vboxLayout->addItem(spacerItem);
		
		hboxLayout3 = new QHBoxLayout();
		hboxLayout3->setSpacing(6);
		hboxLayout3->setObjectName(QString::fromUtf8("hboxLayout3"));
		okButton = new QPushButton(ClientPathEditorBase);
		okButton->setObjectName(QString::fromUtf8("okButton"));
		
		hboxLayout3->addWidget(okButton);
		
		spacerItem1 = new QSpacerItem(81, 20, QSizePolicy::Expanding, QSizePolicy::Minimum);
		
		hboxLayout3->addItem(spacerItem1);
		
		cancelButton = new QPushButton(ClientPathEditorBase);
		cancelButton->setObjectName(QString::fromUtf8("cancelButton"));
		
		hboxLayout3->addWidget(cancelButton);
		
		
		vboxLayout->addLayout(hboxLayout3);
		
		
		hboxLayout->addLayout(vboxLayout);
		
		QWidget::setTabOrder(pathLineEdit, okButton);
		QWidget::setTabOrder(okButton, cancelButton);
		QWidget::setTabOrder(cancelButton, clientNameLabel);
		
		retranslateUi(ClientPathEditorBase);
		QObject::connect(okButton, SIGNAL(clicked()), ClientPathEditorBase, SLOT(accept()));
		QObject::connect(cancelButton, SIGNAL(clicked()), ClientPathEditorBase, SLOT(reject()));
		QObject::connect(pathLineEdit, SIGNAL(textChanged(QString)), ClientPathEditorBase, SLOT(pathIsOk(QString)));
		QObject::connect(browseButton, SIGNAL(clicked()), ClientPathEditorBase, SLOT(browsePath()));
		
		QMetaObject::connectSlotsByName(ClientPathEditorBase);
    } // setupUi
	
    void retranslateUi(QDialog *ClientPathEditorBase)
    {
		ClientPathEditorBase->setWindowTitle(QApplication::translate("ClientPathEditorBase", "Client Path Editor", 0, QApplication::UnicodeUTF8));
		groupBox3->setTitle(QApplication::translate("ClientPathEditorBase", "Client", 0, QApplication::UnicodeUTF8));
		textLabel1->setText(QApplication::translate("ClientPathEditorBase", "Name", 0, QApplication::UnicodeUTF8));
		browseButton->setText(QApplication::translate("ClientPathEditorBase", "...", 0, QApplication::UnicodeUTF8));
		browseButton->setText(QApplication::translate("ClientPathEditorBase", "...", 0, QApplication::UnicodeUTF8));
		textLabel2->setText(QApplication::translate("ClientPathEditorBase", "Path", 0, QApplication::UnicodeUTF8));
		okButton->setText(QApplication::translate("ClientPathEditorBase", "&OK", 0, QApplication::UnicodeUTF8));
		okButton->setShortcut(QApplication::translate("ClientPathEditorBase", "Alt+O", 0, QApplication::UnicodeUTF8));
		cancelButton->setText(QApplication::translate("ClientPathEditorBase", "&Cancel", 0, QApplication::UnicodeUTF8));
		cancelButton->setShortcut(QApplication::translate("ClientPathEditorBase", "Alt+C", 0, QApplication::UnicodeUTF8));
		Q_UNUSED(ClientPathEditorBase);
    } // retranslateUi
	
};

namespace Ui {
    class ClientPathEditorBase: public Ui_ClientPathEditorBase {};
} // namespace Ui

class ClientPathEditorBase : public QDialog, public Ui::ClientPathEditorBase
{
    Q_OBJECT
	
public:
    ClientPathEditorBase(QWidget* parent = 0, const char* name = 0, bool modal = false, Qt::WindowFlags fl = 0);
    ~ClientPathEditorBase();
	
	protected slots:
		virtual void languageChange();
	
    virtual void browsePath();
    virtual void pathIsOk( const QString & );
	
	
};

#endif // CLIENTPATHEDITORBASE_H
