#ifndef _CONFIGURATIONCLIENTLIST_H
#define _CONFIGURATIONCLIENTLIST_H

#include "model/Client.h"

#include <QtCore/QVariant>
#include <QtCore/QObject>
#include <QtCore/QPoint>
#include <QtCore/QString>
#include <QtGui/QWidget>
#include <QtGui/QTreeWidget>
#include <QtGui/QToolTip>
#include <QtGui/QMouseEvent>
#include <QtGui/QVBoxLayout>
#include <QtGui/QGridLayout>
#include <QtGui/QHBoxLayout>
#include <QtGui/QPushButton>

class ClientConfListView;
class ClientConfItem;
class ClientConf;


class ConfigurationClientList : public QWidget {
  Q_OBJECT
 public:
  ConfigurationClientList(QWidget* parent = 0, const char* name = 0, Qt::WFlags fl = 0);
  ~ConfigurationClientList();
  
  ClientConfListView* ClientListView;
  QPushButton* AddClientButton;
  QPushButton* DeleteClientButton;

  void disableButtons();
  void refreshClientConfList();
  bool clientExistsInApplication(ClientConf *cc);
  bool clientRunningInApplication(ClientConf *cc);
  void changeClientPathInApplication(ClientConf *cc, QString &newPath);
     
  public slots:
   void contMenu( const QPoint & pos );
   void addClient();
   void deleteClient();
   void editClient();
   void enableButtons(QTreeWidgetItem *item);

 protected:
   QHBoxLayout* ConfigurationClientListBaseLayout;
   QVBoxLayout* layout29;
   QHBoxLayout* layout28;
   QSpacerItem* spacer8;
   
 protected slots:
  virtual void languageChange();
};


class ClientConfListView : public QTreeWidget {
Q_OBJECT    
public:
    ClientConfListView(QWidget * parent = 0);
    ~ClientConfListView();

protected:
    void mousePressEvent( QMouseEvent* event );
    void mouseMoveEvent( QMouseEvent *event);
        
private:
    QPoint dragPos;
    void startDrag();
};


class ClientConfItem : public QTreeWidgetItem {
public:
    ClientConfItem(ClientConf *cl, QTreeWidget *parent, QStringList _name);
    ~ClientConfItem();
    
    ClientConf* getModel();
    
private:
    ClientConf *model;
};

#endif

