#include "ConfigurationServerList.h"
#include "mainwindow.h"

#include <QtGui/QHeaderView>
#include <QtGui/QAction>
#include <QtGui/QIcon>
#include <QtGui/QApplication>
#include <QtGui/QMenu>
#include <QtGui/QContextMenuEvent>
#include <QtCore/QString>

#include <map>

using namespace std;

ConfigurationServerList::ConfigurationServerList(QWidget* parent, const char* name, Qt::WFlags fl) : QWidget(parent, name, fl){
	setupUi(this);
}

ConfigurationServerList::~ConfigurationServerList(){}

void ConfigurationServerList::refreshServerList() {
    serverListView->clear();
    std::map<unsigned int, Server *>* serverList = MainWindow::instance()->global->getServerList()->getServerList();
    std::map<unsigned int, Server *>::iterator iter;
	QList<QTreeWidgetItem *> items;
    for ( iter = serverList->begin(); iter != serverList->end(); iter++ ) {
		if ( iter->second->getName() != "No Server" ) {
			iter->second->initTreeWidgetItem(serverListView);
			items.append(iter->second->getServerViewItem());
		}
    }
	serverListView->insertTopLevelItems(0, items);
}

void ConfigurationServerList::contMenu(const QPoint &p) {
	ServerItem *si = (ServerItem *)(serverListView->itemAt(p));
	if ( si ) {
		QMenu *menu = new QMenu();
		//menu->popup(mapToGlobal(p));
		menu->popup(QCursor::pos());
		menu->insertItem(tr("&Show Log..."), this, SLOT(viewLogAction()));
	}
}

void ConfigurationServerList::viewLogAction() {
	ServerItem *si = (ServerItem *)(serverListView->currentItem());
	if ( si ) {
		Server *s = si->getModel();
		if ( s ) {
			MainWindow::instance()->viewLog();
			MainWindow::instance()->logView->setServerTab(s->getId());
		}
	}
	
}

void ConfigurationServerList::showLogOnClick(QTreeWidgetItem*, int) {
  ServerItem *si = (ServerItem *)(serverListView->currentItem());
  if ( si ) {
		Server *s = si->getModel();
		if ( s ) {
			MainWindow::instance()->logView->setServerTab(s->getId());
		}
   }
}

void ConfigurationServerList::languageChange()
{
    retranslateUi(this);
}

/**********************************/

ServerItem::ServerItem(Server *s, QTreeWidget *parent, QStringList sList) : QTreeWidgetItem(parent, sList) {   
	model = s;
	setIcon(0, QIcon(":/images/RegServer.xpm"));
}

ServerItem::~ServerItem() {}

Server* ServerItem::getModel() { return model; }

/**********************************/

void Ui_ConfigurationServerList::setupUi(QWidget *ConfigurationServerList)
{
    if (ConfigurationServerList->objectName().isEmpty())
        ConfigurationServerList->setObjectName(QString::fromUtf8("ConfigurationServerList"));
    ConfigurationServerList->resize(355, 389);
    hboxLayout = new QHBoxLayout(ConfigurationServerList);
    hboxLayout->setSpacing(6);
    hboxLayout->setMargin(0);
    hboxLayout->setObjectName(QString::fromUtf8("hboxLayout"));
    vboxLayout = new QVBoxLayout();
    vboxLayout->setSpacing(6);
    vboxLayout->setObjectName(QString::fromUtf8("vboxLayout"));
	
	serverListView = new QTreeWidget(ConfigurationServerList);
	serverListView->setColumnCount(1);
	QStringList theLabel;
	theLabel << "Host Name" << "OS";
	serverListView->setHeaderLabels(theLabel);
	serverListView->header()->setMovable(false);
	serverListView->header()->setResizeMode(0, QHeaderView::Interactive);
    serverListView->header()->setResizeMode(1, QHeaderView::Interactive);
	serverListView->setRootIsDecorated ( false );
	
    vboxLayout->addWidget(serverListView);
	
    hboxLayout->addLayout(vboxLayout);
	
    retranslateUi(ConfigurationServerList);
	
	serverListView->setContextMenuPolicy(Qt::CustomContextMenu);
	
    QObject::connect(serverListView, SIGNAL(customContextMenuRequested(const QPoint&)), ConfigurationServerList, SLOT(contMenu(const QPoint &)));
	QObject::connect(serverListView, SIGNAL(itemClicked(QTreeWidgetItem*, int)), ConfigurationServerList, SLOT(showLogOnClick(QTreeWidgetItem*, int)));
    QMetaObject::connectSlotsByName(ConfigurationServerList);
} // setupUi

void Ui_ConfigurationServerList::retranslateUi(QWidget *ConfigurationServerList)
{
    ConfigurationServerList->setWindowTitle(QApplication::translate("ConfigurationServerList", "Server List", 0, QApplication::UnicodeUTF8));
    Q_UNUSED(ConfigurationServerList);
} // retranslateUi


