#ifndef _CONFIGURATIONSERVERLIST_H
#define _CONFIGURATIONSERVERLIST_H

#include <QtCore/QObject>
#include <QtCore/QVariant>
#include <QtGui/QTreeWidget>
#include <QtGui/QHBoxLayout>
#include <QtGui/QVBoxLayout>
#include <QtCore/QStringList>
#include <QtGui/QTreeWidgetItem>
#include <QtGui/QWidget>

#include "model/Server.h"

class Ui_ConfigurationServerList
{
public:
    QHBoxLayout *hboxLayout;
    QVBoxLayout *vboxLayout;
	QTreeWidget *serverListView;
	
    void setupUi(QWidget *ConfigurationServerList);
	
    void retranslateUi(QWidget *ConfigurationServerList);
};

namespace Ui {
    class ConfigurationServerList: public Ui_ConfigurationServerList {};
} // namespace Ui

class ConfigurationServerList : public QWidget, public Ui::ConfigurationServerList {
	Q_OBJECT
public:
	ConfigurationServerList(QWidget* parent = 0, const char* name = 0, Qt::WFlags fl = 0);
	~ConfigurationServerList();
	
	void refreshServerList();

public slots:
	void contMenu(const QPoint &);
	void viewLogAction();
	void showLogOnClick(QTreeWidgetItem*, int);
		
protected slots:
	virtual void languageChange();
	
};    

class ServerItem : public QTreeWidgetItem {
public:
    ServerItem(Server *s, QTreeWidget *parent, QStringList sList);
    ~ServerItem();
    
    Server* getModel();

private:
   Server *model;
};

#endif
