#include "FlowInformation.h"

#include <QtGui/QLineEdit>

FlowInformation::FlowInformation(Flow *f, QWidget* parent, const char* name, bool modal, Qt::WFlags fl) : FlowInformationBase(parent, name, modal, fl) {
	if ( f ) {
		nameLineEdit->setText(f->getOutletOut()->getName());
		typeLineEdit->setText(f->getDataType());
		groupLineEdit->setText(f->getOutletOut()->getGroup());
		nameLineEdit->setReadOnly(true);
		typeLineEdit->setReadOnly(true);
		groupLineEdit->setReadOnly(true);
	}
}

FlowInformation::FlowInformation(FlowOutlet *f, QWidget* parent, const char* name, bool modal, Qt::WFlags fl) : FlowInformationBase(parent, name, modal, fl) {
	if ( f ) {
		nameLineEdit->setText(f->getName());
		typeLineEdit->setText(f->getDataType());
		groupLineEdit->setText(f->getGroup());
		nameLineEdit->setReadOnly(true);
		typeLineEdit->setReadOnly(true);
		groupLineEdit->setReadOnly(true);
	}
}

FlowInformation::~FlowInformation() {}
