#ifndef _LOGVIEW_H
#define _LOGVIEW_H

#include "LogViewBase.h"

#include <QtGui/QWidget>
#include <QtCore/QString>

#include <map>

class ClientLogTab;
class ServerList;
class ServerLogTab;
class DuplicatorLogTab;

class LogView : public LogViewBase { 
    Q_OBJECT
	
public:
    LogView( QWidget* parent = 0, const char* name = 0, Qt::WFlags fl = 0 );
    ~LogView();
	
    bool addClientTab(unsigned int clientID);
    bool removeClientTab(unsigned int clientID);
    void setClientTab(unsigned int clientID);
	
    void addLogForClient(unsigned int clientID, QString &l);
    void clearClientLog(unsigned int clientID);
    void removeAllClientTab();
	
    bool addServerTab(ServerList *sl, unsigned int serverID);
    bool removeServerTab(unsigned int serverID);
    void setServerTab(unsigned int serverID);
	
    void addLogForServer(unsigned int serverID, QString &l);
    void clearServerLog(unsigned int serverID);
    void removeAllServerTab();
	
    bool addDuplicatorTab(unsigned int dupID);
    bool removeDuplicatorTab(unsigned int dupID);
    void setDuplicatorTab(unsigned int dupID);
	
    void addLogForDuplicator(unsigned int dupID, QString &l);
    void clearDuplicatorLog(unsigned int dupID);
    void removeAllDuplicatorTab();
	
	ServerLogTab* findServerTab(QString &sname, int &sid);
	
    void removeAllTab();
	
	QString getLogDir();
	void setLogDir(QString dir);
	
protected:
	std::map<unsigned int, ClientLogTab *> client_tabs;	
    std::map<unsigned int, ServerLogTab *> server_tabs;	
	std::map<unsigned int, DuplicatorLogTab *> duplicator_tabs;
	
	QString logDir;
	
protected slots:
	virtual void languageChange();
	
};

#endif // _LOGVIEW_H
