#ifndef LOGVIEWBASE_H
#define LOGVIEWBASE_H

#include <QtCore/QVariant>
#include <QtGui/QApplication>
#include <QtGui/QHBoxLayout>
#include <QtGui/QTabWidget>
#include <QtGui/QWidget>
#include <QtGui/QDialog>

#define TAB_SERVER 0
#define TAB_CLIENT 1
#define TAB_DUPLI 2

class Ui_LogViewBase
{
public:
    QHBoxLayout * LogViewBaseLayout;
    QTabWidget *tabWidget_out;
    QTabWidget *tabWidget_clients;
    QTabWidget *tabWidget_servers;
    QTabWidget *tabWidget_duplicators;
	
    QWidget *tab_clients;
    QWidget *tab_servers;
    QWidget *tab_duplicators;
	
	
    QHBoxLayout* LogViewLayout_clients;
    QHBoxLayout* LogViewLayout_servers;
    QHBoxLayout* LogViewLayout_duplicators;
	
    void setupUi(QWidget *LogViewBase)
    {
		if ( LogViewBase->objectName().isEmpty() )
			LogViewBase->setName(QString::fromUtf8("LogViewBase"));
		LogViewBaseLayout = new QHBoxLayout(LogViewBase, 0, 2, "LogViewBaseLayout"); 
		//setPaletteBackgroundColor( QColor( 255, 255, 255 ) );
		
		tabWidget_out = new QTabWidget( LogViewBase, QString::fromUtf8("tabWidget") );
		LogViewBaseLayout->addWidget( tabWidget_out );
		
		tab_clients = new QWidget();
		tab_clients->setObjectName(QString::fromUtf8("Clients"));
		tabWidget_out->insertTab(TAB_CLIENT, tab_clients, QString::fromUtf8("Clients"));
		
		LogViewLayout_clients =  new QHBoxLayout( tab_clients, 0, 2, "LogViewLayout_clients");
		
		tab_servers = new QWidget();
		tab_servers->setObjectName(QString::fromUtf8("Servers"));
		tabWidget_out->insertTab(TAB_SERVER, tab_servers, QString::fromUtf8("Servers"));
		
		LogViewLayout_servers =  new QHBoxLayout( tab_servers, 0, 2, "LogViewLayout_servers");
		
		tab_duplicators = new QWidget();
		tab_duplicators->setObjectName(QString::fromUtf8("Duplicators"));
		tabWidget_out->insertTab(TAB_DUPLI, tab_duplicators, QString::fromUtf8("Duplicators"));
		
		LogViewLayout_duplicators =  new QHBoxLayout( tab_duplicators, 0, 2, "LogViewLayout_duplicators");
		
		tabWidget_clients = new QTabWidget(tab_clients);
		tabWidget_servers = new QTabWidget(tab_servers);
		tabWidget_duplicators = new QTabWidget(tab_duplicators);
		
		LogViewLayout_clients->addWidget( tabWidget_clients );
		LogViewLayout_servers->addWidget( tabWidget_servers );
		LogViewLayout_duplicators->addWidget( tabWidget_duplicators );
		
		tabWidget_clients->setElideMode(Qt::ElideNone);
		tabWidget_clients->setUsesScrollButtons ( true );
		tabWidget_servers->setElideMode (Qt::ElideNone);
		tabWidget_servers->setUsesScrollButtons ( true );
		tabWidget_duplicators->setElideMode(Qt::ElideNone);
		tabWidget_duplicators->setUsesScrollButtons ( true );
		
		LogViewBase->resize( QSize(600, 480).expandedTo(LogViewBase->minimumSizeHint()) );
		
		retranslateUi(LogViewBase);
		
		QMetaObject::connectSlotsByName(LogViewBase);
    } // setupUi
	
    void retranslateUi(QWidget *LogViewBase)
    {
		LogViewBase->setWindowTitle(QApplication::translate("LogViewBase", "Logs", 0, QApplication::UnicodeUTF8));
		Q_UNUSED(LogViewBase);
    } // retranslateUi
	
};

namespace Ui {
    class LogViewBase: public Ui_LogViewBase {};
} // namespace Ui

class LogViewBase : public QDialog, public Ui::LogViewBase
{
    Q_OBJECT
	
public:
    LogViewBase(QWidget* parent = 0, const char* name = 0, Qt::WindowFlags fl = 0);
    ~LogViewBase();
	
protected slots:
	virtual void languageChange();
	
};

#endif // LOGVIEWBASE_H
