#ifndef _FLOWGEN_H
#define _FLOWGEN_H

#include "flowgenBase.h"

#include <QtGui/QWidget>
#include <QtGui/QCloseEvent>

class FlowGen : public flowgenBase {
	Q_OBJECT
public:
    FlowGen( QWidget* parent = 0, const char* name = 0, Qt::WFlags fl = Qt::WType_TopLevel );
	~FlowGen();
	
	void loadFile(QString &s);
	void initAll();
	
public slots:
	virtual void fileNew();
    virtual void fileOpen();
    virtual void fileSave();
    virtual void fileSaveAs();
    virtual void fileExit();
    virtual void tools_Build_Flow_Library();
    virtual void tools_Generate_Code();
    virtual void helpAbout();
    virtual void checkClassName();
    virtual void checkDesc();
    virtual void checkBufferSize();
    virtual void checkHistorySize();
    virtual void checkSpecificMethods();
    virtual void checkIncludes();
    virtual void closeEvent(QCloseEvent *e);
	
private:
	void enableGeneration();
    void clearAllFields();
    void initAllFields();
};

#endif

