#ifndef _FLOWTYPEMODEL_H
#define _FLOWTYPEMODEL_H

#include <QtCore/QString>
#include <QtCore/QStringList>
#include "../xmlwriter/xmlwriter.h"

class FlowTypeModel {
public:
	FlowTypeModel();
	~FlowTypeModel();
	
	void setDescription(QString _desc);
	void setClassName(QString _class);
	void setBufferSize(QString _bsize);
	void setHistorySize(QString _hsize);
	void setSpecificMethods(QString _methods);
	void setIncludes(QString _includes);
	void setBaseName(QString &_baseName);
	
	QString& getDescription();
	QString& getClassName();
	QString& getBufferSize();
	QString& getHistorySize();
	QStringList& getSpecificMethods();
	QStringList& getIncludes();
	QString& getBaseName();
	
	QStringList splitMethod(QString &method);
	
	bool readFlowFile(QString &filename);
	bool writeFlowFile(QString &filename);
	
	bool generateCode();
	
	void printModel();
	
private:
	QString className;
	QString description;
	QString bufferSize;
	QString historySize;
	QStringList specificMethods;
	QStringList includes;
	QString baseName;
	
	void writeFlow(XmlWriter *xw, QString &type, QString &description, QString &bufferSize, QString &historySize);
	void writeIncludes(XmlWriter *xw);	
	void writeMethods(XmlWriter *xw);	   
};

#endif
