//========================= Official Notice ===============================
//
// "This software was developed at the National Institute of Standards
// and Technology by employees of the Federal Government in the course of
// their official duties. Pursuant to Title 17 Section 105 of the United
// States Code this software is not subject to copyright protection and
// is in the public domain.
//
// The NIST Data Flow System (NDFS) is an experimental system and is
// offered AS IS. NIST assumes no responsibility whatsoever for its use
// by other parties, and makes no guarantees and NO WARRANTIES, EXPRESS
// OR IMPLIED, about its quality, reliability, fitness for any purpose,
// or any other characteristic.
//
// We would appreciate acknowledgement if the software is used.
//
// This software can be redistributed and/or modified freely provided
// that any derivative works bear some notice that they are derived from
// it, and any modified versions bear some notice that they have been
// modified from the original."
//
//=========================================================================



#ifndef _GENERATE_H
#define _GENERATE_H

#include <QtCore/QString>
#include <QtCore/QTextStream>
#include <QtCore/QFile>

class FlowTypeModel;

class Generate {
public:
	Generate(FlowTypeModel *_model, QString basename, const char* ext, bool overwriteFile);
	virtual ~Generate();
	
protected:
	FlowTypeModel *model;
	void write(const char* str);
	void writeLine(const char* str);
	void write(const char* str, QString &arg);
	void writeLine(const char* str, QString &arg);
	void write(const char* str, QString &arg1, QString &arg2);
	void writeLine(const char* str, QString &arg1, QString &arg2);
	void write(const char* str, QString &arg1, QString &arg2, QString &arg3);
	void writeLine(const char* str, QString &arg1, QString &arg2, QString &arg3);
	void write(const char* str, QString &arg1, QString &arg2, QString &arg3, QString &arg4);
	void writeLine(const char* str, QString &arg1, QString &arg2, QString &arg3, QString &arg4);
	void newLine();
	
protected:
	QFile *theFile;
	QTextStream *stream;
	bool needGeneration;
};

class Generate_H : public Generate {
public:
	Generate_H(class FlowTypeModel *_model, QString basename);
	virtual ~Generate_H();
	
	bool generate_code_H();
	
private:
	QString includeName;
};

class Generate_CPP : public Generate {
public:
	Generate_CPP(class FlowTypeModel *_model, QString basename);
	virtual ~Generate_CPP();
	
	bool generate_code_CPP();
	
private:
	QString includeName;
};

class Generate_functions_CPP : public Generate {
public:
	Generate_functions_CPP(class FlowTypeModel *_model, QString basename);
	virtual ~Generate_functions_CPP();
	
	bool generate_code_functions_CPP();
	
private:
	QString includeName;
};

class Generate_PRO : public Generate {
public:
	Generate_PRO(class FlowTypeModel *_model, QString basename);
	virtual ~Generate_PRO();
	
	bool generate_code_PRO();
};

#endif
