#include "flowgenBase.h"

/*
 *  Constructs a flowgenBase as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 *
 */
flowgenBase::flowgenBase(QWidget* parent, const char* name, Qt::WindowFlags fl)
: QMainWindow(parent, name, fl)
{
    setupUi(this);
	
    (void)statusBar();
}

/*
 *  Destroys the object and frees any allocated resources
 */
flowgenBase::~flowgenBase()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void flowgenBase::languageChange()
{
    retranslateUi(this);
}

void flowgenBase::fileNew()
{
    qWarning("flowgenBase::fileNew(): Not implemented yet");
}

void flowgenBase::fileOpen()
{
    qWarning("flowgenBase::fileOpen(): Not implemented yet");
}

void flowgenBase::fileSave()
{
    qWarning("flowgenBase::fileSave(): Not implemented yet");
}

void flowgenBase::fileSaveAs()
{
    qWarning("flowgenBase::fileSaveAs(): Not implemented yet");
}

void flowgenBase::filePrint()
{
    qWarning("flowgenBase::filePrint(): Not implemented yet");
}

void flowgenBase::fileExit()
{
    qWarning("flowgenBase::fileExit(): Not implemented yet");
}

void flowgenBase::tools_Build_Flow_Library()
{
    qWarning("flowgenBase::tools_Build_Flow_Library(): Not implemented yet");
}

void flowgenBase::tools_Generate_Code()
{
    qWarning("flowgenBase::tools_Generate_Code(): Not implemented yet");
}

void flowgenBase::helpAbout()
{
    qWarning("flowgenBase::helpAbout(): Not implemented yet");
}

void flowgenBase::checkClassName()
{
    qWarning("flowgenBase::checkClassName(): Not implemented yet");
}

void flowgenBase::checkDesc()
{
    qWarning("flowgenBase::checkDesc(): Not implemented yet");
}

void flowgenBase::checkBufferSize()
{
    qWarning("flowgenBase::checkBufferSize(): Not implemented yet");
}

void flowgenBase::checkHistorySize()
{
    qWarning("flowgenBase::checkHistorySize(): Not implemented yet");
}

void flowgenBase::checkSpecificMethods()
{
    qWarning("flowgenBase::checkSpecificMethods(): Not implemented yet");
}

void flowgenBase::checkIncludes()
{
    qWarning("flowgenBase::checkIncludes(): Not implemented yet");
}

void flowgenBase::closeEvent( QCloseEvent *)
{
    qWarning("flowgenBase::closeEvent( QCloseEvent *): Not implemented yet");
}

