#ifndef FLOWGENBASE_H
#define FLOWGENBASE_H

#include "FlowTypeModel.h"

#include <QtCore/QDir>
#include <QtCore/QStringRef>
#include <QtGui/QGroupBox>
#include <QtGui/QMainWindow>
#include <QtGui/QTextEdit>
#include <QtGui/QToolBar>
#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QGridLayout>
#include <QtGui/QHBoxLayout>
#include <QtGui/QLabel>
#include <QtGui/QLineEdit>
#include <QtGui/QMenu>
#include <QtGui/QMenuBar>
#include <QtGui/QVBoxLayout>
#include <QtGui/QWidget>

class Ui_flowgenBase
{
public:
    QAction *fileNewAction;
    QAction *fileOpenAction;
    QAction *fileSaveAction;
    QAction *fileSaveAsAction;
    QAction *fileExitAction;
    QAction *helpAboutAction;
    QAction *toolsGenerate_CodeAction;
    QAction *toolsBuild_Flow_libraryAction;
    QWidget *widget;
    QHBoxLayout *hboxLayout;
    QVBoxLayout *vboxLayout;
    QGroupBox *groupBox2;
    QVBoxLayout *vboxLayout1;
    QGridLayout *gridLayout;
    QLineEdit *flowClassName;
    QLabel *textLabel5;
    QLabel *textLabel3;
    QLabel *textLabel2;
    QLineEdit *historySize;
    QLineEdit *bufferSize;
    QLineEdit *flowDesc;
    QLabel *textLabel1;
    QGroupBox *groupBox1;
    QHBoxLayout *hboxLayout1;
    QVBoxLayout *vboxLayout2;
    QGroupBox *groupBox6;
    QHBoxLayout *hboxLayout2;
    QVBoxLayout *vboxLayout3;
    QLabel *textLabel1_2;
    QTextEdit *includeTextEdit;
    QGroupBox *groupBox5;
    QHBoxLayout *hboxLayout3;
    QVBoxLayout *vboxLayout4;
    QLabel *textLabel4;
    QTextEdit *methodTextEdit;
    QToolBar *toolBar;
    QToolBar *Toolbar;
	
    QMenu *fileMenu;
    QMenu *Tools;
    QMenu *helpMenu;
	
    void setupUi(QMainWindow *flowgenBase)
    {
		if (flowgenBase->objectName().isEmpty())
			flowgenBase->setObjectName(QString::fromUtf8("flowgenBase"));
		flowgenBase->resize(511, 578);
		
		fileNewAction = new QAction(flowgenBase);
		fileNewAction->setObjectName(QString::fromUtf8("fileNewAction"));
		fileNewAction->setName("fileNewAction");
		fileNewAction->setIcon(QIcon(":/images/fileNew.xpm"));
		fileOpenAction = new QAction(flowgenBase);
		fileOpenAction->setObjectName(QString::fromUtf8("fileOpenAction"));
		fileOpenAction->setName("fileOpenAction");
		fileOpenAction->setIcon(QIcon(":/images/fileOpen.xpm"));
		fileSaveAction = new QAction(flowgenBase);
		fileSaveAction->setObjectName(QString::fromUtf8("fileSaveAction"));
		fileSaveAction->setName("fileSaveAction");
		fileSaveAction->setIcon(QIcon(":/images/fileSave.xpm"));
		fileSaveAsAction = new QAction(flowgenBase);
		fileSaveAsAction->setObjectName(QString::fromUtf8("fileSaveAsAction"));
		fileSaveAsAction->setName("fileSaveAsAction");
		fileSaveAsAction->setIcon(QIcon(":/images/fileSaveAs.xpm"));
		fileExitAction = new QAction(flowgenBase);
		fileExitAction->setObjectName(QString::fromUtf8("fileExitAction"));
		fileExitAction->setName("fileExitAction");
		helpAboutAction = new QAction(flowgenBase);
		helpAboutAction->setObjectName(QString::fromUtf8("helpAboutAction"));
		helpAboutAction->setName("helpAboutAction");
		toolsGenerate_CodeAction = new QAction(flowgenBase);
		toolsGenerate_CodeAction->setObjectName(QString::fromUtf8("toolsGenerate_CodeAction"));
		toolsGenerate_CodeAction->setName("toolsGenerate_CodeAction");
		toolsGenerate_CodeAction->setEnabled(false);
		toolsGenerate_CodeAction->setIcon(QIcon(":/images/generateCode.xpm"));
		toolsBuild_Flow_libraryAction = new QAction(flowgenBase);
		toolsBuild_Flow_libraryAction->setObjectName(QString::fromUtf8("toolsBuild_Flow_libraryAction"));
		toolsBuild_Flow_libraryAction->setName("toolsBuild_Flow_libraryAction");
		toolsBuild_Flow_libraryAction->setEnabled(false);
		toolsBuild_Flow_libraryAction->setIcon(QIcon(":/images/build.xpm"));
		widget = new QWidget(flowgenBase);
		widget->setObjectName(QString::fromUtf8("widget"));
		hboxLayout = new QHBoxLayout(widget);
		hboxLayout->setSpacing(6);
		hboxLayout->setMargin(11);
		hboxLayout->setObjectName(QString::fromUtf8("hboxLayout"));
		hboxLayout->setContentsMargins(0, 0, 0, 0);
		vboxLayout = new QVBoxLayout();
		vboxLayout->setSpacing(6);
		vboxLayout->setObjectName(QString::fromUtf8("vboxLayout"));
		groupBox2 = new QGroupBox(widget);
		groupBox2->setObjectName(QString::fromUtf8("groupBox2"));
		QVBoxLayout *theLayout = new QVBoxLayout;
		groupBox2->setLayout(theLayout);
		//groupBox2->setColumnLayout(0, Qt::Vertical);
		groupBox2->layout()->setSpacing(6);
		groupBox2->layout()->setMargin(11);
		vboxLayout1 = new QVBoxLayout();
		QBoxLayout *boxlayout = qobject_cast<QBoxLayout *>(groupBox2->layout());
		if (boxlayout)
			boxlayout->addLayout(vboxLayout1);
		vboxLayout1->setAlignment(Qt::AlignTop);
		vboxLayout1->setObjectName(QString::fromUtf8("vboxLayout1"));
		gridLayout = new QGridLayout();
		gridLayout->setSpacing(6);
		gridLayout->setObjectName(QString::fromUtf8("gridLayout"));
		flowClassName = new QLineEdit(groupBox2);
		flowClassName->setObjectName(QString::fromUtf8("flowClassName"));
		
		gridLayout->addWidget(flowClassName, 1, 1, 1, 1);
		
		textLabel5 = new QLabel(groupBox2);
		textLabel5->setObjectName(QString::fromUtf8("textLabel5"));
		textLabel5->setWordWrap(false);
		
		gridLayout->addWidget(textLabel5, 1, 0, 1, 1);
		
		textLabel3 = new QLabel(groupBox2);
		textLabel3->setObjectName(QString::fromUtf8("textLabel3"));
		textLabel3->setWordWrap(false);
		
		gridLayout->addWidget(textLabel3, 3, 0, 1, 1);
		
		textLabel2 = new QLabel(groupBox2);
		textLabel2->setObjectName(QString::fromUtf8("textLabel2"));
		textLabel2->setWordWrap(false);
		
		gridLayout->addWidget(textLabel2, 2, 0, 1, 1);
		
		historySize = new QLineEdit(groupBox2);
		historySize->setObjectName(QString::fromUtf8("historySize"));
		
		gridLayout->addWidget(historySize, 3, 1, 1, 1);
		
		bufferSize = new QLineEdit(groupBox2);
		bufferSize->setObjectName(QString::fromUtf8("bufferSize"));
		
		gridLayout->addWidget(bufferSize, 2, 1, 1, 1);
		
		flowDesc = new QLineEdit(groupBox2);
		flowDesc->setObjectName(QString::fromUtf8("flowDesc"));
		
		gridLayout->addWidget(flowDesc, 0, 1, 1, 1);
		
		textLabel1 = new QLabel(groupBox2);
		textLabel1->setObjectName(QString::fromUtf8("textLabel1"));
		textLabel1->setWordWrap(false);
		
		gridLayout->addWidget(textLabel1, 0, 0, 1, 1);
		
		
		vboxLayout1->addLayout(gridLayout);
		
		
		vboxLayout->addWidget(groupBox2);
		
		groupBox1 = new QGroupBox(widget);
		groupBox1->setObjectName(QString::fromUtf8("groupBox1"));
		//groupBox1->setColumnLayout(0, Qt::Vertical);
		QVBoxLayout *theLayout2 = new QVBoxLayout;
		groupBox1->setLayout(theLayout2);
		groupBox1->layout()->setSpacing(6);
		groupBox1->layout()->setMargin(11);
		hboxLayout1 = new QHBoxLayout();
		QBoxLayout *boxlayout1 = qobject_cast<QBoxLayout *>(groupBox1->layout());
		if (boxlayout1)
			boxlayout1->addLayout(hboxLayout1);
		hboxLayout1->setAlignment(Qt::AlignTop);
		hboxLayout1->setObjectName(QString::fromUtf8("hboxLayout1"));
		vboxLayout2 = new QVBoxLayout();
		vboxLayout2->setSpacing(6);
		vboxLayout2->setObjectName(QString::fromUtf8("vboxLayout2"));
		groupBox6 = new QGroupBox(groupBox1);
		groupBox6->setObjectName(QString::fromUtf8("groupBox6"));
		//groupBox6->setMargin(0);
		//groupBox6->setColumnLayout(0, Qt::Vertical);
		QVBoxLayout *theLayout3 = new QVBoxLayout;
		groupBox6->setLayout(theLayout3);
		groupBox6->layout()->setSpacing(6);
		groupBox6->layout()->setMargin(11);
		hboxLayout2 = new QHBoxLayout();
		QBoxLayout *boxlayout2 = qobject_cast<QBoxLayout *>(groupBox6->layout());
		if (boxlayout2)
			boxlayout2->addLayout(hboxLayout2);
		hboxLayout2->setAlignment(Qt::AlignTop);
		hboxLayout2->setObjectName(QString::fromUtf8("hboxLayout2"));
		vboxLayout3 = new QVBoxLayout();
		vboxLayout3->setSpacing(6);
		vboxLayout3->setObjectName(QString::fromUtf8("vboxLayout3"));
		textLabel1_2 = new QLabel(groupBox6);
		textLabel1_2->setObjectName(QString::fromUtf8("textLabel1_2"));
		textLabel1_2->setLineWidth(0);
		textLabel1_2->setWordWrap(false);
		
		vboxLayout3->addWidget(textLabel1_2);
		
		includeTextEdit = new QTextEdit(groupBox6);
		includeTextEdit->setObjectName(QString::fromUtf8("includeTextEdit"));
		
		vboxLayout3->addWidget(includeTextEdit);
		
		
		hboxLayout2->addLayout(vboxLayout3);
		
		
		vboxLayout2->addWidget(groupBox6);
		
		groupBox5 = new QGroupBox(groupBox1);
		groupBox5->setObjectName(QString::fromUtf8("groupBox5"));
		//groupBox5->setColumnLayout(0, Qt::Vertical);
		QVBoxLayout *theLayout4 = new QVBoxLayout;
		groupBox5->setLayout(theLayout4);
		groupBox5->layout()->setSpacing(6);
		groupBox5->layout()->setMargin(11);
		hboxLayout3 = new QHBoxLayout();
		QBoxLayout *boxlayout3 = qobject_cast<QBoxLayout *>(groupBox5->layout());
		if (boxlayout3)
			boxlayout3->addLayout(hboxLayout3);
		hboxLayout3->setAlignment(Qt::AlignTop);
		hboxLayout3->setObjectName(QString::fromUtf8("hboxLayout3"));
		vboxLayout4 = new QVBoxLayout();
		vboxLayout4->setSpacing(6);
		vboxLayout4->setObjectName(QString::fromUtf8("vboxLayout4"));
		textLabel4 = new QLabel(groupBox5);
		textLabel4->setObjectName(QString::fromUtf8("textLabel4"));
		textLabel4->setLineWidth(0);
		textLabel4->setWordWrap(false);
		
		vboxLayout4->addWidget(textLabel4);
		
		methodTextEdit = new QTextEdit(groupBox5);
		methodTextEdit->setObjectName(QString::fromUtf8("methodTextEdit"));
		
		vboxLayout4->addWidget(methodTextEdit);
		
		
		hboxLayout3->addLayout(vboxLayout4);
		
		
		vboxLayout2->addWidget(groupBox5);
		
		
		hboxLayout1->addLayout(vboxLayout2);
		
		
		vboxLayout->addWidget(groupBox1);
		
		
		hboxLayout->addLayout(vboxLayout);
		
		flowgenBase->setCentralWidget(widget);
		toolBar = flowgenBase->addToolBar("MainToolbar");
		Toolbar = flowgenBase->addToolBar("ToolToolBar");
		
		fileMenu = flowgenBase->menuBar()->addMenu("&File");
		Tools = flowgenBase->menuBar()->addMenu("&Tools");
		helpMenu = flowgenBase->menuBar()->addMenu("&Help");
		
		QWidget::setTabOrder(flowDesc, flowClassName);
		QWidget::setTabOrder(flowClassName, bufferSize);
		QWidget::setTabOrder(bufferSize, historySize);
		QWidget::setTabOrder(historySize, includeTextEdit);
		QWidget::setTabOrder(includeTextEdit, methodTextEdit);
		
		toolBar->addAction(fileNewAction);
		toolBar->addAction(fileOpenAction);
		toolBar->addAction(fileSaveAction);
		toolBar->addAction(fileSaveAsAction);
		Toolbar->addAction(toolsGenerate_CodeAction);
		Toolbar->addAction(toolsBuild_Flow_libraryAction);
		
		fileMenu->addAction(fileNewAction);
		fileMenu->addAction(fileOpenAction);
		fileMenu->addSeparator();
		fileMenu->addAction(fileSaveAction);
		fileMenu->addAction(fileSaveAsAction);
		fileMenu->addSeparator();
		fileMenu->addAction(fileExitAction);
		Tools->addAction(toolsGenerate_CodeAction);
		Tools->addAction(toolsBuild_Flow_libraryAction);
		helpMenu->addAction(helpAboutAction);
		
		retranslateUi(flowgenBase);
		QObject::connect(fileNewAction, SIGNAL(triggered()), flowgenBase, SLOT(fileNew()));
		QObject::connect(fileOpenAction, SIGNAL(triggered()), flowgenBase, SLOT(fileOpen()));
		QObject::connect(fileSaveAction, SIGNAL(triggered()), flowgenBase, SLOT(fileSave()));
		QObject::connect(fileSaveAsAction, SIGNAL(triggered()), flowgenBase, SLOT(fileSaveAs()));
		QObject::connect(fileExitAction, SIGNAL(triggered()), flowgenBase, SLOT(fileExit()));
		QObject::connect(toolsBuild_Flow_libraryAction, SIGNAL(triggered()), flowgenBase, SLOT(tools_Build_Flow_Library()));
		QObject::connect(toolsGenerate_CodeAction, SIGNAL(triggered()), flowgenBase, SLOT(tools_Generate_Code()));
		QObject::connect(helpAboutAction, SIGNAL(triggered()), flowgenBase, SLOT(helpAbout()));
		QObject::connect(flowDesc, SIGNAL(textChanged(QString)), flowgenBase, SLOT(checkDesc()));
		QObject::connect(flowClassName, SIGNAL(textChanged(QString)), flowgenBase, SLOT(checkClassName()));
		QObject::connect(historySize, SIGNAL(textChanged(QString)), flowgenBase, SLOT(checkHistorySize()));
		QObject::connect(bufferSize, SIGNAL(textChanged(QString)), flowgenBase, SLOT(checkBufferSize()));
		QObject::connect(includeTextEdit, SIGNAL(textChanged()), flowgenBase, SLOT(checkIncludes()));
		QObject::connect(methodTextEdit, SIGNAL(textChanged()), flowgenBase, SLOT(checkSpecificMethods()));
		
		QMetaObject::connectSlotsByName(flowgenBase);
    } // setupUi
	
    void retranslateUi(QMainWindow *flowgenBase)
    {
		flowgenBase->setWindowTitle(QApplication::translate("flowgenBase", "Flow Generator", 0, QApplication::UnicodeUTF8));
		fileNewAction->setIconText(QApplication::translate("flowgenBase", "New", 0, QApplication::UnicodeUTF8));
		fileNewAction->setText(QApplication::translate("flowgenBase", "&New", 0, QApplication::UnicodeUTF8));
		fileNewAction->setShortcut(QApplication::translate("flowgenBase", "Ctrl+N", 0, QApplication::UnicodeUTF8));
		fileOpenAction->setIconText(QApplication::translate("flowgenBase", "Open", 0, QApplication::UnicodeUTF8));
		fileOpenAction->setText(QApplication::translate("flowgenBase", "&Open...", 0, QApplication::UnicodeUTF8));
		fileOpenAction->setShortcut(QApplication::translate("flowgenBase", "Ctrl+O", 0, QApplication::UnicodeUTF8));
		fileSaveAction->setIconText(QApplication::translate("flowgenBase", "Save", 0, QApplication::UnicodeUTF8));
		fileSaveAction->setText(QApplication::translate("flowgenBase", "&Save", 0, QApplication::UnicodeUTF8));
		fileSaveAction->setShortcut(QApplication::translate("flowgenBase", "Ctrl+S", 0, QApplication::UnicodeUTF8));
		fileSaveAsAction->setIconText(QApplication::translate("flowgenBase", "Save As", 0, QApplication::UnicodeUTF8));
		fileSaveAsAction->setText(QApplication::translate("flowgenBase", "Save &As...", 0, QApplication::UnicodeUTF8));
		fileSaveAsAction->setShortcut(QString());
		fileExitAction->setIconText(QApplication::translate("flowgenBase", "Exit", 0, QApplication::UnicodeUTF8));
		fileExitAction->setText(QApplication::translate("flowgenBase", "E&xit", 0, QApplication::UnicodeUTF8));
		fileExitAction->setShortcut(QApplication::translate("flowgenBase", "Ctrl+Q", 0, QApplication::UnicodeUTF8));
		helpAboutAction->setIconText(QApplication::translate("flowgenBase", "About", 0, QApplication::UnicodeUTF8));
		helpAboutAction->setText(QApplication::translate("flowgenBase", "&About", 0, QApplication::UnicodeUTF8));
		helpAboutAction->setShortcut(QApplication::translate("flowgenBase", "Ctrl+A", 0, QApplication::UnicodeUTF8));
		toolsGenerate_CodeAction->setIconText(QApplication::translate("flowgenBase", "&Generate Code", 0, QApplication::UnicodeUTF8));
		toolsGenerate_CodeAction->setText(QApplication::translate("flowgenBase", "&Generate Code", 0, QApplication::UnicodeUTF8));
		toolsGenerate_CodeAction->setToolTip(QApplication::translate("flowgenBase", "Generate Code", 0, QApplication::UnicodeUTF8));
		toolsGenerate_CodeAction->setShortcut(QApplication::translate("flowgenBase", "Ctrl+G", 0, QApplication::UnicodeUTF8));
		toolsBuild_Flow_libraryAction->setIconText(QApplication::translate("flowgenBase", "&Build Flow library", 0, QApplication::UnicodeUTF8));
		toolsBuild_Flow_libraryAction->setText(QApplication::translate("flowgenBase", "&Build Flow library", 0, QApplication::UnicodeUTF8));
		toolsBuild_Flow_libraryAction->setToolTip(QApplication::translate("flowgenBase", "Build Flow library", 0, QApplication::UnicodeUTF8));
		toolsBuild_Flow_libraryAction->setShortcut(QApplication::translate("flowgenBase", "Ctrl+B", 0, QApplication::UnicodeUTF8));
		groupBox2->setTitle(QString());
		flowClassName->setText(QApplication::translate("flowgenBase", "Flow_", 0, QApplication::UnicodeUTF8));
		textLabel5->setText(QApplication::translate("flowgenBase", "Class name", 0, QApplication::UnicodeUTF8));
		textLabel3->setText(QApplication::translate("flowgenBase", "Default History size", 0, QApplication::UnicodeUTF8));
		textLabel2->setText(QApplication::translate("flowgenBase", "Maximum Buffer size", 0, QApplication::UnicodeUTF8));
		textLabel1->setText(QApplication::translate("flowgenBase", "Flow Description", 0, QApplication::UnicodeUTF8));
		groupBox1->setTitle(QApplication::translate("flowgenBase", "Specific Methods (Optional)", 0, QApplication::UnicodeUTF8));
		groupBox6->setTitle(QString());
		textLabel1_2->setText(QApplication::translate("flowgenBase", "Write below the included file you may need.\n"
													  "One file per line.\n"
													  "Example:   #include \"myfile.h\"", 0, QApplication::UnicodeUTF8));
		groupBox5->setTitle(QString());
		textLabel4->setText(QApplication::translate("flowgenBase", "Write below the prototypes of the methods you want to add to the flow type.\n"
													"One method per line.\n"
													"Example:   void my_method( int n );", 0, QApplication::UnicodeUTF8));
		toolBar->setLabel(QApplication::translate("flowgenBase", "Tools", 0, QApplication::UnicodeUTF8));
		Toolbar->setLabel(QApplication::translate("flowgenBase", "Toolbar", 0, QApplication::UnicodeUTF8));
		fileMenu->setTitle(QApplication::translate("flowgenBase", "&File", 0, QApplication::UnicodeUTF8));
		Tools->setTitle(QApplication::translate("flowgenBase", "&Tools", 0, QApplication::UnicodeUTF8));
		helpMenu->setTitle(QApplication::translate("flowgenBase", "&Help", 0, QApplication::UnicodeUTF8));
    } // retranslateUi
	
};

namespace Ui {
    class flowgenBase: public Ui_flowgenBase {};
} // namespace Ui

class flowgenBase : public QMainWindow, public Ui::flowgenBase
{
    Q_OBJECT
	
public:
    flowgenBase(QWidget* parent = 0, const char* name = 0, Qt::WindowFlags fl = Qt::WType_TopLevel);
    ~flowgenBase();
	
public slots:
	virtual void fileNew();
    virtual void fileOpen();
    virtual void fileSave();
    virtual void fileSaveAs();
    virtual void filePrint();
    virtual void fileExit();
    virtual void tools_Build_Flow_Library();
    virtual void tools_Generate_Code();
    virtual void helpAbout();
    virtual void checkClassName();
    virtual void checkDesc();
    virtual void checkBufferSize();
    virtual void checkHistorySize();
    virtual void checkSpecificMethods();
    virtual void checkIncludes();
	
protected:
	bool classNameOK;
    bool descOK;
    bool bufferSizeOK;
    bool historySizeOK;
    bool needSave;
    QDir currentDir;
	bool hasDir;
    QString flowFileName;
    bool isGenerated;
    FlowTypeModel *model;
	
    virtual void closeEvent( QCloseEvent * e );
	
protected slots:
	virtual void languageChange();
	
};

#endif // FLOWGENBASE_H
