#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include "dialog/ApplicationMonitor.h"
#include "ClientDescriptionGenerator/ClientDescGen.h"
#include "dialog/ConfigurationClientList.h"
#include "dialog/ConfigurationServerList.h"
#include "dialog/LogView.h"
#include "flowGenerator/FlowGen.h"
#include "map/MapView.h"
#include "model/GlobalCC.h"
#include "model/SfControl.h"
#include "model/SfControlThread.h"

#include <QtCore/QVariant>
#include <QtCore/QDir>
#include <QtCore/QStringRef>
#include <QtCore/QSemaphore>

#include <QtGui/QMainWindow>
#include <QtGui/QFileDialog>
#include <QtGui/QToolBar>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QMenu>
#include <QtGui/QMenuBar>
#include <QtGui/QWidget>
#include <QtGui/QApplication>
#include <QtGui/QDockWidget>
#include <QtGui/QStatusBar>
#include <QtGui/QLabel>
#include <QtGui/QMdiArea>
#include <QtGui/QMdiSubWindow>
#include <QtGui/QMessageBox>

class Ui_MainWindow
{
public:
    QAction *fileConfigurationOpenAction;
    QAction *fileConfigurationSaveAction;
    QAction *fileConfigurationSave_AsAction;
    QAction *editClearClientListAction;
    QAction *fileApplicationOpenAction;
    QAction *fileApplicationSaveAction;
    QAction *fileApplicationSave_AsAction;
    QAction *editEraseMapAction;
    QAction *fileSave_AllAction;
    QAction *fileClose_AllAction;
    QAction *fileExitAction;
    QAction *helpAboutAction;
    QAction *ViewShowMapAction;
    QAction *editApplicationDiscoverAction;
	QAction *editAddClientAction;
    QAction *editConfigurationLook_for_ServersAction;
    QAction *applicationStart_ApplicationAction;
    QAction *applicationStop_ApplicationAction;
    QAction *viewApplication_Server_ListAction;
    QAction *viewApplication_Client_ListAction;
    QAction *viewApplication_Flow_ListAction;
	QAction *viewLogsAction;
	QAction *toolsCreate_FlowAction;
    QAction *applicationConnect_to_ServerAction;
    QAction *zoomInAction;
    QAction *zoomOutAction;
    QAction *toolsCreate_Client_DescriptionAction;
    QToolBar *fileConfigToolBar;
    QToolBar *fileAppliToolBar;
    QToolBar *controlAppliToolBar;
    QToolBar *mapToolBar;
	
    QMenu *File;
    QMenu *Edit;
    QMenu *View;
    QMenu *Tools;
    QMenu *Application;
    QMenu *Help;
	
    void setupUi(QMainWindow *MainWindow)
    {
		if (MainWindow->objectName().isEmpty())
			MainWindow->setObjectName(QString::fromUtf8("MainWindow"));
		MainWindow->resize(930, 752);
		
		fileConfigurationOpenAction = new QAction(MainWindow);
		fileConfigurationOpenAction->setIcon(QIcon(":/images/ConfigOpen.xpm"));
		
		fileConfigurationSaveAction = new QAction(MainWindow);
		fileConfigurationSaveAction->setIcon(QIcon(":/images/ConfigSave.xpm"));
		
		fileConfigurationSave_AsAction = new QAction(MainWindow);
		fileConfigurationSave_AsAction->setIcon(QIcon(":/images/ConfigSaveAs.xpm"));
		
		fileApplicationOpenAction = new QAction(MainWindow);
		fileApplicationOpenAction->setIcon(QIcon(":/images/AppliOpen.xpm"));
		
		fileApplicationSaveAction = new QAction(MainWindow);
		fileApplicationSaveAction->setIcon(QIcon(":/images/AppliSave.xpm"));
		
		fileApplicationSave_AsAction = new QAction(MainWindow);
		fileApplicationSave_AsAction->setIcon(QIcon(":/images/AppliSaveAs.xpm"));
		
		fileSave_AllAction = new QAction(MainWindow);
		
		fileClose_AllAction = new QAction(MainWindow);
		
		fileExitAction = new QAction(MainWindow);
		
		helpAboutAction = new QAction(MainWindow);
		
		editEraseMapAction = new QAction(MainWindow);
		
		editClearClientListAction = new QAction(MainWindow);
		
		editApplicationDiscoverAction = new QAction(MainWindow);
		editApplicationDiscoverAction->setEnabled(true);
		
		editApplicationDiscoverAction->setIcon(QIcon(":/images/Discover.xpm"));
		
		editConfigurationLook_for_ServersAction = new QAction(MainWindow);
		
		editAddClientAction = new QAction(MainWindow);
		
		applicationStart_ApplicationAction = new QAction(MainWindow);
		applicationStart_ApplicationAction->setIcon(QIcon(":/images/startAppli.png"));
		
		applicationStop_ApplicationAction = new QAction(MainWindow);
		applicationStop_ApplicationAction->setIcon(QIcon(":/images/stopAppli.png"));
		
		viewApplication_Server_ListAction = new QAction(MainWindow);
		
		viewApplication_Client_ListAction = new QAction(MainWindow);
		
		viewApplication_Flow_ListAction = new QAction(MainWindow);
		
		viewLogsAction = new QAction(MainWindow);
		
		ViewShowMapAction = new QAction(MainWindow);
		ViewShowMapAction->setIcon(QIcon(":/images/EditMap.png"));
		
		toolsCreate_FlowAction = new QAction(MainWindow);
		
		applicationConnect_to_ServerAction = new QAction(MainWindow);
		applicationConnect_to_ServerAction->setIcon(QIcon(":/images/connect.xpm"));
		
		zoomInAction = new QAction(MainWindow);
		zoomInAction->setIcon(QIcon(":/images/MapZoomIn.png"));
		
		zoomOutAction = new QAction(MainWindow);
		zoomOutAction->setIcon(QIcon(":/images/MapZoomOut.png"));
		
		toolsCreate_Client_DescriptionAction = new QAction(MainWindow);
		
		fileConfigToolBar = MainWindow->addToolBar("Config");
		fileAppliToolBar = MainWindow->addToolBar("Application");
		controlAppliToolBar = MainWindow->addToolBar("Control");
		mapToolBar = MainWindow->addToolBar("Map");
		
		File = MainWindow->menuBar()->addMenu("&File");
		Edit =  MainWindow->menuBar()->addMenu("&Edit");
		
		View = MainWindow->menuBar()->addMenu("&View");
		Application = MainWindow->menuBar()->addMenu("Application");
		Tools = MainWindow->menuBar()->addMenu("&Tools");
		Help = MainWindow->menuBar()->addMenu("&Help");
		
		fileConfigToolBar->addAction(fileConfigurationOpenAction);
		fileConfigToolBar->addAction(fileConfigurationSaveAction);
		fileConfigToolBar->addAction(fileConfigurationSave_AsAction);
		
		fileAppliToolBar->addAction(fileApplicationOpenAction);
		fileAppliToolBar->addAction(fileApplicationSaveAction);
		fileAppliToolBar->addAction(fileApplicationSave_AsAction);
		
		controlAppliToolBar->addAction(applicationConnect_to_ServerAction);
		controlAppliToolBar->addAction(editApplicationDiscoverAction);
		controlAppliToolBar->addAction(applicationStart_ApplicationAction);
		controlAppliToolBar->addAction(applicationStop_ApplicationAction);
		
		mapToolBar->addAction(ViewShowMapAction);
		mapToolBar->addAction(zoomInAction);
		mapToolBar->addAction(zoomOutAction);
		
		File->addAction(fileConfigurationOpenAction);
		File->addAction(fileConfigurationSaveAction);
		File->addAction(fileConfigurationSave_AsAction);
		File->addSeparator();
		File->addAction(fileApplicationOpenAction);
		File->addAction(fileApplicationSaveAction);
		File->addAction(fileApplicationSave_AsAction);
		File->addSeparator();
		File->addAction(fileSave_AllAction);
		File->addAction(fileClose_AllAction);
		File->addAction(fileExitAction);
		
		Edit->addAction(editAddClientAction);
		Edit->addSeparator();
		Edit->addAction(editClearClientListAction);
		Edit->addAction(editEraseMapAction);
		
		View->addAction(viewApplication_Server_ListAction);
		View->addAction(viewApplication_Client_ListAction);
		View->addAction(viewApplication_Flow_ListAction);
		View->addSeparator();
		View->addAction(ViewShowMapAction);
		View->addSeparator();
		View->addAction(viewLogsAction);
		View->addSeparator();
		
		Tools->addAction(toolsCreate_FlowAction);
		Tools->addAction(toolsCreate_Client_DescriptionAction);
		
		Application->addAction(applicationConnect_to_ServerAction);
		Application->addSeparator();
		Application->addAction(editApplicationDiscoverAction);
		Application->addAction(applicationStart_ApplicationAction);
		Application->addAction(applicationStop_ApplicationAction);
		
		Help->addAction(helpAboutAction);
		
		retranslateUi(MainWindow);
		QObject::connect(fileExitAction, SIGNAL(triggered()), MainWindow, SLOT(close()));
		QObject::connect(fileConfigurationOpenAction, SIGNAL(triggered()), MainWindow, SLOT(configOpenFile()));
		QObject::connect(fileConfigurationSaveAction, SIGNAL(triggered()), MainWindow, SLOT(configSaveFile()));
		QObject::connect(fileConfigurationSave_AsAction, SIGNAL(triggered()), MainWindow, SLOT(configSaveAsFile()));
		QObject::connect(fileApplicationOpenAction, SIGNAL(triggered()), MainWindow, SLOT(appliOpenFile()));
		QObject::connect(fileApplicationSaveAction, SIGNAL(triggered()), MainWindow, SLOT(appliSaveFile()));
		QObject::connect(fileApplicationSave_AsAction, SIGNAL(triggered()), MainWindow, SLOT(appliSaveAsFile()));
		QObject::connect(fileClose_AllAction, SIGNAL(triggered()), MainWindow, SLOT(closeAll()));
		QObject::connect(fileSave_AllAction, SIGNAL(triggered()), MainWindow, SLOT(saveAll()));
		
		QObject::connect(editAddClientAction, SIGNAL(triggered()), MainWindow, SLOT(addClient()));
		QObject::connect(editClearClientListAction, SIGNAL(triggered()), MainWindow, SLOT(clearClientList()));
		QObject::connect(editEraseMapAction, SIGNAL(triggered()), MainWindow, SLOT(eraseMap()));
		
		
		QObject::connect(helpAboutAction, SIGNAL(triggered()), MainWindow, SLOT(helpAbout()));
		QObject::connect(toolsCreate_FlowAction, SIGNAL(triggered()), MainWindow, SLOT(createFlow()));
		QObject::connect(viewApplication_Server_ListAction, SIGNAL(triggered()), MainWindow, SLOT(viewServerAppList()));
		QObject::connect(viewApplication_Client_ListAction, SIGNAL(triggered()), MainWindow, SLOT(viewClientAppList()));
		QObject::connect(viewApplication_Flow_ListAction, SIGNAL(triggered()), MainWindow, SLOT(viewFlowAppList()));
		QObject::connect(viewLogsAction, SIGNAL(triggered()), MainWindow, SLOT(viewLog()));
		QObject::connect(ViewShowMapAction, SIGNAL(triggered()), MainWindow, SLOT(displayMap()));
		QObject::connect(applicationConnect_to_ServerAction, SIGNAL(triggered()), MainWindow, SLOT(connectToServer()));
		QObject::connect(applicationStart_ApplicationAction, SIGNAL(triggered()), MainWindow, SLOT(startApplication()));
		QObject::connect(applicationStop_ApplicationAction, SIGNAL(triggered()), MainWindow, SLOT(stopApplication()));
		QObject::connect(editApplicationDiscoverAction, SIGNAL(triggered()), MainWindow, SLOT(discoverApplication()));
		QObject::connect(zoomInAction, SIGNAL(triggered()), MainWindow, SLOT(zoomInInMap()));
		QObject::connect(zoomOutAction, SIGNAL(triggered()), MainWindow, SLOT(zoomOutInMap()));
		QObject::connect(toolsCreate_Client_DescriptionAction, SIGNAL(triggered()), MainWindow, SLOT(launchClientDescription()));
		
		QMetaObject::connectSlotsByName(MainWindow);
    } // setupUi
	
    void retranslateUi(QMainWindow *MainWindow)
    {
		MainWindow->setWindowTitle(QApplication::translate("MainWindow", "NDFS Control Center", 0, QApplication::UnicodeUTF8));
		fileConfigurationOpenAction->setIconText(QApplication::translate("MainWindow", "Open Client List...", 0, QApplication::UnicodeUTF8));
		fileConfigurationOpenAction->setText(QApplication::translate("MainWindow", "Open Client List...", 0, QApplication::UnicodeUTF8));
		fileConfigurationOpenAction->setToolTip(QApplication::translate("MainWindow", "Open Client List...", 0, QApplication::UnicodeUTF8));
		fileConfigurationSaveAction->setIconText(QApplication::translate("MainWindow", "Save Client List", 0, QApplication::UnicodeUTF8));
		fileConfigurationSaveAction->setText(QApplication::translate("MainWindow", "Save Client List", 0, QApplication::UnicodeUTF8));
		fileConfigurationSaveAction->setToolTip(QApplication::translate("MainWindow", "Save Client List", 0, QApplication::UnicodeUTF8));
		fileConfigurationSave_AsAction->setIconText(QApplication::translate("MainWindow", "Save Client List As...", 0, QApplication::UnicodeUTF8));
		fileConfigurationSave_AsAction->setText(QApplication::translate("MainWindow", "Save Client List As...", 0, QApplication::UnicodeUTF8));
		fileApplicationOpenAction->setIconText(QApplication::translate("MainWindow", "Open Map...", 0, QApplication::UnicodeUTF8));
		fileApplicationOpenAction->setText(QApplication::translate("MainWindow", "Open Map...", 0, QApplication::UnicodeUTF8));
		fileApplicationOpenAction->setToolTip(QApplication::translate("MainWindow", "Open Map...", 0, QApplication::UnicodeUTF8));
		fileApplicationSaveAction->setIconText(QApplication::translate("MainWindow", "Save Map", 0, QApplication::UnicodeUTF8));
		fileApplicationSaveAction->setText(QApplication::translate("MainWindow", "Save Map", 0, QApplication::UnicodeUTF8));
		fileApplicationSaveAction->setToolTip(QApplication::translate("MainWindow", "Save Map", 0, QApplication::UnicodeUTF8));
		fileApplicationSave_AsAction->setIconText(QApplication::translate("MainWindow", "Save Map As...", 0, QApplication::UnicodeUTF8));
		fileApplicationSave_AsAction->setText(QApplication::translate("MainWindow", "Save Map As...", 0, QApplication::UnicodeUTF8));
		fileSave_AllAction->setIconText(QApplication::translate("MainWindow", "Save All", 0, QApplication::UnicodeUTF8));
		fileSave_AllAction->setText(QApplication::translate("MainWindow", "Sa&ve All", 0, QApplication::UnicodeUTF8));
		fileSave_AllAction->setShortcut(QApplication::translate("MainWindow", "Ctrl+S", 0, QApplication::UnicodeUTF8));
		fileClose_AllAction->setIconText(QApplication::translate("MainWindow", "Close All", 0, QApplication::UnicodeUTF8));
		fileClose_AllAction->setText(QApplication::translate("MainWindow", "&Close All", 0, QApplication::UnicodeUTF8));
		fileExitAction->setIconText(QApplication::translate("MainWindow", "Exit", 0, QApplication::UnicodeUTF8));
		fileExitAction->setText(QApplication::translate("MainWindow", "E&xit", 0, QApplication::UnicodeUTF8));
		fileExitAction->setToolTip(QApplication::translate("MainWindow", "Exit", 0, QApplication::UnicodeUTF8));
		fileExitAction->setShortcut(QApplication::translate("MainWindow", "Ctrl+Q", 0, QApplication::UnicodeUTF8));
		helpAboutAction->setIconText(QApplication::translate("MainWindow", "About...", 0, QApplication::UnicodeUTF8));
		helpAboutAction->setText(QApplication::translate("MainWindow", "&About...", 0, QApplication::UnicodeUTF8));
		editApplicationDiscoverAction->setIconText(QApplication::translate("MainWindow", "Discover Application", 0, QApplication::UnicodeUTF8));
		editApplicationDiscoverAction->setText(QApplication::translate("MainWindow", "&Discover Application", 0, QApplication::UnicodeUTF8));
		editAddClientAction->setText(QApplication::translate("MainWindow", "Add CLient...", 0, QApplication::UnicodeUTF8));
		editConfigurationLook_for_ServersAction->setIconText(QApplication::translate("MainWindow", "Look for Servers...", 0, QApplication::UnicodeUTF8));
		editConfigurationLook_for_ServersAction->setText(QApplication::translate("MainWindow", "&Look for Servers...", 0, QApplication::UnicodeUTF8));
		editEraseMapAction->setIconText(QApplication::translate("MainWindow", "Erase Map", 0, QApplication::UnicodeUTF8));
		editEraseMapAction->setText(QApplication::translate("MainWindow", "Erase Map", 0, QApplication::UnicodeUTF8));
		editClearClientListAction->setIconText(QApplication::translate("MainWindow", "Clear Client List", 0, QApplication::UnicodeUTF8));
		editClearClientListAction->setText(QApplication::translate("MainWindow", "Clear Client List", 0, QApplication::UnicodeUTF8));
		applicationStart_ApplicationAction->setIconText(QApplication::translate("MainWindow", "Start All Clients", 0, QApplication::UnicodeUTF8));
		applicationStart_ApplicationAction->setText(QApplication::translate("MainWindow", "&Start All Clients", 0, QApplication::UnicodeUTF8));
		applicationStop_ApplicationAction->setIconText(QApplication::translate("MainWindow", "Stop All Clients", 0, QApplication::UnicodeUTF8));
		applicationStop_ApplicationAction->setText(QApplication::translate("MainWindow", "S&top All Clients", 0, QApplication::UnicodeUTF8));
		viewApplication_Server_ListAction->setIconText(QApplication::translate("MainWindow", "Application Server List...", 0, QApplication::UnicodeUTF8));
		viewApplication_Server_ListAction->setText(QApplication::translate("MainWindow", "Application &Server List...", 0, QApplication::UnicodeUTF8));
		viewApplication_Client_ListAction->setIconText(QApplication::translate("MainWindow", "Application Client List...", 0, QApplication::UnicodeUTF8));
		viewApplication_Client_ListAction->setText(QApplication::translate("MainWindow", "Application &Client List...", 0, QApplication::UnicodeUTF8));
		viewApplication_Flow_ListAction->setIconText(QApplication::translate("MainWindow", "Application Flow List...", 0, QApplication::UnicodeUTF8));
		viewApplication_Flow_ListAction->setText(QApplication::translate("MainWindow", "Application &Flow List...", 0, QApplication::UnicodeUTF8));
		viewLogsAction->setIconText(QApplication::translate("MainWindow", "Logs...", 0, QApplication::UnicodeUTF8));
		viewLogsAction->setText(QApplication::translate("MainWindow", "&Logs...", 0, QApplication::UnicodeUTF8));
		ViewShowMapAction->setIconText(QApplication::translate("MainWindow", "Show Map", 0, QApplication::UnicodeUTF8));
		ViewShowMapAction->setToolTip(QApplication::translate("MainWindow", "View Map", 0, QApplication::UnicodeUTF8));
		ViewShowMapAction->setText(QApplication::translate("MainWindow", "&Map", 0, QApplication::UnicodeUTF8));
		toolsCreate_FlowAction->setIconText(QApplication::translate("MainWindow", "Create &Flow...", 0, QApplication::UnicodeUTF8));
		toolsCreate_FlowAction->setText(QApplication::translate("MainWindow", "Create &Flow...", 0, QApplication::UnicodeUTF8));
		toolsCreate_FlowAction->setToolTip(QApplication::translate("MainWindow", "Create Flow...", 0, QApplication::UnicodeUTF8));
		applicationConnect_to_ServerAction->setIconText(QApplication::translate("MainWindow", "&Connect to Server", 0, QApplication::UnicodeUTF8));
		applicationConnect_to_ServerAction->setText(QApplication::translate("MainWindow", "&Connect to Server", 0, QApplication::UnicodeUTF8));
		applicationConnect_to_ServerAction->setToolTip(QApplication::translate("MainWindow", "Connect to Server", 0, QApplication::UnicodeUTF8));
		zoomInAction->setIconText(QApplication::translate("MainWindow", "Zoom In", 0, QApplication::UnicodeUTF8));
		zoomOutAction->setIconText(QApplication::translate("MainWindow", "Zoom Out", 0, QApplication::UnicodeUTF8));
		toolsCreate_Client_DescriptionAction->setIconText(QApplication::translate("MainWindow", "Create Client &Description...", 0, QApplication::UnicodeUTF8));
		toolsCreate_Client_DescriptionAction->setText(QApplication::translate("MainWindow", "Create Client &Description...", 0, QApplication::UnicodeUTF8));
		toolsCreate_Client_DescriptionAction->setToolTip(QApplication::translate("MainWindow", "Launch the Client Description Generato", 0, QApplication::UnicodeUTF8));
		toolsCreate_Client_DescriptionAction->setStatusTip(QApplication::translate("MainWindow", "Launch the Client Description Generator", 0, QApplication::UnicodeUTF8));
		fileConfigToolBar->setLabel(QApplication::translate("MainWindow", "Configuration", 0, QApplication::UnicodeUTF8));
		fileAppliToolBar->setLabel(QApplication::translate("MainWindow", "Application", 0, QApplication::UnicodeUTF8));
		controlAppliToolBar->setLabel(QApplication::translate("MainWindow", "Control", 0, QApplication::UnicodeUTF8));
		mapToolBar->setLabel(QApplication::translate("MainWindow", "mapToolBar", 0, QApplication::UnicodeUTF8));
		//File->setTitle(QApplication::translate("MainWindow", "&File", 0, QApplication::UnicodeUTF8));
		//popupMenu->setTitle(QApplication::translate("MainWindow", "C&onfiguration", 0, QApplication::UnicodeUTF8));
		//popupMenu_9->setTitle(QApplication::translate("MainWindow", "&Application", 0, QApplication::UnicodeUTF8));
		//Edit->setTitle(QApplication::translate("MainWindow", "&Edit", 0, QApplication::UnicodeUTF8));
		//View->setTitle(QApplication::translate("MainWindow", "&View", 0, QApplication::UnicodeUTF8));
		//Tools->setTitle(QApplication::translate("MainWindow", "&Tools", 0, QApplication::UnicodeUTF8));
		//Application->setTitle(QApplication::translate("MainWindow", "&Application", 0, QApplication::UnicodeUTF8));
		//Help->setTitle(QApplication::translate("MainWindow", "&Help", 0, QApplication::UnicodeUTF8));
    } // retranslateUi
	
};

namespace Ui {
    class MainWindow: public Ui_MainWindow {};
} // namespace Ui

class MainWindow : public QMainWindow, public Ui::MainWindow
{
    Q_OBJECT
	
public:
    MainWindow(QWidget* parent = 0, const char* name = 0, Qt::WindowFlags fl = Qt::WType_TopLevel);
    ~MainWindow();
	
    ApplicationMonitor *appMon;
    bool appliNeedSave;
    bool configNeedSave;
	QMdiArea *mdiArea;
	QMdiSubWindow *subWindowMap;
    GlobalCC *global;
    LogView *logView;
    QString lastModificationMessage;
	QSemaphore* okToUseSFControl;
	
    virtual void initStatusBar();
    virtual void setupClientList();
    virtual void setupServerList();
    virtual void initVariables();
    virtual void initWorkspace();
    virtual void initSignalSlotConnection();
    static MainWindow * instance();
    virtual void initApplicationMonitor();
    virtual void refreshConfigurationViews();
    virtual void setupLog();
	virtual void setMapName(QString name);
   
	virtual void emitUpdateSignal(QString message);
	
	virtual void emitConnectToServerSignal();
	virtual void emitDisconnectFromServerSignal();
	virtual void emitGetServerListSignal(int res, QString list);
	//virtual void emitStartClientSignal(unsigned int id);
	virtual void emitStartClientSignal(int res, QString mess, ClientApp *client);
	//virtual void emitStopClientSignal(unsigned int id);
	virtual void emitStopClientSignal(int res, ClientApp* client);
	//virtual void emitStartAllClientsSignal();
	//virtual void emitStopAllClientsSignal();
	virtual void emitDiscoverApplicationSignal(QString description);
	
	//virtual void emitPauseFlowSignal(Flow *f, ClientApp *cl);
	//virtual void emitRestartFlowSignal(Flow *f, ClientApp *cl);
		
public slots:
    virtual void configOpenFile();
    virtual void configSaveFile();
    virtual void configSaveAsFile();
    virtual bool clearClientList();
    virtual void appliOpenFile();
    virtual void appliSaveFile();
    virtual void appliSaveAsFile();
    virtual bool eraseMap();
    virtual bool closeAll();
    virtual void saveAll();
    virtual void closeEvent( QCloseEvent *e );
    virtual void displayMap();
    virtual void helpAbout();
    virtual void createFlow();
    virtual void viewServerAppList();
    virtual void viewClientAppList();
    virtual void viewFlowAppList();
    virtual void viewLog();
    virtual void connectToServer();
    virtual void startApplication();
    virtual void stopApplication();
    virtual void discoverApplication();
    virtual void zoomInInMap();
    virtual void zoomOutInMap();
    virtual void launchClientDescription();
    virtual void updateApplicationSlot(QString message);
    virtual void addClient();
	
	virtual void connectToServerSlot();
	virtual void disconnectFromServerSlot();
	virtual void getServerListSlot(int res, QString list);
	//virtual void startClientSlot(unsigned int id);
	virtual void startClientSlot(int res, QString mess, ClientApp *client);
	//virtual void stopClientSlot(unsigned int id);
	virtual void stopClientSlot(int res, ClientApp* client);
	//virtual void startAllClientsSlot();
	//virtual void stopAllClientsSlot();
	virtual void discoverApplicationSlot(QString description);
	
	//virtual void pauseFlowSlot(Flow *f, ClientApp *cl);
	//virtual void restartFlowSlot(Flow *f, ClientApp *cl);
	
signals:
    void updateMessageSignal(QString message);
	
	void connectToServerSignal();
	void disconnectFromServerSignal();
	void getServerListSignal(int res, QString list);
	//void startClientSignal(unsigned int id);
	void startClientSignal(int res, QString mess, ClientApp *client);
	//void stopClientSignal(unsigned int id);
	void stopClientSignal(int res, ClientApp* client);
	//void startAllClientsSignal();
	//void stopAllClientsSignal();
	void discoverApplicationSignal(QString description);
	
	//void pauseFlowSignal(Flow *f, ClientApp *cl);
	//void restartFlowSignal(Flow *f, ClientApp *cl);
	
protected:
    QString appliDir;
    QString configDir;
    ConfigurationServerList *serverList;
    ConfigurationClientList *clientList;
	
protected slots:
    virtual void languageChange();
	
private:
	FlowGen *flowGenerator;
    QString appliFileName;
    QString configFileName;
    MapView *mv;
    static MainWindow *me;
    ClientDescGen *clientDescGenerator;
	
    void init();
    void destroy();
    virtual bool loadConfiguration( QString & file );
    virtual bool loadApplication( QString & file );
    virtual bool saveApplication( QString & filename );
    virtual bool saveConfiguration( QString & filename );
    virtual void closeApplication();
    virtual void closeConfiguration();
    virtual void initModel();
	
};

#endif // MAINWINDOW_H
