//Added by qt3to4:
#include <QtGui/QCloseEvent>
#include <QtGui/QLabel>

#include <iostream>
using namespace std;
/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
MainWindow *MainWindow::me;

void MainWindow::init() {
	me = this;
	initStatusBar();
	initVariables();
	initSignalSlotConnection();
	setupServerList();
	setupClientList();
	setupLog();
	initModel();
	initWorkspace();
	initApplicationMonitor();
		
	flowGenerator = new FlowGen();
	clientDescGenerator = new ClientDescGen();
	//flowGen = new FlowGen_InAThread();
	
	
}

void MainWindow::destroy() {
    delete flowGenerator; 
    delete clientDescGenerator;
    delete appMon;
    delete global;
}
void MainWindow::initStatusBar()
{
	statusBar()->addWidget(new QLabel("", statusBar()), 1);
}

void  MainWindow::initSignalSlotConnection() {
	connect( this, SIGNAL(updateMessageSignal(QString)), this, SLOT(updateApplicationSlot(QString)));
	
	connect( this, SIGNAL(connectToServerSignal()), this, SLOT(connectToServerSlot()));
	connect( this, SIGNAL(disconnectFromServerSignal()), this, SLOT(disconnectFromServerSlot()));
	connect( this, SIGNAL(getServerListSignal(int, QString)), this, SLOT(getServerListSlot(int, QString)));
	//connect( this, SIGNAL(startClientSignal(unsigned int)), this, SLOT(startClientSlot(unsigned int)));
	connect( this, SIGNAL(startClientSignal(int, QString, ClientApp *)), this, SLOT(startClientSlot(int, QString, ClientApp *)));
	//connect( this, SIGNAL(stopClientSignal(unsigned int)), this, SLOT(stopClientSlot(unsigned int)));
	connect( this, SIGNAL(stopClientSignal(int, ClientApp*)), this, SLOT(stopClientSlot(int, ClientApp*)));
	//connect( this, SIGNAL(startAllClientsSignal()), this, SLOT(startAllClientsSlot()));
	//connect( this, SIGNAL(stopAllClientsSignal()), this, SLOT(stopAllClientsSlot()));
	connect( this, SIGNAL(discoverApplicationSignal(QString)), this, SLOT(discoverApplicationSlot(QString)));
	//connect( this, SIGNAL(pauseFlowSignal(Flow *, ClientApp *)), this, SLOT(pauseFlowSlot(Flow *, ClientApp *)));
	//connect( this, SIGNAL(restartFlowSignal(Flow *, ClientApp *)), this, SLOT(restartFlowSlot(Flow *, ClientApp *)));

}

void MainWindow::setupClientList()
{
	QDockWidget *dock = new QDockWidget(tr("Client List"), this);
	dock->setAllowedAreas(Qt::LeftDockWidgetArea | Qt::RightDockWidgetArea);
	
	clientList = new ConfigurationClientList(dock);
	
	dock->setWidget(clientList);
	addDockWidget(Qt::LeftDockWidgetArea, dock);
	View->addAction(dock->toggleViewAction());
	dock->show();
}

void MainWindow::setupServerList()
{
	QDockWidget *dock = new QDockWidget(tr("Server List"), this);
	dock->setAllowedAreas(Qt::LeftDockWidgetArea | Qt::RightDockWidgetArea);
	
	serverList = new ConfigurationServerList(dock);
	
	dock->setWidget(serverList);
	addDockWidget(Qt::LeftDockWidgetArea, dock);
	View->addAction(dock->toggleViewAction());
	dock->show();
}


void MainWindow::configOpenFile()
{
	QFileDialog dialog(this, "Open Client List", "", "Client List files (*.conf);;All (*)");
    if ( configDir != "" )
		dialog.setDirectory( configDir);
    QString filename;
    if ( dialog.exec() == QDialog::Accepted ) {
		int res = QMessageBox::Yes;
		if ( appliNeedSave ) {
			res = QMessageBox::warning(this, tr("Attention"), 
									   tr("If you open a Client List, the current map will be erased.\n"
										  "Do you want to continue?"),
									   QMessageBox::Yes | QMessageBox::Default,
									   QMessageBox::No | QMessageBox::Escape);
		}
		if ( res == QMessageBox::Yes) {
			clearClientList();
			filename = dialog.selectedFile();
			
			configDir = dialog.directory().absolutePath();
			if ( !filename.isEmpty() ) {
				if ( loadConfiguration(filename) ) {
					statusBar()->message(tr("Client List loaded"));
					configFileName = filename;
					configNeedSave = false;
				}
			}
			else {
				statusBar()->message(tr("Failed to load Client List")); 
			}
		}
    }
}


void MainWindow::configSaveFile()
{
	if ( configFileName.isEmpty() )
		configSaveAsFile();
	else {
		if ( saveConfiguration(configFileName) ) {
			statusBar()->message(tr("Client List file %1 saved").arg(QDir::convertSeparators(configFileName)));
			configNeedSave = false;
		}
		else
			statusBar()->message(tr("The Client List cannot be saved"));
	}
}


void MainWindow::configSaveAsFile()
{
	QFileDialog dialog(this, "Save Client List", "", "Client List files (*.conf);;All (*)");
    if ( configDir != "" )
		dialog.setDirectory( configDir );
    dialog.setFileMode( QFileDialog::AnyFile );
	dialog.setAcceptMode ( QFileDialog::AcceptSave );
    QString filename;
    if ( dialog.exec() == QDialog::Accepted ) {
		filename = dialog.selectedFile();
		configDir = dialog.directory().absolutePath();
		if ( !filename.isEmpty() ) {
			QRegExp rxp( "\\.conf", true, false );
			bool nb = filename.contains( rxp );
			if ( nb == false )
				filename = filename.append(".conf");
			if ( saveConfiguration(filename) ) {
				statusBar()->message(tr("Client List file %1 saved").arg(QDir::convertSeparators(filename)));
				configNeedSave = false;
				configFileName = filename;
			}
			else
				statusBar()->message(tr("The Client List cannot be saved"));
		}
    }
}


bool MainWindow::clearClientList()
{
    int res = QMessageBox::No;
    if ( appliNeedSave )
		res = QMessageBox::warning(this, tr("Attention"), 
								   tr("If you erase the client list, the map will be erased.\n"
									  "Do you want to continue?"),
								   QMessageBox::Yes | QMessageBox::Default,
								   QMessageBox::No | QMessageBox::Escape);
	if ( res == QMessageBox::Yes ||  !appliNeedSave ) {
		if ( configNeedSave ) {
			if ( configFileName.isEmpty() ) {
				int ret = QMessageBox::warning(this, tr("Attention"), 
											   tr("The Client List is not saved.\n"
												  "Do you want to save it?"),
											   QMessageBox::Yes | QMessageBox::Default,
											   QMessageBox::No | QMessageBox::Escape,
											   QMessageBox::Cancel);
				if (ret == QMessageBox::Yes)
					configSaveFile();
				else if ( ret == QMessageBox::Cancel )
					return false;
			}
			else {
				int ret = QMessageBox::warning(this, tr("Attention"), 
											   tr("The Client List %1 is not saved.\n"
												  "Do you want to save it?")
											   .arg(QDir::convertSeparators(configFileName)),
											   QMessageBox::Yes | QMessageBox::Default,
											   QMessageBox::No | QMessageBox::Escape,
											   QMessageBox::Cancel);
				if (ret == QMessageBox::Yes)
					configSaveFile();
				else if ( ret == QMessageBox::Cancel )
					return false;
			}
		}
	}
    closeConfiguration();
    closeApplication();
    appliNeedSave = false;
    configNeedSave = false;   
	configFileName = "";
	
    return true;
}


void MainWindow::appliOpenFile()
{  
	QFileDialog dialog(this, "Open Map", "", "Map files (*.app);;All (*)");
    if ( appliDir != "" )
		dialog.setDirectory( appliDir);
	QString filename;
    if ( dialog.exec() == QDialog::Accepted ) {
		eraseMap();
		filename = dialog.selectedFile();
		appliDir = dialog.directory().absolutePath();
		if ( !filename.isEmpty() ) {
			if ( loadApplication(filename) ) {
				statusBar()->message(tr("Map loaded"));
				appliFileName = filename;
				setMapName(QDir::convertSeparators(appliFileName));
				appliNeedSave = false;
			}
		}
		else {
			statusBar()->message(tr("Failed to load Map")); 
		}
    }
}


void MainWindow::appliSaveFile()
{
	if ( appliFileName.isEmpty() )
		appliSaveAsFile();
	else {
		if ( saveApplication(appliFileName) ) {
			statusBar()->message(tr("Map file %1 saved").arg(QDir::convertSeparators(appliFileName)));
			setMapName(QDir::convertSeparators(appliFileName));
			appliNeedSave = false;
		}
		else
			statusBar()->message(tr("The Map cannot be saved"));
	}
}


void MainWindow::appliSaveAsFile()
{
	QFileDialog dialog(this, "Save Map", "", "Map files (*.app);;All (*)");
    if ( appliDir != "" )
		dialog.setDirectory( appliDir );
    dialog.setFileMode( QFileDialog::AnyFile );
	dialog.setAcceptMode ( QFileDialog::AcceptSave );
    QString filename;
    if ( dialog.exec() == QDialog::Accepted ) {
		filename = dialog.selectedFile();
		appliDir = dialog.directory().absolutePath();
		if ( !filename.isEmpty() ) {
			QRegExp rxp( "\\.app", true, false );
			bool nb = filename.contains( rxp );
			if ( nb == false )
				filename = filename.append(".app");
			if ( saveApplication(filename) ) {
				statusBar()->message(tr("Map file %1 saved").arg(QDir::convertSeparators(filename)));
				setMapName(QDir::convertSeparators(filename));
				appliNeedSave = false;
				appliFileName = filename;
			}
			else
				statusBar()->message(tr("The Map cannot be saved"));
		}
    }
}


bool MainWindow::eraseMap()
{
    if ( appliNeedSave ) {
		if ( appliFileName.isEmpty() ) {
			int ret = QMessageBox::warning(this, tr("Attention"), 
										   tr("The Map is not saved.\n"
											  "Do you want to save it?"),
										   QMessageBox::Yes | QMessageBox::Default,
										   QMessageBox::No | QMessageBox::Escape,
										   QMessageBox::Cancel);
			if (ret == QMessageBox::Yes)
				appliSaveFile();
			else if ( ret ==  QMessageBox::Cancel ) {
				return false;
			}
			
		}
		else {
			int ret = QMessageBox::warning(this, tr("Attention"), 
										   tr("The Map File %1 is not saved.\n"
											  "Do you want to save it?")
										   .arg(QDir::convertSeparators(appliFileName)),
										   QMessageBox::Yes | QMessageBox::Default,
										   QMessageBox::No | QMessageBox::Escape,
										   QMessageBox::Cancel);
			if (ret == QMessageBox::Yes)
				appliSaveFile();
			else if ( ret ==  QMessageBox::Cancel )
				return false;
		}
	    
    }
    closeApplication();
    appliNeedSave = false;
	appliFileName = "";
    return true;
}


bool MainWindow::loadConfiguration( QString &file )
{
	bool success =  global->getClientConfList()->readClientListFromXMLFile(file);
	refreshConfigurationViews();
	return success;
}


bool MainWindow::loadApplication( QString &file )
{
    appMon->clearAllView();
    bool success = global->getApplication()->readXmlApplication(file);
    GlobalCC::setInitialGroupId((global->getApplication()->getMaxGroupId())+1);
    refreshConfigurationViews();
    return success;
}


bool MainWindow::saveApplication( QString &filename )
{
    return global->getApplication()->writeXmlApplication(filename);
}


bool MainWindow::saveConfiguration( QString &filename )
{
    return global->getClientConfList()->writeClientListFromXMLFile(filename);
}


void MainWindow::closeApplication()
{
	global->clearApplication();
	mdiArea->removeSubWindow(subWindowMap);
	delete subWindowMap;
	//mdiArea->removeChild(global->getApplication()->getMap());
	//workspace->removeChild(global->getApplication()->getMap());
	//removeChild(global->getApplication()->getMap());
	
	//global->getApplication()->initMap(workspace);
	global->getApplication()->initMap();
	subWindowMap = new QMdiSubWindow;
	
	subWindowMap->setWidget(global->getApplication()->getMap());
	//subWindowMap->setAttribute(Qt::WA_DeleteOnClose);
	mdiArea->addSubWindow(subWindowMap);
	
	
	//add the map in the layout.
	
	//global->getApplication()->initMap(this);
	//setCentralWidget(global->getApplication()->getMap());
	//setCentralWidget(workspace);
	
	
	
	//need to update the views
    appMon->clearAllView();
    logView->removeAllClientTab();
    GlobalCC::setInitialGroupId(0);
    global->getApplication()->getMap()->show();
}


void MainWindow::closeConfiguration()
{
    global->clearClientConfList();
    //need to update the view
    refreshConfigurationViews();
}



bool MainWindow::closeAll()
{
    bool closeTheAppli;
    closeTheAppli = eraseMap();
    if ( closeTheAppli == false ) {
		return closeTheAppli;
	}
    else {
		closeTheAppli = clearClientList();
		return closeTheAppli;
    }
}


void MainWindow::saveAll()
{
	configSaveFile();
	appliSaveFile();
}

void MainWindow::closeEvent( QCloseEvent *e )
{
	if ( closeAll() ) {
		e->accept();
		destroy();
		exit( 0 );
	}
	else {
		e->ignore();
	}
}

void MainWindow::displayMap()
{
	(mdiArea->subWindowList()).first()->show();
	global->getApplication()->getMap()->show();
}


void MainWindow::initVariables()
{
	configDir = "";
    appliDir = "";
    appliNeedSave = configNeedSave = false;
    lastModificationMessage = "";
}

void MainWindow::initWorkspace()
{
	mdiArea = new QMdiArea(this);
	
	global->clearApplication();
	global->getApplication()->initMap();
	
	//workspace = new QWorkspace(this);
	//setCentralWidget(workspace);
	
	subWindowMap = new QMdiSubWindow;
	
	//global->getApplication()->initMap(mdiArea);
	//mdiArea->addSubWindow(global->getApplication()->getMap());
	
	subWindowMap->setWidget(global->getApplication()->getMap());
	//subWindowMap->setAttribute(Qt::WA_DeleteOnClose);
	mdiArea->addSubWindow(subWindowMap);  
	
	//workspace->setScrollBarsEnabled ( true );
	
	//global->getApplication()->initMap(workspace);
	
	//global->getApplication()->initMap(mdiArea);
    
	//global->getApplication()->initMap(this);
	//setCentralWidget(global->getApplication()->getMap());
	
	setCentralWidget(mdiArea);
	mdiArea->tileSubWindows ();//cascadeSubWindows();
		
}


void MainWindow::initModel()
{
    global = new GlobalCC();
	okToUseSFControl = new QSemaphore(0);
    global->createSfControlThread(okToUseSFControl);
    global->createClientConfList();
    global->createServerList();
	okToUseSFControl->acquire();
  	connectToServer();
    global->createApplication();
    refreshConfigurationViews();    
}


MainWindow * MainWindow::instance()
{
    return me;
}


void MainWindow::helpAbout()
{
    QMessageBox::about (this, QMessageBox::tr("About the NDFS Control Center"), QMessageBox::tr("NDFS Control Center.\nSmart Space Group.\nInformation Access Division.\nNIST.") );
}


void MainWindow::createFlow()
{	
    flowGenerator->initAll();
    flowGenerator->show();
	flowGenerator->raise();
}


void MainWindow::initApplicationMonitor()
{
    appMon = new ApplicationMonitor();
}


void MainWindow::viewServerAppList()
{
    appMon->monitorTabWidget->setCurrentPage(0); 
    appMon->show();	
	appMon->raise();
}


void MainWindow::viewClientAppList()
{
    appMon->monitorTabWidget->setCurrentPage(1); 
    appMon->show();
	appMon->raise();
}


void MainWindow::viewFlowAppList()
{
    appMon->monitorTabWidget->setCurrentPage(2); 
    appMon->show();
	appMon->raise();
}




void MainWindow::refreshConfigurationViews()
{
	serverList->refreshServerList();
	clientList->refreshClientConfList();
}


void MainWindow::setupLog()
{
	logView = new LogView(this);
	logView->hide();
}

void MainWindow::setMapName(QString name) {
	QString tmp_name = "NDFS Contol Center (";
	tmp_name += name;
	tmp_name += ")";
	setWindowTitle(QApplication::translate("MainWindow", tmp_name, 0, QApplication::UnicodeUTF8));
}


void MainWindow::viewLog()
{
	logView->show();
	logView->raise();
}


void MainWindow::connectToServer()
{
    //std::cout << "[MainWindow::connectToServer()] " << std::endl;
    SfControlThread *sfct = global->getSfControlThread();
	if ( sfct ) {
		SfControl *sfc = sfct->getSfControl();
		if ( sfc ) {
			if ( sfc->isConnectedToServer() ) {
				//cout << "[MainWindow::connectToServer()] It seems we are already connected" << endl;
				//we are connected, we just have to disable the connection button
				applicationConnect_to_ServerAction->setEnabled(false);
				applicationStop_ApplicationAction->setEnabled(true);
				applicationStart_ApplicationAction->setEnabled(true);
				editApplicationDiscoverAction->setEnabled(true);
				refreshConfigurationViews();
			}
			else {
				//we are not connected, and will try to connect, we erase any previous serverlog if any
				if ( logView )
					logView->removeAllServerTab();
				//we are not connected, first we try to connect
				//we emit the signal
				//cout << "About to emit signal for SFControl" << endl;
				emit sfc->emitConnectToServerSignal();
				//sfc->connectToServer();
				//now we test if it succeed
				/*if ( !sfc->isConnectedToServer() ) {
					//enable the button 
					applicationConnect_to_ServerAction->setEnabled (true);
					applicationStop_ApplicationAction->setEnabled (false);
					applicationStart_ApplicationAction->setEnabled (false);
					editApplicationDiscoverAction->setEnabled(false);
					//display an error messsage
					QMessageBox::warning (this, QMessageBox::tr("Attention"), QMessageBox::tr("The Smartflow server is not present on this computer. It is required to control an application.") );
				}
				else {
					//disable the button
					applicationConnect_to_ServerAction->setEnabled (false);
					applicationStop_ApplicationAction->setEnabled (true);
					applicationStart_ApplicationAction->setEnabled (true);
					editApplicationDiscoverAction->setEnabled(true);
					sfc->getServerList();
					refreshConfigurationViews();
					global->getApplication()->checkIfClientsHaveServerInApplication();
				}*/
			}
		}
	}
}


void MainWindow::startApplication()
{
    if ( global ) {
		SfControl *sfc = global->getSfControlThread()->getSfControl();
		if ( sfc ) {
			if ( !sfc->isConnectedToServer() ) {
				connectToServer();
				return;
			}
			//if ( !sfc->isApplicationStarted() ) {
			//applicationStart_ApplicationAction->setDisabled (true);
			//sfc->startAllClients();
			sfc->emitStartAllClientsSignal();
			//applicationStop_ApplicationAction->setDisabled (false);
			//}
		}
    }	
}


void MainWindow::stopApplication()
{
    if ( global ) {
		SfControlThread *sfct = global->getSfControlThread();
		if ( sfct ) {
			SfControl *sfc = sfct->getSfControl();
			if ( sfc ) {
				//if ( sfc->isApplicationStarted() ) {
				//applicationStop_ApplicationAction->setDisabled (true);
				//sfc->stopAllClients();
				sfc->emitStopAllClientsSignal();
				//applicationStart_ApplicationAction->setDisabled (false);
				//}
			}
		}
    }
}


void MainWindow::discoverApplication()
{
    if ( global ) {
		SfControlThread *sfct = global->getSfControlThread();
		if ( sfct ) {
			SfControl *sfc = sfct->getSfControl();
			if ( sfc ) {
				if ( sfc->isConnectedToServer() ) {
					int ret = QMessageBox::warning(this, tr("Attention"), 
												   tr("The discovery processus will erase the current client list and the application.\n"
													  "Do you want to continue anyway?"),
												   QMessageBox::Yes | QMessageBox::Default,
												   QMessageBox::No | QMessageBox::Escape);
					if ( ret == QMessageBox::Yes) {
							clearClientList();
						//closeApplication();
						appMon->clearAllView();
						//sfc->discoverApplication();
						sfc->emitDiscoverApplicationSignal();
						//GlobalCC::setInitialGroupId((global->getApplication()->getMaxGroupId())+1);
						//refreshConfigurationViews();
					}
				}
				else
					QMessageBox::warning (this, QMessageBox::tr("Attention"), QMessageBox::tr("The Smartflow server is not present on this computer. It is required to discover an application.") );
			}
		}
    }
}


void MainWindow::zoomInInMap()
{
    global->getApplication()->getMap()->zoomIn();
	global->getApplication()->getMap()->adjustSize();
	subWindowMap->adjustSize();
    //double theZoom = global->getApplication()->getMap()->getZoomLevel();
    //QSize size = global->getApplication()->getMap()->canvas()->size();
    //double x = (size.width()*theZoom);
    //double y = (size.height()*theZoom);
    mdiArea->tileSubWindows ();
	
	//original
	//we need an other way to get the map
    //global->getApplication()->getMap()->canvas()->resize(((int) x)+10, ((int)y)+10);
    //((workspace->windowList(QWorkspace::CreationOrder)).first())->resize(((int) x)+10, ((int)y)+10);
}


void MainWindow::zoomOutInMap()
{
    global->getApplication()->getMap()->zoomOut();
	global->getApplication()->getMap()->adjustSize();
	subWindowMap->adjustSize();
	mdiArea->tileSubWindows ();
    //double theZoom = global->getApplication()->getMap()->getZoomLevel();
    //QSize size = global->getApplication()->getMap()->canvas()->size();
    //double x = (size.width()*theZoom);
    //double y = (size.height()*theZoom);
    //global->getApplication()->getMap()->canvas()->resize(((int) x)+10, ((int)y)+10);
    //((workspace->windowList(QWorkspace::CreationOrder)).first())->resize(((int) x)+10, ((int) y)+10);
}


void MainWindow::launchClientDescription()
{
    clientDescGenerator->show();
	clientDescGenerator->raise();
}

void MainWindow::updateApplicationSlot(QString message) {
	ApplicationCC *app = global->getApplication();
	if ( app ) {
		app->parseLastModificationsInApplication(message);
	}
}

void MainWindow::emitUpdateSignal(QString message) {
	emit updateMessageSignal(message);
}

void  MainWindow::addClient() {
	clientList->addClient();
}

void MainWindow::connectToServerSlot() {
	//cout << " MainWindow::connectToServerSlot()" << endl;
	SfControlThread *sfct = global->getSfControlThread();
	if ( sfct ) {
		SfControl *sfc = sfct->getSfControl();
		if ( sfc ) {
			if ( !sfc->isConnectedToServer() ) {
					//enable the button 
					applicationConnect_to_ServerAction->setEnabled (true);
					applicationStop_ApplicationAction->setEnabled (false);
					applicationStart_ApplicationAction->setEnabled (false);
					editApplicationDiscoverAction->setEnabled(false);
					//display an error messsage
					QMessageBox::warning (this, QMessageBox::tr("Attention"), QMessageBox::tr("The Smartflow server is not present on this computer. It is required to control an application.") );
			}
			else {
					//disable the button
					applicationConnect_to_ServerAction->setEnabled (false);
					applicationStop_ApplicationAction->setEnabled (true);
					applicationStart_ApplicationAction->setEnabled (true);
					editApplicationDiscoverAction->setEnabled(true);
					sfc->emitGetServerListSignal();
					//sfc->getServerList();
					//refreshConfigurationViews();
					//global->getApplication()->checkIfClientsHaveServerInApplication();
			}
		}
	}
}

void MainWindow::disconnectFromServerSlot(){
	ApplicationCC* appli_tmp = global->getApplication();
	if ( appli_tmp ) { 
			appli_tmp->updateAfterMainServerDisconnection();
	}	
	SfControlThread *sfct = global->getSfControlThread();
	if ( sfct ) {
		SfControl *sfc = sfct->getSfControl();
		if ( sfc ) {
			if ( !sfc->isConnectedToServer() ) {
				//we are disconnected, we just have to disable the start and stop button and enable the connection button
				applicationConnect_to_ServerAction->setDisabled (false);
				applicationStop_ApplicationAction->setDisabled (true);
				applicationStart_ApplicationAction->setDisabled (true);
				editApplicationDiscoverAction->setDisabled (true);
				refreshConfigurationViews();
			}
		}
	}
}

void MainWindow::getServerListSlot(int res, QString list) {
	if ( res != -1 ) {
		if ( global->hasServerList() ) {
			if ( !global->getServerList()->readServerList(list) )
				cout << "Server List Parse NOT Okay" << endl;
		}
	}
	else {
		cout << "Error getting server list" << endl;
	}
	refreshConfigurationViews();
	global->getApplication()->checkIfClientsHaveServerInApplication();
}

//void MainWindow::startClientSlot(unsigned int id){}

void MainWindow::startClientSlot(int res, QString mess, ClientApp *client){
	if ( res == -1 ) {
		client->setError();
		client->addLogLine(mess);
	}
	else {
		client->setStarting();
		client->addLogLine("Client starting...");
	}
}

//void MainWindow::stopClientSlot(unsigned int id){}

void MainWindow::stopClientSlot(int res, ClientApp* client){
	if ( res == 0 ) {
		client->setError();
		client->addLogLine("Error trying to stop client (client node not present in the first place?).");
	}
}

//void MainWindow::startAllClientsSlot(){
		//should be useless
//}

//void MainWindow::stopAllClientsSlot(){
		//should be useless
//}

void MainWindow::discoverApplicationSlot(QString description){
	if ( !global->getApplication()->readApplicationDescription(description) ) {
			cout << "Error During the discovery process" << endl;
	} 
	refreshConfigurationViews();
}
	
//void MainWindow::pauseFlowSlot(Flow *f, ClientApp *cl){
//		//should be useless
//}

//void MainWindow::restartFlowSlot(Flow *f, ClientApp *cl){
		//should be useless
//}

//Signal emit methods
void MainWindow::emitConnectToServerSignal() {
	emit connectToServerSignal();
}

void MainWindow::emitDisconnectFromServerSignal() {
	emit disconnectFromServerSignal();
}

void MainWindow::emitGetServerListSignal(int res, QString list) {
	emit getServerListSignal(res, list);
}

//void MainWindow::emitStartClientSignal(unsigned int id) {
//	emit startClientSignal(id);
//}

void MainWindow::emitStartClientSignal(int res, QString mess, ClientApp *client) {
	emit startClientSignal(res, mess, client);
}

//void MainWindow::emitStopClientSignal(unsigned int id) {
//	emit stopClientSignal(id);
//}	

void MainWindow::emitStopClientSignal(int res, ClientApp* client) {
	emit stopClientSignal(res, client);
}

//void MainWindow::emitStartAllClientsSignal() {
//	emit startAllClientsSignal();
//}

//void MainWindow::emitStopAllClientsSignal() {
//	emit stopAllClientsSignal();
//}

void MainWindow::emitDiscoverApplicationSignal(QString description) {
	emit discoverApplicationSignal(description);
}

//void MainWindow::emitPauseFlowSignal(Flow *f, ClientApp *cl) {
//	emit pauseFlowSignal(f, cl);
//}

//void MainWindow::emitRestartFlowSignal(Flow *f, ClientApp *cl) {
//	emit restartFlowSignal(f, cl);
//}

