#include "CheckSmartflowModifications.h"
#include "mainwindow.h"

#include <iostream>
using namespace std;

CheckSmartflowModifications::CheckSmartflowModifications(smartflow::Smartflow *_sf, QMutex *m, GlobalCC *g,  SfControl *_sfcontrol) : sf(_sf), mutex(m), global(g), control(_sfcontrol), keepRunnning(true) {}

CheckSmartflowModifications::~CheckSmartflowModifications() {}

void CheckSmartflowModifications::run() {
	bool res = false;
	while ( keepRunnning ) {
		if ( control->isConnectedToServer() ) {
			std::string lastModif;
			mutex->lock();
			res = sf->getLastModifications(lastModif);
			mutex->unlock();
			if ( res ) {
				QString theModif(QString::fromStdString(lastModif));
				MainWindow::instance()->emitUpdateSignal(theModif);
			}
		}
		sleep(1);
	}
}

void CheckSmartflowModifications::stop_work() {
	mutex->lock();
	keepRunnning = false;
	mutex->unlock();
}
