#include "Duplicator.h"
#include "mainwindow.h"

#include <iostream>

using namespace std;

Duplicator::Duplicator(GlobalCC *g, QString _flowID, QString _serverName) : GlobalObject(g), flowID(_flowID), serverName(_serverName) {
	has_log = false;
	name = "";
	name.append(_flowID);
	name.append(" on ");
	name.append(_serverName);
}

Duplicator::Duplicator(GlobalCC *g) : GlobalObject(g) {
	has_log = false;
}

Duplicator::~Duplicator() {}

void Duplicator::setFlowID(QString _flowID) {
	if ( !_flowID.isEmpty() )
		flowID = _flowID;
}

void Duplicator::setServerName(QString _serverName) {
	if ( !_serverName.isEmpty() )
		serverName = _serverName;
}

QString& Duplicator::getFlowID() { return flowID; }

QString& Duplicator::getServerName() { return serverName; }

void Duplicator::print() {
	cout << "Duplicator #" << getId() << endl << "  Name=" << getName().toStdString() << endl << "  flowID=" << getFlowID().toStdString() << endl << "  serverName=" << getServerName().toStdString() << endl;
} 

void Duplicator::addLogLine(QString l) {
  MainWindow::instance()->logView->addLogForDuplicator(getId(),l);
}

void Duplicator::setLog(bool l)
{
	if ( has_log != l ) {
		has_log = l;
		//we need to update the server views.
		
	}
}
