#include "Server.h"
#include "mainwindow.h"

#include <QtCore/QDateTime>
#include <QtGui/QListView>
#include <QtGui/QTreeWidgetItem>

#include <iostream>
using namespace std;

Server::Server(GlobalCC *g, QString _name, QString _address, unsigned int _port, QString _os, QString _comment) : GlobalObject(g, _name), address(_address), port(_port), os(_os), comment(_comment) {
	serverViewItem = 0;
	has_log = false;
}

Server::Server(GlobalCC *g) : GlobalObject(g) {
	serverViewItem = 0;
	has_log = false;
}

Server::~Server() {}

void Server::setComment(QString _comment) {
	if ( !_comment.isEmpty() )
		comment = _comment;
}

void Server::setAddress(QString _address) {
	if ( !_address.isEmpty() )
		address = _address;
}

void Server::setPort(unsigned int _port) {
	port = _port;
}

void Server::setOS(QString _os) {
	if ( !_os.isEmpty() )
		os = _os;
}

QString& Server::getComment() { return comment; }

QString& Server::getAddress() { return address; }

unsigned int Server::getPort() { return port; }

QString& Server::getOS() { return os; }

void Server::initTreeWidgetItem(QTreeWidget *parent) {
	QStringList sl;
	sl << getName() << getOS();
	serverViewItem = new ServerItem(this, parent, sl);
}

ServerItem* Server::getServerViewItem() { return serverViewItem; }

void Server::print() {
	cout << "Server #" << getId() << endl << "  Name=" << getName().toStdString() << endl << "  Address=" << getAddress().toStdString() << endl << "  Port=" << getPort() << endl << "  Comment=" << getComment().toStdString() << " OS=" << getOS().toStdString() << endl;
} 

void Server::addLogLine(QString l) {
	MainWindow::instance()->logView->addLogForServer(getId(),l);
}

void Server::setLog(bool l)
{
	if ( has_log != l ) {
		has_log = l;
		//we need to update the server views.
		
	}
}
