#ifndef _SERVER_H
#define _SERVER_H

#include "GlobalCC.h"
#include "dialog/ConfigurationServerList.h"

#include <QtCore/QString>

class QTreeWidgetItem;
class ServerItem;

class Server : public GlobalObject {
public:
	Server(GlobalCC *g, QString _name, QString _address, unsigned int _port, QString _os, QString _comment = QString::null);
	Server(GlobalCC *g);
	~Server();
	
	void setComment(QString _comment);
	void setAddress(QString _address);
	void setPort(unsigned int _port);
	void setOS(QString _os);
	
	QString& getComment();
	QString& getAddress();
	unsigned int getPort();
	QString& getOS();
	
	void initTreeWidgetItem(QTreeWidget *parent);
	ServerItem* getServerViewItem();
	
	bool hasLog() { return has_log; }
	void addLogLine(QString l);
	void setLog(bool l);
	
	void print();
	
private:
	bool has_log;
	QString address;
	unsigned int port;
	QString os;
	QString comment;
	ServerItem *serverViewItem;
	
};

#endif
