#include "SfControlThread.h"
#include "mainwindow.h"

#include <iostream>
using namespace std;

SfControlThread::SfControlThread(GlobalCC *g, QSemaphore *s) : global(g), sem(s) {
}

SfControlThread::~SfControlThread() {
	if ( control )
		delete control;
	control = NULL;
}

void SfControlThread::initSignalAndSlots() {
	connect( control, SIGNAL(connectToServerSignal()), control, SLOT(connectToServer()));
	connect( control, SIGNAL(disconnectFromServerSignal()), control, SLOT(disconnectFromServer()));
	connect( control, SIGNAL(getServerListSignal()), control, SLOT(getServerList()));
	connect( control, SIGNAL(startClientSignal(unsigned int)), control, SLOT(startClient(unsigned int)));
	connect( control, SIGNAL(startClientSignal(ClientApp*)), control, SLOT(startClient(ClientApp*)));
	connect( control, SIGNAL(stopClientSignal(unsigned int)), control, SLOT(stopClient(unsigned int)));
	connect( control, SIGNAL(stopClientSignal(ClientApp*)), control, SLOT(stopClient(ClientApp*)));
	connect( control, SIGNAL(startAllClientsSignal()), control, SLOT(startAllClients()));
	connect( control, SIGNAL(stopAllClientsSignal()), control, SLOT(stopAllClients()));
	connect( control, SIGNAL(discoverApplicationSignal()), control, SLOT(discoverApplication()));
	connect( control, SIGNAL(pauseFlowSignal(Flow*, ClientApp*)), control, SLOT(pauseFlow(Flow*, ClientApp*)));
	connect( control, SIGNAL(restartFlowSignal(Flow*, ClientApp*)), control, SLOT(restartFlow(Flow*, ClientApp*)));
}


void SfControlThread::doSleep() {
	msleep(100);
}

void SfControlThread::run() {
	//create the SfControl instance here so it belongs to this thread
	//SfControl shouldn't be in global...
	control = new SfControl(global, this);
	//we release the semaphore to notify the main thread the SFControl object can be accessed.
	initSignalAndSlots();
	sem->release();
	//run the event loop of the thread
	QThread::exec();
}

