TEMPLATE	= app
LANGUAGE	= C++

include(../../../sf2.pro.inc)

DESTDIR     = $$SF2/bin/tools
OBJECTS_DIR = $$OBJECTS_DIR/sfcontrolcenter
MOC_DIR     = $$OBJECTS_DIR/moc
UI_DIR      = $$OBJECTS_DIR/ui

CONFIG	+= qt warn_on release
QT += qt3support xml core gui

macx {
	CONFIG  += app_bundle
	QMAKE_DEL_FILE = rm -rf
}

LIBS	+= $$SF2LIB -lsmartflow2

macx {
	QMAKE_CLEAN += $$SF2/bin/tools/sfcontrolcenter.app
}
unix {
	!macx {
		QMAKE_CLEAN += $$SF2/bin/tools/sfcontrolcenter
	}
}

INCLUDEPATH	+= . $$SF2/src/smartflow2 $$SF2/src/include 

RESOURCES = sfcontrolcenter.qrc

HEADERS	+=	ClientDescriptionGenerator/ClientDescGen.h \
			ClientDescriptionGenerator/FlowDescriptionDialog.h \
			ClientDescriptionGenerator/FlowDescriptionDialog.ui.h \
			ClientDescriptionGenerator/MainWindowClientDescGen.h \
			dialog/AddClientTool.h \
			dialog/AddClientToolBase.h \
			dialog/ApplicationMonitor.h \
			dialog/ApplicationMonitorBase.h \
			dialog/ClientAppEditor.h \
			dialog/ClientAppEditorBase.h \
			dialog/ClientEditor.h \
			dialog/ClientEditorBase.h \
			dialog/ClientPathEditor.h \
			dialog/ClientPathEditorBase.h \
			dialog/ConfigurationServerList.h \
			dialog/ConfigurationClientList.h \
			dialog/FlowInformation.h \
			dialog/FlowInformationBase.h \
			dialog/LogTab.h \
			dialog/LogView.h \
			dialog/LogViewBase.h \
			flowGenerator/FlowGen.h \
			flowGenerator/FlowGenBase.h \
			flowGenerator/FlowTypeModel.h \
			flowGenerator/Generate.h \
			mainwindow.h \
			mainwindow.ui.h \
			map/MapView.h \
			map/PathFinding.h \
			model/CheckSmartflowModifications.h \
			model/Client.h \
			model/Duplicator.h \
			model/Flow.h \
			model/GlobalCC.h \
			model/Server.h \
			model/SfControl.h \
			model/SfControlThread.h \
			xmlwriter/xmlwriter.h 


SOURCES	+=	ClientDescriptionGenerator/ClientDescGen.cpp \
			ClientDescriptionGenerator/FlowDescriptionDialog.cpp \
			ClientDescriptionGenerator/MainWindowClientDescGen.cpp \
			dialog/AddClientTool.cpp \
			dialog/AddClientToolBase.cpp \
			dialog/ApplicationMonitor.cpp \
			dialog/ApplicationMonitorBase.cpp \
			dialog/ClientAppEditor.cpp \
			dialog/ClientAppEditorBase.cpp \
			dialog/ClientEditor.cpp \
			dialog/ClientEditorBase.cpp \
			dialog/ClientPathEditor.cpp \
			dialog/ClientPathEditorBase.cpp \
			dialog/ConfigurationServerList.cpp \
			dialog/ConfigurationClientList.cpp \
			dialog/FlowInformation.cpp \
			dialog/FlowInformationBase.cpp \
			dialog/LogTab.cpp \
			dialog/LogView.cpp \
			dialog/LogViewBase.cpp \
			flowGenerator/FlowGen.cpp \
			flowGenerator/FlowGenBase.cpp \
			flowGenerator/FlowTypeModel.cpp \
			flowGenerator/Generate.cpp \
			mainwindow.cpp\
			main.cpp \
			map/MapView.cpp \
			map/PathFinding.cpp \
			model/CheckSmartflowModifications.cpp \
			model/Client.cpp \
			model/Duplicator.cpp \
			model/Flow.cpp \
			model/GlobalCC.cpp \
			model/Server.cpp \
			model/SfControl.cpp \
			model/SfControlThread.cpp \
			xmlwriter/xmlwriter.cpp

